/* panel.c generated by valac 0.56.17, the Vala compiler
 * generated from panel.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2015-2025 Takao Fujwiara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <locale.h>
#include <float.h>
#include <math.h>
#include <libnotify/notify.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <signal.h>
#include <sys/types.h>
#include <config.h>

#define PANEL_PRELOAD_ENGINES_DELAY_TIME ((guint) 30000)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
typedef struct _PanelPrivate PanelPrivate;
typedef enum  {
	PANEL_ICON_TYPE_STATUS_ICON,
	PANEL_ICON_TYPE_INDICATOR
} PanelIconType;

#define PANEL_TYPE_ICON_TYPE (panel_icon_type_get_type ())

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())

#define TYPE_CANDIDATE_PANEL (candidate_panel_get_type ())
#define CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANDIDATE_PANEL, CandidatePanel))
#define CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANDIDATE_PANEL, CandidatePanelClass))
#define IS_CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANDIDATE_PANEL))
#define IS_CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANDIDATE_PANEL))
#define CANDIDATE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANDIDATE_PANEL, CandidatePanelClass))

typedef struct _CandidatePanel CandidatePanel;
typedef struct _CandidatePanelClass CandidatePanelClass;

#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;

#define TYPE_PROPERTY_MANAGER (property_manager_get_type ())
#define PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_MANAGER, PropertyManager))
#define PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_MANAGER, PropertyManagerClass))
#define IS_PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_MANAGER))
#define IS_PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_MANAGER))
#define PROPERTY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_MANAGER, PropertyManagerClass))

typedef struct _PropertyManager PropertyManager;
typedef struct _PropertyManagerClass PropertyManagerClass;

#define TYPE_PROPERTY_PANEL (property_panel_get_type ())
#define PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_PANEL, PropertyPanel))
#define PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_PANEL, PropertyPanelClass))
#define IS_PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_PANEL))
#define IS_PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_PANEL))
#define PROPERTY_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_PANEL, PropertyPanelClass))

typedef struct _PropertyPanel PropertyPanel;
typedef struct _PropertyPanelClass PropertyPanelClass;

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;

#define BINDING_COMMON_TYPE_KEYBINDING (binding_common_keybinding_get_type ())
#define BINDING_COMMON_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybinding))
#define BINDING_COMMON_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))
#define BINDING_COMMON_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))

typedef struct _BindingCommonKeybinding BindingCommonKeybinding;
typedef struct _BindingCommonKeybindingClass BindingCommonKeybindingClass;
enum  {
	PANEL_0_PROPERTY,
	PANEL_NUM_PROPERTIES
};
static GParamSpec* panel_properties[PANEL_NUM_PROPERTIES];
typedef enum  {
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_EMOJI_TYPING
} BindingCommonKeyEventFuncType;

#define BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE (binding_common_key_event_func_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _property_manager_unref0(var) ((var == NULL) ? NULL : (var = (property_manager_unref (var), NULL)))
#define _xkb_layout_unref0(var) ((var == NULL) ? NULL : (var = (xkb_layout_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef struct _Block11Data Block11Data;

#define TYPE_KEYBINDING_MANAGER (keybinding_manager_get_type ())
#define KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManager))
#define KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))
#define IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYBINDING_MANAGER))
#define IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYBINDING_MANAGER))
#define KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))

typedef struct _KeybindingManager KeybindingManager;
typedef struct _KeybindingManagerClass KeybindingManagerClass;
typedef void (*KeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block14Data Block14Data;
typedef struct _Block15Data Block15Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
enum  {
	PANEL_REALIZE_SURFACE_SIGNAL,
	PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL,
	PANEL_NUM_SIGNALS
};
static guint panel_signals[PANEL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Panel {
	IBusPanelService parent_instance;
	PanelPrivate * priv;
};

struct _PanelClass {
	IBusPanelServiceClass parent_class;
};

struct _PanelPrivate {
	IBusBus* m_bus;
	GSettings* m_settings_general;
	GSettings* m_settings_hotkey;
	GSettings* m_settings_panel;
	PanelIconType m_icon_type;
	Indicator* m_indicator;
	IndicatorStatus m_indicator_show_status;
	GtkStatusIcon* m_status_icon;
	GtkMenu* m_ime_menu;
	GtkMenu* m_sys_menu;
	IBusEngineDesc** m_engines;
	gint m_engines_length1;
	gint _m_engines_size_;
	GHashTable* m_engine_contexts;
	gchar* m_current_context_path;
	gchar* m_real_current_context_path;
	gboolean m_use_global_engine;
	gboolean m_use_engine_lang;
	CandidatePanel* m_candidate_panel;
	CandidatePanel* m_candidate_panel_active;
	Switcher* m_switcher;
	Switcher* m_switcher_active;
	CandidatePanel* m_candidate_panel_x11;
	Switcher* m_switcher_x11;
	guint m_switcher_focus_set_engine_id;
	gint m_switcher_selected_index;
	PropertyManager* m_property_manager;
	PropertyPanel* m_property_panel;
	GPid m_setup_pid;
	GtkAboutDialog* m_about_dialog;
	GtkCssProvider* m_css_provider;
	gint m_switcher_delay_time;
	gboolean m_use_system_keyboard_layout;
	GHashTable* m_xkb_icon_pixbufs;
	GHashTable* m_xkb_icon_image;
	GdkRGBA m_xkb_icon_rgba;
	XKBLayout* m_xkblayout;
	gboolean inited_engines_order;
	guint m_preload_engines_id;
	gchar* m_icon_prop_key;
	gint m_property_icon_delay_time;
	guint m_property_icon_delay_time_id;
	guint m_menu_update_delay_time;
	guint m_menu_update_delay_time_id;
	gboolean m_is_wayland;
	gboolean m_is_wayland_im;
	gboolean m_is_indicator;
	gboolean m_is_context_menu;
	gulong m_popup_menu_id;
	gulong m_activate_id;
	gulong m_registered_status_notifier_item_id;
	FILE* m_log;
	gboolean m_verbose;
	GList* m_keybindings;
	gchar* m_wayland_object_path;
};

struct _Block10Data {
	int _ref_count_;
	Panel* self;
	Switcher* switcher;
	gboolean no_wayland_panel;
};

struct _Block11Data {
	int _ref_count_;
	Panel* self;
	GdkRectangle area;
	GdkWindow* window;
	GtkMenuPositionFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block12Data {
	int _ref_count_;
	Panel* self;
	gchar** names;
	gint names_length1;
	gint _names_size_;
};

struct _Block13Data {
	int _ref_count_;
	Panel* self;
	GtkMessageDialog* dialog;
};

struct _Block14Data {
	int _ref_count_;
	Panel* self;
	IBusEngineDesc* e;
};

struct _Block15Data {
	int _ref_count_;
	Panel* self;
	gchar* symbol;
};

static gint Panel_private_offset;
static gpointer panel_parent_class = NULL;

VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
static GType panel_icon_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType candidate_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CandidatePanel, g_object_unref)
VALA_EXTERN GType switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Switcher, g_object_unref)
VALA_EXTERN gpointer property_manager_ref (gpointer instance);
VALA_EXTERN void property_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_property_manager (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_property_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_property_manager (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_property_manager (const GValue* value);
VALA_EXTERN GType property_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyManager, property_manager_unref)
VALA_EXTERN GType property_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyPanel, g_object_unref)
VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN GType binding_common_keybinding_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BindingCommonKeybinding, g_object_unref)
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
VALA_EXTERN GType binding_common_key_event_func_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void binding_common_unbind_switch_shortcut (BindingCommonKeyEventFuncType ftype,
                                            GList* keybindings);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _g_free0_ (gpointer var);
static void _cairo_surface_destroy0_ (gpointer var);
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
VALA_EXTERN Panel* panel_new (IBusBus* bus,
                  gboolean is_wayland_im);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus,
                        gboolean is_wayland_im);
VALA_EXTERN gboolean binding_common_default_is_xdisplay (void);
static void panel_init_settings (Panel* self);
static void panel_set_version (Panel* self);
static void panel_check_wayland (Panel* self);
static gboolean panel_is_indicator (Panel* self);
VALA_EXTERN PropertyManager* property_manager_new (void);
VALA_EXTERN PropertyManager* property_manager_construct (GType object_type);
static void __lambda90_ (Panel* self,
                  PropertyManager* w,
                  const gchar* k,
                  gint s);
static void ___lambda90__property_manager_property_activate (PropertyManager* _sender,
                                                      const gchar* key,
                                                      gint state,
                                                      gpointer self);
static void panel_init_indicator (Panel* self);
static void panel_init_status_icon (Panel* self);
static CandidatePanel* panel_candidate_panel_new (Panel* self,
                                           gboolean no_wayland_panel);
static Switcher* panel_switcher_new (Panel* self,
                              gboolean no_wayland_panel);
static void panel_bind_switch_shortcut (Panel* self);
VALA_EXTERN PropertyPanel* property_panel_new (void);
VALA_EXTERN PropertyPanel* property_panel_construct (GType object_type);
static void __lambda111_ (Panel* self,
                   PropertyPanel* w,
                   const gchar* k,
                   gint s);
static void ___lambda111__property_panel_property_activate (PropertyPanel* _sender,
                                                     const gchar* key,
                                                     gint state,
                                                     gpointer self);
VALA_EXTERN CandidatePanel* candidate_panel_new (gboolean no_wayland_panel);
VALA_EXTERN CandidatePanel* candidate_panel_construct (GType object_type,
                                           gboolean no_wayland_panel);
static void __lambda102_ (Panel* self,
                   CandidatePanel* w);
static void ___lambda102__candidate_panel_page_up (CandidatePanel* _sender,
                                            gpointer self);
static void __lambda103_ (Panel* self,
                   CandidatePanel* w);
static void ___lambda103__candidate_panel_page_down (CandidatePanel* _sender,
                                              gpointer self);
static void __lambda104_ (Panel* self,
                   CandidatePanel* w);
static void ___lambda104__candidate_panel_cursor_up (CandidatePanel* _sender,
                                              gpointer self);
static void __lambda105_ (Panel* self,
                   CandidatePanel* w);
static void ___lambda105__candidate_panel_cursor_down (CandidatePanel* _sender,
                                                gpointer self);
static void __lambda106_ (Panel* self,
                   CandidatePanel* w,
                   guint i,
                   guint b,
                   guint s);
static void ___lambda106__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                      guint index,
                                                      guint button,
                                                      guint state,
                                                      gpointer self);
static void __lambda107_ (Panel* self,
                   CandidatePanel* w,
                   guint v,
                   guint c,
                   guint m);
static void ___lambda107__candidate_panel_forward_process_key_event (CandidatePanel* _sender,
                                                              guint keyval,
                                                              guint keycode,
                                                              guint modifiers,
                                                              gpointer self);
static void __lambda108_ (Panel* self,
                   CandidatePanel* w,
                   void* s);
static void ___lambda108__candidate_panel_realize_surface (CandidatePanel* _sender,
                                                    void* surface,
                                                    gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN Switcher* switcher_new (gboolean no_wayland_panel);
VALA_EXTERN Switcher* switcher_construct (GType object_type,
                              gboolean no_wayland_panel);
static void __lambda109_ (Panel* self,
                   Switcher* w,
                   void* s);
static void ___lambda109__switcher_realize_surface (Switcher* _sender,
                                             void* surface,
                                             gpointer self);
static void __lambda110_ (Block10Data* _data10_,
                   GtkWidget* w);
VALA_EXTERN IBusEngineDesc* switcher_get_selected_engine (Switcher* self);
static void panel_set_engine (Panel* self,
                       IBusEngineDesc* engine);
VALA_EXTERN void switcher_reset (Switcher* self);
static void ___lambda110__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
VALA_EXTERN void switcher_set_popup_delay_time (Switcher* self,
                                    guint popup_delay_time);
static CandidatePanel* panel_get_active_candidate_panel (Panel* self);
static void panel_set_use_glyph_from_engine_lang (Panel* self);
VALA_EXTERN void candidate_panel_set_vertical (CandidatePanel* self,
                                   gboolean vertical);
static Switcher* panel_get_active_switcher (Panel* self);
static void __lambda66_ (Panel* self,
                  const gchar* key);
static void panel_update_engines (Panel* self,
                           gchar** unowned_engine_names,
                           gint unowned_engine_names_length1,
                           gchar** order_names,
                           gint order_names_length1);
static void ___lambda66__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda69_ (Panel* self,
                  const gchar* key);
static void panel_set_switcher_delay_time (Panel* self);
static void ___lambda69__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda70_ (Panel* self,
                  const gchar* key);
static void panel_set_use_system_keyboard_layout (Panel* self);
static void ___lambda70__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda71_ (Panel* self,
                  const gchar* key);
static void panel_set_embed_preedit_text (Panel* self);
static void ___lambda71__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda72_ (Panel* self,
                  const gchar* key);
static void panel_set_use_global_engine (Panel* self);
static void ___lambda72__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda73_ (Panel* self,
                  const gchar* key);
static void panel_set_use_xmodmap (Panel* self);
static void ___lambda73__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda74_ (Panel* self,
                  const gchar* key);
static void ___lambda74__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda76_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_font (GSettings* settings_panel,
                                     GSettings* settings_emoji,
                                     GtkCssProvider** css_provider);
static void ___lambda76__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda77_ (Panel* self,
                  const gchar* key);
static void ___lambda77__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda78_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_theme (GSettings* settings_panel);
static void ___lambda78__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda79_ (Panel* self,
                  const gchar* key);
static void ___lambda79__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda80_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_icon (GSettings* settings_panel);
static void ___lambda80__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda81_ (Panel* self,
                  const gchar* key);
static void ___lambda81__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda82_ (Panel* self,
                  const gchar* key);
static void ___lambda82__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda83_ (Panel* self,
                  const gchar* key);
static void panel_set_show_icon_on_systray (Panel* self,
                                     gboolean update_now);
static void ___lambda83__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda84_ (Panel* self,
                  const gchar* key);
static void panel_set_lookup_table_orientation (Panel* self);
static void ___lambda84__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda85_ (Panel* self,
                  const gchar* key);
static void panel_set_show_property_panel (Panel* self);
static void ___lambda85__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda86_ (Panel* self,
                  const gchar* key);
static void panel_set_timeout_property_panel (Panel* self);
static void ___lambda86__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda87_ (Panel* self,
                  const gchar* key);
static void panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self);
static void ___lambda87__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda88_ (Panel* self,
                  const gchar* key);
static void panel_set_xkb_icon_rgba (Panel* self);
static void ___lambda88__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda89_ (Panel* self,
                  const gchar* key);
static void panel_set_property_icon_delay_time (Panel* self);
static void ___lambda89__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void panel_popup_menu_at_area_window (Panel* self,
                                      GtkMenu* menu,
                                      GdkRectangle* area,
                                      GdkWindow* window,
                                      GtkMenuPositionFunc func,
                                      gpointer func_target);
static gboolean panel_is_gnome (void);
static void panel_popup_menu_at_pointer_window (Panel* self,
                                         GtkMenu* menu,
                                         gint x,
                                         gint y,
                                         GdkWindow* window,
                                         GtkMenuPositionFunc func,
                                         gpointer func_target);
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
static void __lambda91_ (Panel* self);
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
static void ___lambda91__indicator_registered_status_notifier_item (Indicator* _sender,
                                                             gpointer self);
static void __lambda92_ (Panel* self);
VALA_EXTERN void indicator_set_menu (Indicator* self,
                         GtkMenu* menu);
static GtkMenu* panel_create_context_menu (Panel* self,
                                    gboolean use_x11);
static GtkMenu* panel_create_activate_menu (Panel* self,
                                     gboolean use_x11);
static void ___lambda92__indicator_secondary_activate (Indicator* _sender,
                                                gpointer self);
static void panel_init_status_icon_menu (Panel* self);
static void _panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GdkX11Display* binding_common_get_xdisplay (gboolean check_only);
static void __lambda100_ (Block11Data* _data11_,
                   guint b,
                   guint t);
static void ___lambda100__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                               guint button,
                                               guint activate_time,
                                               gpointer self);
static void __lambda101_ (Block11Data* _data11_);
static void ___lambda101__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                             gpointer self);
VALA_EXTERN GType keybinding_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManager, g_object_unref)
VALA_EXTERN KeybindingManager* keybinding_manager_get_instance (gboolean is_wayland_im);
VALA_EXTERN void binding_common_keybinding_manager_bind (KeybindingManager* keybinding_manager,
                                             GList** keybindings,
                                             const gchar* accelerator,
                                             BindingCommonKeyEventFuncType ftype,
                                             KeybindingManagerKeybindingHandlerFunc handler_normal,
                                             gpointer handler_normal_target,
                                             KeybindingManagerKeybindingHandlerFunc handler_reverse,
                                             gpointer handler_reverse_target);
static void panel_handle_engine_switch_normal (Panel* self,
                                        GdkEvent* event);
static void _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                    gpointer self);
static void panel_handle_engine_switch_reverse (Panel* self,
                                         GdkEvent* event);
static void _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                     gpointer self);
VALA_EXTERN gboolean binding_common_keybinding_get_reverse (BindingCommonKeybinding* self);
VALA_EXTERN guint binding_common_keybinding_get_keysym (BindingCommonKeybinding* self);
VALA_EXTERN GdkModifierType binding_common_keybinding_get_modifiers (BindingCommonKeybinding* self);
static void _vala_array_add18 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static void _vala_array_add19 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static GList* panel_get_engines_from_xkb (Panel* self,
                                   GList* engines);
VALA_EXTERN void xkb_layout_get_layout (XKBLayout* self,
                            gchar** layout,
                            gchar** variant,
                            gchar** option);
static GList* panel_get_engines_from_locale (Panel* self,
                                      GList* engines);
static gint __lambda112_ (IBusEngineDesc* a,
                   IBusEngineDesc* b);
static gint ___lambda112__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void panel_init_engines_order (Panel* self);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
static void panel_set_language_from_engine (Panel* self,
                                     IBusEngineDesc* engine);
VALA_EXTERN void property_panel_set_show (PropertyPanel* self,
                              gint _show);
VALA_EXTERN void property_panel_set_auto_hide_timeout (PropertyPanel* self,
                                           guint timeout);
VALA_EXTERN void property_panel_set_follow_input_cursor_when_always_shown (PropertyPanel* self,
                                                               gboolean is_follow);
static gint panel_compare_versions (Panel* self,
                             const gchar* version1,
                             const gchar* version2);
static void panel_update_version_1_5_8 (Panel* self);
static void panel_save_log (Panel* self,
                     const gchar* format);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
VALA_EXTERN void panel_set_global_shortcut_key_state (Panel* self,
                                          IBusBusGlobalBindingType type,
                                          guint keyval,
                                          guint keycode,
                                          guint state,
                                          gboolean is_backward);
static void panel_handle_engine_switch_focused (Panel* self,
                                         guint keyval,
                                         guint keycode,
                                         guint state,
                                         gboolean reverse);
VALA_EXTERN void panel_set_log (Panel* self,
                    FILE* log,
                    gboolean verbose);
static void panel_engine_contexts_insert (Panel* self,
                                   IBusEngineDesc* engine);
VALA_EXTERN void candidate_panel_set_language (CandidatePanel* self,
                                   PangoAttribute* language_attribute);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static void panel_switch_engine (Panel* self,
                          gint i,
                          gboolean force);
static void panel_handle_engine_switch (Panel* self,
                                 GdkEvent* event,
                                 gboolean reverse);
VALA_EXTERN GdkModifierType keybinding_manager_get_primary_modifier (guint binding_mask);
VALA_EXTERN gboolean keybinding_manager_primary_modifier_still_pressed (GdkEvent* event,
                                                            guint primary_modifier);
VALA_EXTERN gint switcher_run (Switcher* self,
                   guint keyval,
                   guint state,
                   GdkEvent* event,
                   IBusEngineDesc** engines,
                   gint engines_length1,
                   gint index,
                   const gchar* input_context_path);
static void panel_switcher_focus_set_engine (Panel* self);
VALA_EXTERN gint switcher_run_popup (Switcher* self,
                         guint keyval,
                         guint state,
                         IBusEngineDesc** engines,
                         gint engines_length1,
                         gint index);
static void panel_handle_engine_switch_release (Panel* self,
                                         gboolean is_timeout);
static void panel_run_preload_engines (Panel* self,
                                IBusEngineDesc** engines,
                                gint engines_length1,
                                gint index);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean __lambda68_ (Block12Data* _data12_);
static gboolean ___lambda68__gsource_func (gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void ___lambda67_ (Block13Data* _data13_,
                   gint id);
static void ____lambda67__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static IBusEngineDesc** _vala_array_dup3 (IBusEngineDesc** self,
                                   gssize length);
static IBusEngineDesc** _vala_array_dup4 (IBusEngineDesc** self,
                                   gssize length);
static void panel_context_render_string (Panel* self,
                                  cairo_t* cr,
                                  const gchar* symbol,
                                  gint image_width,
                                  gint image_height);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static cairo_surface_t* panel_create_cairo_image_surface_with_string (Panel* self,
                                                               const gchar* symbol,
                                                               gboolean cache);
static GdkPixbuf* panel_create_icon_pixbuf_with_string (Panel* self,
                                                 const gchar* symbol);
static void panel_show_setup_dialog (Panel* self);
static void __lambda94_ (Panel* self,
                  GPid pid,
                  gint state);
static void ___lambda94__gchild_watch_func (GPid pid,
                                     gint wait_status,
                                     gpointer self);
static void panel_show_about_dialog (Panel* self);
static void panel_run_ibus_command (Panel* self,
                             const gchar* args);
static void _vala_array_add25 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add26 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add27 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void panel_append_preferences_menu (Panel* self,
                                    GtkMenu* menu);
static void __lambda93_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void panel_append_emoji_menu (Panel* self,
                              GtkMenu* menu);
static void __lambda95_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda95__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda96_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda96__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda97_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda97__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda98_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda98__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
VALA_EXTERN gint property_manager_create_menu_items (PropertyManager* self,
                                         GtkMenu* menu);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void ____lambda99_ (Block14Data* _data14_,
                    GtkMenuItem* item);
static void _____lambda99__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void panel_set_properties (Panel* self,
                           IBusPropList* props);
static void panel_set_property (Panel* self,
                         IBusProperty* prop,
                         gboolean all_update);
static void panel_animate_icon (Panel* self,
                         const gchar* symbol,
                         gboolean all_update);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static gboolean __lambda113_ (Block15Data* _data15_);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
static gboolean ___lambda113__gsource_func (gpointer self);
static void panel_real_set_cursor_location (IBusPanelService* base,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height);
VALA_EXTERN void candidate_panel_set_cursor_location (CandidatePanel* self,
                                          gint x,
                                          gint y,
                                          gint width,
                                          gint height);
VALA_EXTERN void property_panel_set_cursor_location (PropertyPanel* self,
                                         gint x,
                                         gint y,
                                         gint width,
                                         gint height);
static gboolean panel_switcher_focus_set_engine_real (Panel* self);
VALA_EXTERN gchar* switcher_get_input_context_path (Switcher* self);
VALA_EXTERN gboolean switcher_is_running (Switcher* self);
static gboolean ___lambda75_ (Panel* self);
static gboolean ____lambda75__gsource_func (gpointer self);
static void panel_real_focus_in (IBusPanelService* base,
                          const gchar* input_context_path);
VALA_EXTERN void property_panel_focus_in (PropertyPanel* self);
static void panel_real_focus_out (IBusPanelService* base,
                           const gchar* input_context_path);
static void panel_real_destroy_context (IBusPanelService* base,
                                 const gchar* input_context_path);
static void panel_real_register_properties (IBusPanelService* base,
                                     IBusPropList* props);
VALA_EXTERN void property_manager_set_properties (PropertyManager* self,
                                      IBusPropList* props);
VALA_EXTERN void property_panel_set_properties (PropertyPanel* self,
                                    IBusPropList* props);
static gboolean __lambda114_ (Panel* self);
static gboolean ___lambda114__gsource_func (gpointer self);
static void panel_real_update_property (IBusPanelService* base,
                                 IBusProperty* prop);
VALA_EXTERN void property_manager_update_property (PropertyManager* self,
                                       IBusProperty* prop);
VALA_EXTERN void property_panel_update_property (PropertyPanel* self,
                                     IBusProperty* prop);
static void panel_real_update_preedit_text (IBusPanelService* base,
                                     IBusText* text,
                                     guint cursor_pos,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_preedit_text (CandidatePanel* self,
                                       IBusText* text,
                                       guint cursor);
VALA_EXTERN void property_panel_set_preedit_text (PropertyPanel* self,
                                      IBusText* text,
                                      guint cursor);
static void panel_real_hide_preedit_text (IBusPanelService* base);
static void panel_real_update_auxiliary_text (IBusPanelService* base,
                                       IBusText* text,
                                       gboolean visible);
VALA_EXTERN void candidate_panel_set_auxiliary_text (CandidatePanel* self,
                                         IBusText* text);
VALA_EXTERN void property_panel_set_auxiliary_text (PropertyPanel* self,
                                        IBusText* text);
static void panel_real_hide_auxiliary_text (IBusPanelService* base);
static void panel_real_update_lookup_table (IBusPanelService* base,
                                     IBusLookupTable* table,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_lookup_table (CandidatePanel* self,
                                       IBusLookupTable* table);
VALA_EXTERN void property_panel_set_lookup_table (PropertyPanel* self,
                                      IBusLookupTable* table);
static void panel_real_hide_lookup_table (IBusPanelService* base);
static void panel_real_set_content_type (IBusPanelService* base,
                                  guint purpose,
                                  guint hints);
VALA_EXTERN void candidate_panel_set_content_type (CandidatePanel* self,
                                       guint purpose,
                                       guint hints);
static void panel_real_state_changed (IBusPanelService* base);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN gchar* switcher_get_xkb_language (Switcher* self,
                                  IBusEngineDesc* engine);
static void _vala_array_add28 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void panel_set_wayland_object_path (Panel* self,
                                    const gchar* object_path);
static void g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static void panel_finalize (GObject * obj);
static GType panel_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
panel_get_instance_private (Panel* self)
{
	return G_STRUCT_MEMBER_P (self, Panel_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 172 "panel.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1029 "panel.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 172 "panel.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1037 "panel.c"
}

static GType
panel_icon_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PANEL_ICON_TYPE_STATUS_ICON, "PANEL_ICON_TYPE_STATUS_ICON", "status-icon"}, {PANEL_ICON_TYPE_INDICATOR, "PANEL_ICON_TYPE_INDICATOR", "indicator"}, {0, NULL, NULL}};
	GType panel_icon_type_type_id;
	panel_icon_type_type_id = g_enum_register_static ("PanelIconType", values);
	return panel_icon_type_type_id;
}

static GType
panel_icon_type_get_type (void)
{
	static volatile gsize panel_icon_type_type_id__once = 0;
	if (g_once_init_enter (&panel_icon_type_type_id__once)) {
		GType panel_icon_type_type_id;
		panel_icon_type_type_id = panel_icon_type_get_type_once ();
		g_once_init_leave (&panel_icon_type_type_id__once, panel_icon_type_type_id);
	}
	return panel_icon_type_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 44 "panel.vala"
	var = (g_free (var), NULL);
#line 1066 "panel.c"
}

static void
_cairo_surface_destroy0_ (gpointer var)
{
#line 71 "panel.vala"
	(var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL));
#line 1074 "panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 115 "panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 1082 "panel.c"
}

static void
__lambda90_ (Panel* self,
             PropertyManager* w,
             const gchar* k,
             gint s)
{
#line 133 "panel.vala"
	g_return_if_fail (w != NULL);
#line 133 "panel.vala"
	g_return_if_fail (k != NULL);
#line 134 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1097 "panel.c"
}

static void
___lambda90__property_manager_property_activate (PropertyManager* _sender,
                                                 const gchar* key,
                                                 gint state,
                                                 gpointer self)
{
#line 133 "panel.vala"
	__lambda90_ ((Panel*) self, _sender, key, state);
#line 1108 "panel.c"
}

static void
__lambda111_ (Panel* self,
              PropertyPanel* w,
              const gchar* k,
              gint s)
{
#line 157 "panel.vala"
	g_return_if_fail (w != NULL);
#line 157 "panel.vala"
	g_return_if_fail (k != NULL);
#line 158 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1123 "panel.c"
}

static void
___lambda111__property_panel_property_activate (PropertyPanel* _sender,
                                                const gchar* key,
                                                gint state,
                                                gpointer self)
{
#line 157 "panel.vala"
	__lambda111_ ((Panel*) self, _sender, key, state);
#line 1134 "panel.c"
}

Panel*
panel_construct (GType object_type,
                 IBusBus* bus,
                 gboolean is_wayland_im)
{
	Panel * self = NULL;
	GDBusConnection* _tmp0_;
	IBusBus* _tmp1_;
	PropertyManager* _tmp2_;
	PropertyManager* _tmp3_;
	CandidatePanel* _tmp4_;
	CandidatePanel* _tmp5_;
	CandidatePanel* _tmp6_;
	Switcher* _tmp7_;
	Switcher* _tmp8_;
	Switcher* _tmp9_;
	PropertyPanel* _tmp10_;
	PropertyPanel* _tmp11_;
#line 108 "panel.vala"
	g_return_val_if_fail (bus != NULL, NULL);
#line 110 "panel.vala"
	_vala_assert (ibus_bus_is_connected (bus), "bus.is_connected()");
#line 112 "panel.vala"
	_tmp0_ = ibus_bus_get_connection (bus);
#line 112 "panel.vala"
	self = (Panel*) g_object_new (object_type, "connection", _tmp0_, "object-path", "/org/freedesktop/IBus/Panel", NULL);
#line 115 "panel.vala"
	_tmp1_ = _g_object_ref0 (bus);
#line 115 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 115 "panel.vala"
	self->priv->m_bus = _tmp1_;
#line 116 "panel.vala"
	self->priv->m_is_wayland_im = is_wayland_im;
#line 119 "panel.vala"
	self->priv->m_is_wayland = !binding_common_default_is_xdisplay ();
#line 124 "panel.vala"
	panel_init_settings (self);
#line 125 "panel.vala"
	panel_set_version (self);
#line 126 "panel.vala"
	panel_check_wayland (self);
#line 128 "panel.vala"
	self->priv->m_is_indicator = panel_is_indicator (self);
#line 132 "panel.vala"
	_tmp2_ = property_manager_new ();
#line 132 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 132 "panel.vala"
	self->priv->m_property_manager = _tmp2_;
#line 133 "panel.vala"
	_tmp3_ = self->priv->m_property_manager;
#line 133 "panel.vala"
	g_signal_connect_object (_tmp3_, "property-activate", (GCallback) ___lambda90__property_manager_property_activate, self, 0);
#line 139 "panel.vala"
	if (self->priv->m_is_indicator) {
#line 140 "panel.vala"
		panel_init_indicator (self);
#line 1195 "panel.c"
	} else {
#line 142 "panel.vala"
		panel_init_status_icon (self);
#line 1199 "panel.c"
	}
#line 148 "panel.vala"
	_tmp4_ = panel_candidate_panel_new (self, FALSE);
#line 148 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 148 "panel.vala"
	self->priv->m_candidate_panel = _tmp4_;
#line 149 "panel.vala"
	_tmp5_ = self->priv->m_candidate_panel;
#line 149 "panel.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 149 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel_active);
#line 149 "panel.vala"
	self->priv->m_candidate_panel_active = _tmp6_;
#line 151 "panel.vala"
	_tmp7_ = panel_switcher_new (self, FALSE);
#line 151 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 151 "panel.vala"
	self->priv->m_switcher = _tmp7_;
#line 152 "panel.vala"
	_tmp8_ = self->priv->m_switcher;
#line 152 "panel.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 152 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher_active);
#line 152 "panel.vala"
	self->priv->m_switcher_active = _tmp9_;
#line 154 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 156 "panel.vala"
	_tmp10_ = property_panel_new ();
#line 156 "panel.vala"
	g_object_ref_sink (_tmp10_);
#line 156 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 156 "panel.vala"
	self->priv->m_property_panel = _tmp10_;
#line 157 "panel.vala"
	_tmp11_ = self->priv->m_property_panel;
#line 157 "panel.vala"
	g_signal_connect_object (_tmp11_, "property-activate", (GCallback) ___lambda111__property_panel_property_activate, self, 0);
#line 161 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 108 "panel.vala"
	return self;
#line 1247 "panel.c"
}

Panel*
panel_new (IBusBus* bus,
           gboolean is_wayland_im)
{
#line 108 "panel.vala"
	return panel_construct (TYPE_PANEL, bus, is_wayland_im);
#line 1256 "panel.c"
}

static void
__lambda102_ (Panel* self,
              CandidatePanel* w)
{
#line 177 "panel.vala"
	g_return_if_fail (w != NULL);
#line 177 "panel.vala"
	ibus_panel_service_page_up ((IBusPanelService*) self);
#line 1267 "panel.c"
}

static void
___lambda102__candidate_panel_page_up (CandidatePanel* _sender,
                                       gpointer self)
{
#line 177 "panel.vala"
	__lambda102_ ((Panel*) self, _sender);
#line 1276 "panel.c"
}

static void
__lambda103_ (Panel* self,
              CandidatePanel* w)
{
#line 178 "panel.vala"
	g_return_if_fail (w != NULL);
#line 178 "panel.vala"
	ibus_panel_service_page_down ((IBusPanelService*) self);
#line 1287 "panel.c"
}

static void
___lambda103__candidate_panel_page_down (CandidatePanel* _sender,
                                         gpointer self)
{
#line 178 "panel.vala"
	__lambda103_ ((Panel*) self, _sender);
#line 1296 "panel.c"
}

static void
__lambda104_ (Panel* self,
              CandidatePanel* w)
{
#line 179 "panel.vala"
	g_return_if_fail (w != NULL);
#line 179 "panel.vala"
	ibus_panel_service_cursor_up ((IBusPanelService*) self);
#line 1307 "panel.c"
}

static void
___lambda104__candidate_panel_cursor_up (CandidatePanel* _sender,
                                         gpointer self)
{
#line 179 "panel.vala"
	__lambda104_ ((Panel*) self, _sender);
#line 1316 "panel.c"
}

static void
__lambda105_ (Panel* self,
              CandidatePanel* w)
{
#line 180 "panel.vala"
	g_return_if_fail (w != NULL);
#line 180 "panel.vala"
	ibus_panel_service_cursor_down ((IBusPanelService*) self);
#line 1327 "panel.c"
}

static void
___lambda105__candidate_panel_cursor_down (CandidatePanel* _sender,
                                           gpointer self)
{
#line 180 "panel.vala"
	__lambda105_ ((Panel*) self, _sender);
#line 1336 "panel.c"
}

static void
__lambda106_ (Panel* self,
              CandidatePanel* w,
              guint i,
              guint b,
              guint s)
{
#line 182 "panel.vala"
	g_return_if_fail (w != NULL);
#line 182 "panel.vala"
	ibus_panel_service_candidate_clicked ((IBusPanelService*) self, i, b, s);
#line 1350 "panel.c"
}

static void
___lambda106__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                 guint index,
                                                 guint button,
                                                 guint state,
                                                 gpointer self)
{
#line 181 "panel.vala"
	__lambda106_ ((Panel*) self, _sender, index, button, state);
#line 1362 "panel.c"
}

static void
__lambda107_ (Panel* self,
              CandidatePanel* w,
              guint v,
              guint c,
              guint m)
{
#line 185 "panel.vala"
	g_return_if_fail (w != NULL);
#line 185 "panel.vala"
	ibus_panel_service_forward_process_key_event ((IBusPanelService*) self, (guint32) v, (guint32) (c - 8), (guint32) m);
#line 1376 "panel.c"
}

static void
___lambda107__candidate_panel_forward_process_key_event (CandidatePanel* _sender,
                                                         guint keyval,
                                                         guint keycode,
                                                         guint modifiers,
                                                         gpointer self)
{
#line 184 "panel.vala"
	__lambda107_ ((Panel*) self, _sender, keyval, keycode, modifiers);
#line 1388 "panel.c"
}

static void
__lambda108_ (Panel* self,
              CandidatePanel* w,
              void* s)
{
#line 187 "panel.vala"
	g_return_if_fail (w != NULL);
#line 187 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1400 "panel.c"
}

static void
___lambda108__candidate_panel_realize_surface (CandidatePanel* _sender,
                                               void* surface,
                                               gpointer self)
{
#line 186 "panel.vala"
	__lambda108_ ((Panel*) self, _sender, surface);
#line 1410 "panel.c"
}

static CandidatePanel*
panel_candidate_panel_new (Panel* self,
                           gboolean no_wayland_panel)
{
	CandidatePanel* candidate_panel = NULL;
	CandidatePanel* _tmp0_;
	CandidatePanel* result;
#line 175 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "panel.vala"
	_tmp0_ = candidate_panel_new (no_wayland_panel);
#line 176 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 176 "panel.vala"
	candidate_panel = _tmp0_;
#line 177 "panel.vala"
	g_signal_connect_object (candidate_panel, "page-up", (GCallback) ___lambda102__candidate_panel_page_up, self, 0);
#line 178 "panel.vala"
	g_signal_connect_object (candidate_panel, "page-down", (GCallback) ___lambda103__candidate_panel_page_down, self, 0);
#line 179 "panel.vala"
	g_signal_connect_object (candidate_panel, "cursor-up", (GCallback) ___lambda104__candidate_panel_cursor_up, self, 0);
#line 180 "panel.vala"
	g_signal_connect_object (candidate_panel, "cursor-down", (GCallback) ___lambda105__candidate_panel_cursor_down, self, 0);
#line 181 "panel.vala"
	g_signal_connect_object (candidate_panel, "candidate-clicked", (GCallback) ___lambda106__candidate_panel_candidate_clicked, self, 0);
#line 184 "panel.vala"
	g_signal_connect_object (candidate_panel, "forward-process-key-event", (GCallback) ___lambda107__candidate_panel_forward_process_key_event, self, 0);
#line 186 "panel.vala"
	g_signal_connect_object (candidate_panel, "realize-surface", (GCallback) ___lambda108__candidate_panel_realize_surface, self, 0);
#line 189 "panel.vala"
	result = candidate_panel;
#line 189 "panel.vala"
	return result;
#line 1446 "panel.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 192 "panel.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 192 "panel.vala"
	return _data10_;
#line 1456 "panel.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 192 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1466 "panel.c"
		Panel* self;
#line 192 "panel.vala"
		self = _data10_->self;
#line 192 "panel.vala"
		_g_object_unref0 (_data10_->switcher);
#line 192 "panel.vala"
		_g_object_unref0 (self);
#line 192 "panel.vala"
		g_slice_free (Block10Data, _data10_);
#line 1476 "panel.c"
	}
}

static void
__lambda109_ (Panel* self,
              Switcher* w,
              void* s)
{
#line 196 "panel.vala"
	g_return_if_fail (w != NULL);
#line 196 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1489 "panel.c"
}

static void
___lambda109__switcher_realize_surface (Switcher* _sender,
                                        void* surface,
                                        gpointer self)
{
#line 195 "panel.vala"
	__lambda109_ ((Panel*) self, _sender, surface);
#line 1499 "panel.c"
}

static void
__lambda110_ (Block10Data* _data10_,
              GtkWidget* w)
{
	Panel* self;
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	IBusEngineDesc* _tmp2_;
	Switcher* _tmp3_;
#line 198 "panel.vala"
	self = _data10_->self;
#line 198 "panel.vala"
	g_return_if_fail (w != NULL);
#line 199 "panel.vala"
	if (!_data10_->no_wayland_panel) {
#line 200 "panel.vala"
		return;
#line 1520 "panel.c"
	}
#line 201 "panel.vala"
	_tmp0_ = _data10_->switcher;
#line 201 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 201 "panel.vala"
	selected_engine = _tmp1_;
#line 203 "panel.vala"
	_tmp2_ = selected_engine;
#line 203 "panel.vala"
	panel_set_engine (self, _tmp2_);
#line 204 "panel.vala"
	_tmp3_ = _data10_->switcher;
#line 204 "panel.vala"
	switcher_reset (_tmp3_);
#line 205 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 198 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 1540 "panel.c"
}

static void
___lambda110__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 197 "panel.vala"
	__lambda110_ (self, _sender);
#line 1549 "panel.c"
}

static Switcher*
panel_switcher_new (Panel* self,
                    gboolean no_wayland_panel)
{
	Block10Data* _data10_;
	Switcher* _tmp0_;
	Switcher* _tmp1_;
	Switcher* _tmp2_;
	Switcher* _tmp4_;
	Switcher* _tmp5_;
	Switcher* result;
#line 192 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 192 "panel.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 192 "panel.vala"
	_data10_->_ref_count_ = 1;
#line 192 "panel.vala"
	_data10_->self = g_object_ref (self);
#line 192 "panel.vala"
	_data10_->no_wayland_panel = no_wayland_panel;
#line 193 "panel.vala"
	_tmp0_ = switcher_new (_data10_->no_wayland_panel);
#line 193 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 193 "panel.vala"
	_data10_->switcher = _tmp0_;
#line 195 "panel.vala"
	_tmp1_ = _data10_->switcher;
#line 195 "panel.vala"
	g_signal_connect_object (_tmp1_, "realize-surface", (GCallback) ___lambda109__switcher_realize_surface, self, 0);
#line 197 "panel.vala"
	_tmp2_ = _data10_->switcher;
#line 197 "panel.vala"
	g_signal_connect_data ((GtkWidget*) _tmp2_, "hide", (GCallback) ___lambda110__gtk_widget_hide, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 208 "panel.vala"
	if (self->priv->m_switcher_delay_time >= 0) {
#line 1589 "panel.c"
		Switcher* _tmp3_;
#line 209 "panel.vala"
		_tmp3_ = _data10_->switcher;
#line 209 "panel.vala"
		switcher_set_popup_delay_time (_tmp3_, (guint) self->priv->m_switcher_delay_time);
#line 1595 "panel.c"
	}
#line 211 "panel.vala"
	_tmp4_ = _data10_->switcher;
#line 211 "panel.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 211 "panel.vala"
	result = _tmp5_;
#line 211 "panel.vala"
	block10_data_unref (_data10_);
#line 211 "panel.vala"
	_data10_ = NULL;
#line 211 "panel.vala"
	return result;
#line 1609 "panel.c"
}

static CandidatePanel*
panel_get_active_candidate_panel (Panel* self)
{
	const gchar* _tmp0_;
	CandidatePanel* result;
#line 215 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "panel.vala"
	_tmp0_ = self->priv->m_wayland_object_path;
#line 216 "panel.vala"
	if (_tmp0_ == NULL) {
#line 1623 "panel.c"
		CandidatePanel* _tmp1_;
		CandidatePanel* _tmp5_;
		CandidatePanel* _tmp6_;
#line 217 "panel.vala"
		_tmp1_ = self->priv->m_candidate_panel_x11;
#line 217 "panel.vala"
		if (_tmp1_ == NULL) {
#line 1631 "panel.c"
			CandidatePanel* _tmp2_;
			CandidatePanel* _tmp3_;
			GSettings* _tmp4_;
#line 218 "panel.vala"
			_tmp2_ = panel_candidate_panel_new (self, TRUE);
#line 218 "panel.vala"
			_g_object_unref0 (self->priv->m_candidate_panel_x11);
#line 218 "panel.vala"
			self->priv->m_candidate_panel_x11 = _tmp2_;
#line 219 "panel.vala"
			panel_set_use_glyph_from_engine_lang (self);
#line 220 "panel.vala"
			_tmp3_ = self->priv->m_candidate_panel_x11;
#line 220 "panel.vala"
			_tmp4_ = self->priv->m_settings_panel;
#line 220 "panel.vala"
			candidate_panel_set_vertical (_tmp3_, g_settings_get_int (_tmp4_, "lookup-table-orientation") == ((gint) IBUS_ORIENTATION_VERTICAL));
#line 1649 "panel.c"
		}
#line 224 "panel.vala"
		_tmp5_ = self->priv->m_candidate_panel_x11;
#line 224 "panel.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 224 "panel.vala"
		result = _tmp6_;
#line 224 "panel.vala"
		return result;
#line 1659 "panel.c"
	} else {
		CandidatePanel* _tmp7_;
		CandidatePanel* _tmp8_;
#line 226 "panel.vala"
		_tmp7_ = self->priv->m_candidate_panel;
#line 226 "panel.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 226 "panel.vala"
		result = _tmp8_;
#line 226 "panel.vala"
		return result;
#line 1671 "panel.c"
	}
}

static Switcher*
panel_get_active_switcher (Panel* self)
{
	const gchar* _tmp0_;
	Switcher* result;
#line 230 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "panel.vala"
	_tmp0_ = self->priv->m_wayland_object_path;
#line 231 "panel.vala"
	if (_tmp0_ == NULL) {
#line 1686 "panel.c"
		Switcher* _tmp1_;
		Switcher* _tmp3_;
		Switcher* _tmp4_;
#line 232 "panel.vala"
		_tmp1_ = self->priv->m_switcher_x11;
#line 232 "panel.vala"
		if (_tmp1_ == NULL) {
#line 1694 "panel.c"
			Switcher* _tmp2_;
#line 233 "panel.vala"
			_tmp2_ = panel_switcher_new (self, TRUE);
#line 233 "panel.vala"
			_g_object_unref0 (self->priv->m_switcher_x11);
#line 233 "panel.vala"
			self->priv->m_switcher_x11 = _tmp2_;
#line 1702 "panel.c"
		}
#line 234 "panel.vala"
		_tmp3_ = self->priv->m_switcher_x11;
#line 234 "panel.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 234 "panel.vala"
		result = _tmp4_;
#line 234 "panel.vala"
		return result;
#line 1712 "panel.c"
	} else {
		Switcher* _tmp5_;
		Switcher* _tmp6_;
#line 236 "panel.vala"
		_tmp5_ = self->priv->m_switcher;
#line 236 "panel.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 236 "panel.vala"
		result = _tmp6_;
#line 236 "panel.vala"
		return result;
#line 1724 "panel.c"
	}
}

static void
__lambda66_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 247 "panel.vala"
	g_return_if_fail (key != NULL);
#line 248 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 248 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, key);
#line 248 "panel.vala"
	_tmp3_ = _tmp2_;
#line 248 "panel.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 248 "panel.vala"
	panel_update_engines (self, _tmp3_, (gint) _vala_array_length (_tmp1_), NULL, (gint) 0);
#line 248 "panel.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 1751 "panel.c"
}

static void
___lambda66__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 247 "panel.vala"
	__lambda66_ ((Panel*) self, key);
#line 1761 "panel.c"
}

static void
__lambda69_ (Panel* self,
             const gchar* key)
{
#line 252 "panel.vala"
	g_return_if_fail (key != NULL);
#line 253 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 1772 "panel.c"
}

static void
___lambda69__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 252 "panel.vala"
	__lambda69_ ((Panel*) self, key);
#line 1782 "panel.c"
}

static void
__lambda70_ (Panel* self,
             const gchar* key)
{
#line 257 "panel.vala"
	g_return_if_fail (key != NULL);
#line 258 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 1793 "panel.c"
}

static void
___lambda70__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 256 "panel.vala"
	__lambda70_ ((Panel*) self, key);
#line 1803 "panel.c"
}

static void
__lambda71_ (Panel* self,
             const gchar* key)
{
#line 261 "panel.vala"
	g_return_if_fail (key != NULL);
#line 262 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 1814 "panel.c"
}

static void
___lambda71__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 261 "panel.vala"
	__lambda71_ ((Panel*) self, key);
#line 1824 "panel.c"
}

static void
__lambda72_ (Panel* self,
             const gchar* key)
{
#line 265 "panel.vala"
	g_return_if_fail (key != NULL);
#line 266 "panel.vala"
	panel_set_use_global_engine (self);
#line 1835 "panel.c"
}

static void
___lambda72__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 265 "panel.vala"
	__lambda72_ ((Panel*) self, key);
#line 1845 "panel.c"
}

static void
__lambda73_ (Panel* self,
             const gchar* key)
{
#line 269 "panel.vala"
	g_return_if_fail (key != NULL);
#line 270 "panel.vala"
	panel_set_use_xmodmap (self);
#line 1856 "panel.c"
}

static void
___lambda73__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 269 "panel.vala"
	__lambda73_ ((Panel*) self, key);
#line 1866 "panel.c"
}

static void
__lambda74_ (Panel* self,
             const gchar* key)
{
	GList* _tmp0_;
#line 273 "panel.vala"
	g_return_if_fail (key != NULL);
#line 274 "panel.vala"
	_tmp0_ = self->priv->m_keybindings;
#line 274 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER, _tmp0_);
#line 277 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 277 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 278 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 1886 "panel.c"
}

static void
___lambda74__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 273 "panel.vala"
	__lambda74_ ((Panel*) self, key);
#line 1896 "panel.c"
}

static void
__lambda76_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 281 "panel.vala"
	g_return_if_fail (key != NULL);
#line 282 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 282 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1910 "panel.c"
}

static void
___lambda76__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 281 "panel.vala"
	__lambda76_ ((Panel*) self, key);
#line 1920 "panel.c"
}

static void
__lambda77_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 287 "panel.vala"
	g_return_if_fail (key != NULL);
#line 288 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 288 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1934 "panel.c"
}

static void
___lambda77__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 287 "panel.vala"
	__lambda77_ ((Panel*) self, key);
#line 1944 "panel.c"
}

static void
__lambda78_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 293 "panel.vala"
	g_return_if_fail (key != NULL);
#line 294 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 294 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1958 "panel.c"
}

static void
___lambda78__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 293 "panel.vala"
	__lambda78_ ((Panel*) self, key);
#line 1968 "panel.c"
}

static void
__lambda79_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 297 "panel.vala"
	g_return_if_fail (key != NULL);
#line 298 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 298 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1982 "panel.c"
}

static void
___lambda79__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 297 "panel.vala"
	__lambda79_ ((Panel*) self, key);
#line 1992 "panel.c"
}

static void
__lambda80_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 301 "panel.vala"
	g_return_if_fail (key != NULL);
#line 302 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 302 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 2006 "panel.c"
}

static void
___lambda80__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 301 "panel.vala"
	__lambda80_ ((Panel*) self, key);
#line 2016 "panel.c"
}

static void
__lambda81_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 305 "panel.vala"
	g_return_if_fail (key != NULL);
#line 306 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 306 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 2030 "panel.c"
}

static void
___lambda81__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 305 "panel.vala"
	__lambda81_ ((Panel*) self, key);
#line 2040 "panel.c"
}

static void
__lambda82_ (Panel* self,
             const gchar* key)
{
#line 309 "panel.vala"
	g_return_if_fail (key != NULL);
#line 311 "panel.vala"
	panel_set_use_glyph_from_engine_lang (self);
#line 2051 "panel.c"
}

static void
___lambda82__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 309 "panel.vala"
	__lambda82_ ((Panel*) self, key);
#line 2061 "panel.c"
}

static void
__lambda83_ (Panel* self,
             const gchar* key)
{
#line 314 "panel.vala"
	g_return_if_fail (key != NULL);
#line 315 "panel.vala"
	panel_set_show_icon_on_systray (self, TRUE);
#line 2072 "panel.c"
}

static void
___lambda83__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 314 "panel.vala"
	__lambda83_ ((Panel*) self, key);
#line 2082 "panel.c"
}

static void
__lambda84_ (Panel* self,
             const gchar* key)
{
#line 318 "panel.vala"
	g_return_if_fail (key != NULL);
#line 319 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 2093 "panel.c"
}

static void
___lambda84__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 318 "panel.vala"
	__lambda84_ ((Panel*) self, key);
#line 2103 "panel.c"
}

static void
__lambda85_ (Panel* self,
             const gchar* key)
{
#line 322 "panel.vala"
	g_return_if_fail (key != NULL);
#line 323 "panel.vala"
	panel_set_show_property_panel (self);
#line 2114 "panel.c"
}

static void
___lambda85__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 322 "panel.vala"
	__lambda85_ ((Panel*) self, key);
#line 2124 "panel.c"
}

static void
__lambda86_ (Panel* self,
             const gchar* key)
{
#line 326 "panel.vala"
	g_return_if_fail (key != NULL);
#line 327 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 2135 "panel.c"
}

static void
___lambda86__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 326 "panel.vala"
	__lambda86_ ((Panel*) self, key);
#line 2145 "panel.c"
}

static void
__lambda87_ (Panel* self,
             const gchar* key)
{
#line 331 "panel.vala"
	g_return_if_fail (key != NULL);
#line 332 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 2156 "panel.c"
}

static void
___lambda87__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 330 "panel.vala"
	__lambda87_ ((Panel*) self, key);
#line 2166 "panel.c"
}

static void
__lambda88_ (Panel* self,
             const gchar* key)
{
#line 335 "panel.vala"
	g_return_if_fail (key != NULL);
#line 336 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 2177 "panel.c"
}

static void
___lambda88__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 335 "panel.vala"
	__lambda88_ ((Panel*) self, key);
#line 2187 "panel.c"
}

static void
__lambda89_ (Panel* self,
             const gchar* key)
{
#line 339 "panel.vala"
	g_return_if_fail (key != NULL);
#line 340 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 2198 "panel.c"
}

static void
___lambda89__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 339 "panel.vala"
	__lambda89_ ((Panel*) self, key);
#line 2208 "panel.c"
}

static void
panel_init_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
#line 241 "panel.vala"
	g_return_if_fail (self != NULL);
#line 242 "panel.vala"
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
#line 242 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 242 "panel.vala"
	self->priv->m_settings_general = _tmp0_;
#line 243 "panel.vala"
	_tmp1_ = g_settings_new ("org.freedesktop.ibus.general.hotkey");
#line 243 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 243 "panel.vala"
	self->priv->m_settings_hotkey = _tmp1_;
#line 245 "panel.vala"
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
#line 245 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 245 "panel.vala"
	self->priv->m_settings_panel = _tmp2_;
#line 247 "panel.vala"
	_tmp3_ = self->priv->m_settings_general;
#line 247 "panel.vala"
	g_signal_connect_object (_tmp3_, "changed::preload-engines", (GCallback) ___lambda66__g_settings_changed, self, 0);
#line 252 "panel.vala"
	_tmp4_ = self->priv->m_settings_general;
#line 252 "panel.vala"
	g_signal_connect_object (_tmp4_, "changed::switcher-delay-time", (GCallback) ___lambda69__g_settings_changed, self, 0);
#line 256 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 256 "panel.vala"
	g_signal_connect_object (_tmp5_, "changed::use-system-keyboard-layout", (GCallback) ___lambda70__g_settings_changed, self, 0);
#line 261 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 261 "panel.vala"
	g_signal_connect_object (_tmp6_, "changed::embed-preedit-text", (GCallback) ___lambda71__g_settings_changed, self, 0);
#line 265 "panel.vala"
	_tmp7_ = self->priv->m_settings_general;
#line 265 "panel.vala"
	g_signal_connect_object (_tmp7_, "changed::use-global-engine", (GCallback) ___lambda72__g_settings_changed, self, 0);
#line 269 "panel.vala"
	_tmp8_ = self->priv->m_settings_general;
#line 269 "panel.vala"
	g_signal_connect_object (_tmp8_, "changed::use-xmodmap", (GCallback) ___lambda73__g_settings_changed, self, 0);
#line 273 "panel.vala"
	_tmp9_ = self->priv->m_settings_hotkey;
#line 273 "panel.vala"
	g_signal_connect_object (_tmp9_, "changed::triggers", (GCallback) ___lambda74__g_settings_changed, self, 0);
#line 281 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 281 "panel.vala"
	g_signal_connect_object (_tmp10_, "changed::custom-font", (GCallback) ___lambda76__g_settings_changed, self, 0);
#line 287 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 287 "panel.vala"
	g_signal_connect_object (_tmp11_, "changed::use-custom-font", (GCallback) ___lambda77__g_settings_changed, self, 0);
#line 293 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 293 "panel.vala"
	g_signal_connect_object (_tmp12_, "changed::custom-theme", (GCallback) ___lambda78__g_settings_changed, self, 0);
#line 297 "panel.vala"
	_tmp13_ = self->priv->m_settings_panel;
#line 297 "panel.vala"
	g_signal_connect_object (_tmp13_, "changed::use-custom-theme", (GCallback) ___lambda79__g_settings_changed, self, 0);
#line 301 "panel.vala"
	_tmp14_ = self->priv->m_settings_panel;
#line 301 "panel.vala"
	g_signal_connect_object (_tmp14_, "changed::custom-icon", (GCallback) ___lambda80__g_settings_changed, self, 0);
#line 305 "panel.vala"
	_tmp15_ = self->priv->m_settings_panel;
#line 305 "panel.vala"
	g_signal_connect_object (_tmp15_, "changed::use-custom-icon", (GCallback) ___lambda81__g_settings_changed, self, 0);
#line 309 "panel.vala"
	_tmp16_ = self->priv->m_settings_panel;
#line 309 "panel.vala"
	g_signal_connect_object (_tmp16_, "changed::use-glyph-from-engine-lang", (GCallback) ___lambda82__g_settings_changed, self, 0);
#line 314 "panel.vala"
	_tmp17_ = self->priv->m_settings_panel;
#line 314 "panel.vala"
	g_signal_connect_object (_tmp17_, "changed::show-icon-on-systray", (GCallback) ___lambda83__g_settings_changed, self, 0);
#line 318 "panel.vala"
	_tmp18_ = self->priv->m_settings_panel;
#line 318 "panel.vala"
	g_signal_connect_object (_tmp18_, "changed::lookup-table-orientation", (GCallback) ___lambda84__g_settings_changed, self, 0);
#line 322 "panel.vala"
	_tmp19_ = self->priv->m_settings_panel;
#line 322 "panel.vala"
	g_signal_connect_object (_tmp19_, "changed::show", (GCallback) ___lambda85__g_settings_changed, self, 0);
#line 326 "panel.vala"
	_tmp20_ = self->priv->m_settings_panel;
#line 326 "panel.vala"
	g_signal_connect_object (_tmp20_, "changed::timeout", (GCallback) ___lambda86__g_settings_changed, self, 0);
#line 330 "panel.vala"
	_tmp21_ = self->priv->m_settings_panel;
#line 330 "panel.vala"
	g_signal_connect_object (_tmp21_, "changed::follow-input-cursor-when-always-shown", (GCallback) ___lambda87__g_settings_changed, self, 0);
#line 335 "panel.vala"
	_tmp22_ = self->priv->m_settings_panel;
#line 335 "panel.vala"
	g_signal_connect_object (_tmp22_, "changed::xkb-icon-rgba", (GCallback) ___lambda88__g_settings_changed, self, 0);
#line 339 "panel.vala"
	_tmp23_ = self->priv->m_settings_panel;
#line 339 "panel.vala"
	g_signal_connect_object (_tmp23_, "changed::property-icon-delay-time", (GCallback) ___lambda89__g_settings_changed, self, 0);
#line 2342 "panel.c"
}

static void
panel_popup_menu_at_area_window (Panel* self,
                                 GtkMenu* menu,
                                 GdkRectangle* area,
                                 GdkWindow* window,
                                 GtkMenuPositionFunc func,
                                 gpointer func_target)
{
	GdkGravity rect_anchor = 0;
	GdkGravity menu_anchor = 0;
	GdkRectangle _tmp0_;
#line 344 "panel.vala"
	g_return_if_fail (self != NULL);
#line 344 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 344 "panel.vala"
	g_return_if_fail (area != NULL);
#line 348 "panel.vala"
	rect_anchor = GDK_GRAVITY_SOUTH_WEST;
#line 349 "panel.vala"
	menu_anchor = GDK_GRAVITY_NORTH_WEST;
#line 358 "panel.vala"
	_tmp0_ = *area;
#line 358 "panel.vala"
	gtk_menu_popup_at_rect (menu, window, &_tmp0_, rect_anchor, menu_anchor, NULL);
#line 2370 "panel.c"
}

static gboolean
panel_is_gnome (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result;
#line 363 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 363 "panel.vala"
	desktop = _tmp0_;
#line 365 "panel.vala"
	_tmp1_ = desktop;
#line 365 "panel.vala"
	if (g_strcmp0 (_tmp1_, "GNOME") == 0) {
#line 366 "panel.vala"
		result = TRUE;
#line 366 "panel.vala"
		return result;
#line 2396 "panel.c"
	}
#line 367 "panel.vala"
	_tmp3_ = desktop;
#line 367 "panel.vala"
	if (_tmp3_ == NULL) {
#line 367 "panel.vala"
		_tmp2_ = TRUE;
#line 2404 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 367 "panel.vala"
		_tmp4_ = desktop;
#line 367 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2411 "panel.c"
	}
#line 367 "panel.vala"
	if (_tmp2_) {
#line 2415 "panel.c"
		const gchar* _tmp5_;
#line 368 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 368 "panel.vala"
		desktop = _tmp5_;
#line 2421 "panel.c"
	}
#line 369 "panel.vala"
	_tmp7_ = desktop;
#line 369 "panel.vala"
	if (g_strcmp0 (_tmp7_, "gnome") == 0) {
#line 369 "panel.vala"
		_tmp6_ = TRUE;
#line 2429 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 369 "panel.vala"
		_tmp8_ = desktop;
#line 369 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "GNOME") == 0;
#line 2436 "panel.c"
	}
#line 369 "panel.vala"
	if (_tmp6_) {
#line 370 "panel.vala"
		result = TRUE;
#line 370 "panel.vala"
		return result;
#line 2444 "panel.c"
	}
#line 371 "panel.vala"
	result = FALSE;
#line 371 "panel.vala"
	return result;
#line 2450 "panel.c"
}

static gboolean
panel_is_indicator (Panel* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* desktop = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp10_;
	gboolean result;
#line 376 "panel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 377 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 377 "panel.vala"
		_tmp0_ = self->priv->m_is_wayland_im;
#line 2472 "panel.c"
	} else {
#line 377 "panel.vala"
		_tmp0_ = FALSE;
#line 2476 "panel.c"
	}
#line 377 "panel.vala"
	if (_tmp0_) {
#line 378 "panel.vala"
		result = TRUE;
#line 378 "panel.vala"
		return result;
#line 2484 "panel.c"
	}
#line 380 "panel.vala"
	_tmp1_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 380 "panel.vala"
	desktop = _tmp1_;
#line 382 "panel.vala"
	_tmp2_ = desktop;
#line 382 "panel.vala"
	if (g_strcmp0 (_tmp2_, "KDE") == 0) {
#line 383 "panel.vala"
		result = TRUE;
#line 383 "panel.vala"
		return result;
#line 2498 "panel.c"
	}
#line 389 "panel.vala"
	_tmp4_ = desktop;
#line 389 "panel.vala"
	if (_tmp4_ == NULL) {
#line 389 "panel.vala"
		_tmp3_ = TRUE;
#line 2506 "panel.c"
	} else {
		const gchar* _tmp5_;
#line 389 "panel.vala"
		_tmp5_ = desktop;
#line 389 "panel.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "(null)") == 0;
#line 2513 "panel.c"
	}
#line 389 "panel.vala"
	if (_tmp3_) {
#line 2517 "panel.c"
		const gchar* _tmp6_;
#line 390 "panel.vala"
		_tmp6_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 390 "panel.vala"
		desktop = _tmp6_;
#line 2523 "panel.c"
	}
#line 391 "panel.vala"
	_tmp8_ = desktop;
#line 391 "panel.vala"
	if (g_strcmp0 (_tmp8_, "plasma") == 0) {
#line 391 "panel.vala"
		_tmp7_ = TRUE;
#line 2531 "panel.c"
	} else {
		const gchar* _tmp9_;
#line 391 "panel.vala"
		_tmp9_ = desktop;
#line 391 "panel.vala"
		_tmp7_ = g_strcmp0 (_tmp9_, "KDE-wayland") == 0;
#line 2538 "panel.c"
	}
#line 391 "panel.vala"
	if (_tmp7_) {
#line 392 "panel.vala"
		result = TRUE;
#line 392 "panel.vala"
		return result;
#line 2546 "panel.c"
	}
#line 393 "panel.vala"
	_tmp10_ = desktop;
#line 393 "panel.vala"
	if (_tmp10_ == NULL) {
#line 394 "panel.vala"
		g_warning ("panel.vala:394: %s", "XDG_CURRENT_DESKTOP is not exported in your desktop " "session.");
#line 2554 "panel.c"
	}
#line 397 "panel.vala"
	g_warning ("panel.vala:397: %s", "If you launch KDE5 on xterm, " "export XDG_CURRENT_DESKTOP=KDE before launch KDE5.");
#line 399 "panel.vala"
	result = FALSE;
#line 399 "panel.vala"
	return result;
#line 2562 "panel.c"
}

static void
panel_popup_menu_at_pointer_window (Panel* self,
                                    GtkMenu* menu,
                                    gint x,
                                    gint y,
                                    GdkWindow* window,
                                    GtkMenuPositionFunc func,
                                    gpointer func_target)
{
	gint win_x = 0;
	gint win_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkRectangle area = {0};
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 402 "panel.vala"
	g_return_if_fail (self != NULL);
#line 402 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 407 "panel.vala"
	win_x = 0;
#line 408 "panel.vala"
	win_y = 0;
#line 409 "panel.vala"
	gdk_window_get_origin (window, &_tmp0_, &_tmp1_);
#line 409 "panel.vala"
	win_x = _tmp0_;
#line 409 "panel.vala"
	win_y = _tmp1_;
#line 410 "panel.vala"
	_tmp2_.x = x - win_x;
#line 410 "panel.vala"
	_tmp2_.y = y - win_y;
#line 410 "panel.vala"
	_tmp2_.width = 1;
#line 410 "panel.vala"
	_tmp2_.height = 1;
#line 410 "panel.vala"
	area = _tmp2_;
#line 412 "panel.vala"
	_tmp3_ = area;
#line 412 "panel.vala"
	panel_popup_menu_at_area_window (self, menu, &_tmp3_, window, func, func_target);
#line 2609 "panel.c"
}

static void
__lambda91_ (Panel* self)
{
	Indicator* _tmp0_;
#line 425 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 425 "panel.vala"
	indicator_set_status (_tmp0_, self->priv->m_indicator_show_status);
#line 426 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 2622 "panel.c"
}

static void
___lambda91__indicator_registered_status_notifier_item (Indicator* _sender,
                                                        gpointer self)
{
#line 423 "panel.vala"
	__lambda91_ ((Panel*) self);
#line 2631 "panel.c"
}

static void
__lambda92_ (Panel* self)
{
#line 430 "panel.vala"
	self->priv->m_is_context_menu = !self->priv->m_is_context_menu;
#line 431 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 2641 "panel.c"
		Indicator* _tmp0_;
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 432 "panel.vala"
		_tmp0_ = self->priv->m_indicator;
#line 432 "panel.vala"
		_tmp1_ = panel_create_context_menu (self, FALSE);
#line 432 "panel.vala"
		_tmp2_ = _tmp1_;
#line 432 "panel.vala"
		indicator_set_menu (_tmp0_, _tmp2_);
#line 432 "panel.vala"
		_g_object_unref0 (_tmp2_);
#line 2655 "panel.c"
	} else {
		Indicator* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 434 "panel.vala"
		_tmp3_ = self->priv->m_indicator;
#line 434 "panel.vala"
		_tmp4_ = panel_create_activate_menu (self, FALSE);
#line 434 "panel.vala"
		_tmp5_ = _tmp4_;
#line 434 "panel.vala"
		indicator_set_menu (_tmp3_, _tmp5_);
#line 434 "panel.vala"
		_g_object_unref0 (_tmp5_);
#line 2670 "panel.c"
	}
}

static void
___lambda92__indicator_secondary_activate (Indicator* _sender,
                                           gpointer self)
{
#line 428 "panel.vala"
	__lambda92_ ((Panel*) self);
#line 2680 "panel.c"
}

static void
panel_init_indicator (Panel* self)
{
	Indicator* _tmp0_;
	Indicator* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Indicator* _tmp4_;
	gulong _tmp5_;
	Indicator* _tmp6_;
	gulong _tmp7_;
	Indicator* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenu* _tmp10_;
#line 415 "panel.vala"
	g_return_if_fail (self != NULL);
#line 416 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_INDICATOR;
#line 417 "panel.vala"
	_tmp0_ = indicator_new ("ibus-ui-gtk3", INDICATOR_CATEGORY_APPLICATION_STATUS);
#line 417 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 417 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 417 "panel.vala"
	self->priv->m_indicator = _tmp0_;
#line 419 "panel.vala"
	_tmp1_ = self->priv->m_indicator;
#line 419 "panel.vala"
	_tmp2_ = g_strdup_printf ("%s\n%s", _ ("IBus Panel"), _ ("You can toggle the activate menu and context one with " "clicking the mouse middle button on the panel icon."));
#line 419 "panel.vala"
	_tmp3_ = _tmp2_;
#line 419 "panel.vala"
	indicator_set_title (_tmp1_, _tmp3_);
#line 419 "panel.vala"
	_g_free0 (_tmp3_);
#line 423 "panel.vala"
	_tmp4_ = self->priv->m_indicator;
#line 423 "panel.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "registered-status-notifier-item", (GCallback) ___lambda91__indicator_registered_status_notifier_item, self, 0);
#line 423 "panel.vala"
	self->priv->m_registered_status_notifier_item_id = _tmp5_;
#line 428 "panel.vala"
	_tmp6_ = self->priv->m_indicator;
#line 428 "panel.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "secondary-activate", (GCallback) ___lambda92__indicator_secondary_activate, self, 0);
#line 428 "panel.vala"
	self->priv->m_popup_menu_id = _tmp7_;
#line 436 "panel.vala"
	_tmp8_ = self->priv->m_indicator;
#line 436 "panel.vala"
	_tmp9_ = panel_create_activate_menu (self, FALSE);
#line 436 "panel.vala"
	_tmp10_ = _tmp9_;
#line 436 "panel.vala"
	indicator_set_menu (_tmp8_, _tmp10_);
#line 436 "panel.vala"
	_g_object_unref0 (_tmp10_);
#line 2741 "panel.c"
}

static void
_panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 449 "panel.vala"
	panel_init_status_icon_menu ((Panel*) self);
#line 2751 "panel.c"
}

static void
panel_init_status_icon (Panel* self)
{
	GtkStatusIcon* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkStatusIcon* _tmp2_;
	GtkStatusIcon* _tmp3_;
#line 440 "panel.vala"
	g_return_if_fail (self != NULL);
#line 441 "panel.vala"
	_tmp0_ = gtk_status_icon_new ();
#line 441 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 441 "panel.vala"
	self->priv->m_status_icon = _tmp0_;
#line 442 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 442 "panel.vala"
	gtk_status_icon_set_name (_tmp1_, "ibus-ui-gtk");
#line 443 "panel.vala"
	_tmp2_ = self->priv->m_status_icon;
#line 443 "panel.vala"
	gtk_status_icon_set_title (_tmp2_, _ ("IBus Panel"));
#line 446 "panel.vala"
	_tmp3_ = self->priv->m_status_icon;
#line 446 "panel.vala"
	if (gtk_status_icon_get_size (_tmp3_) > 0) {
#line 447 "panel.vala"
		panel_init_status_icon_menu (self);
#line 2783 "panel.c"
	} else {
		GtkStatusIcon* _tmp4_;
#line 449 "panel.vala"
		_tmp4_ = self->priv->m_status_icon;
#line 449 "panel.vala"
		g_signal_connect_object ((GObject*) _tmp4_, "notify::size", (GCallback) _panel_init_status_icon_menu_g_object_notify, self, 0);
#line 2790 "panel.c"
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 452 "panel.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 452 "panel.vala"
	return _data11_;
#line 2801 "panel.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 452 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2811 "panel.c"
		Panel* self;
#line 452 "panel.vala"
		self = _data11_->self;
#line 452 "panel.vala"
		(_data11_->func_target_destroy_notify == NULL) ? NULL : (_data11_->func_target_destroy_notify (_data11_->func_target), NULL);
#line 452 "panel.vala"
		_data11_->func = NULL;
#line 452 "panel.vala"
		_data11_->func_target = NULL;
#line 452 "panel.vala"
		_data11_->func_target_destroy_notify = NULL;
#line 452 "panel.vala"
		_g_object_unref0 (_data11_->window);
#line 452 "panel.vala"
		_g_object_unref0 (self);
#line 452 "panel.vala"
		g_slice_free (Block11Data, _data11_);
#line 2829 "panel.c"
	}
}

static void
__lambda100_ (Block11Data* _data11_,
              guint b,
              guint t)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 490 "panel.vala"
	self = _data11_->self;
#line 491 "panel.vala"
	_tmp0_ = panel_create_context_menu (self, TRUE);
#line 491 "panel.vala"
	_tmp1_ = _tmp0_;
#line 491 "panel.vala"
	_tmp2_ = _data11_->area;
#line 491 "panel.vala"
	_tmp3_ = _data11_->window;
#line 491 "panel.vala"
	_tmp4_ = _data11_->func;
#line 491 "panel.vala"
	_tmp4__target = _data11_->func_target;
#line 491 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 491 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2863 "panel.c"
}

static void
___lambda100__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                          guint button,
                                          guint activate_time,
                                          gpointer self)
{
#line 490 "panel.vala"
	__lambda100_ (self, button, activate_time);
#line 2874 "panel.c"
}

static void
__lambda101_ (Block11Data* _data11_)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 495 "panel.vala"
	self = _data11_->self;
#line 496 "panel.vala"
	_tmp0_ = panel_create_activate_menu (self, TRUE);
#line 496 "panel.vala"
	_tmp1_ = _tmp0_;
#line 496 "panel.vala"
	_tmp2_ = _data11_->area;
#line 496 "panel.vala"
	_tmp3_ = _data11_->window;
#line 496 "panel.vala"
	_tmp4_ = _data11_->func;
#line 496 "panel.vala"
	_tmp4__target = _data11_->func_target;
#line 496 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 496 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2905 "panel.c"
}

static void
___lambda101__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                        gpointer self)
{
#line 495 "panel.vala"
	__lambda101_ (self);
#line 2914 "panel.c"
}

static void
panel_init_status_icon_menu (Panel* self)
{
	Block11Data* _data11_;
	GdkRectangle _tmp0_ = {0};
	GtkStatusIcon* _tmp1_;
	GdkX11Display* display = NULL;
	GdkX11Display* _tmp2_;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	GtkStatusIcon* _tmp5_;
	GdkX11Window* _tmp6_;
	GdkWindow* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GdkWindow* _tmp9_;
	GdkWindow* _tmp19_;
	GtkOrientation orient = 0;
	GtkStatusIcon* _tmp20_;
	GdkRectangle _tmp21_ = {0};
	GtkOrientation _tmp22_ = 0;
	gint win_x = 0;
	gint win_y = 0;
	GdkWindow* _tmp23_;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GtkStatusIcon* _tmp26_;
	gulong _tmp27_;
	GtkStatusIcon* _tmp28_;
	gulong _tmp29_;
#line 452 "panel.vala"
	g_return_if_fail (self != NULL);
#line 452 "panel.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 452 "panel.vala"
	_data11_->_ref_count_ = 1;
#line 452 "panel.vala"
	_data11_->self = g_object_ref (self);
#line 453 "panel.vala"
	_tmp0_.x = 0;
#line 453 "panel.vala"
	_tmp0_.y = 0;
#line 453 "panel.vala"
	_tmp0_.width = 0;
#line 453 "panel.vala"
	_tmp0_.height = 0;
#line 453 "panel.vala"
	_data11_->area = _tmp0_;
#line 454 "panel.vala"
	_data11_->window = NULL;
#line 455 "panel.vala"
	_data11_->func = NULL;
#line 455 "panel.vala"
	_data11_->func_target = NULL;
#line 455 "panel.vala"
	_data11_->func_target_destroy_notify = NULL;
#line 456 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 456 "panel.vala"
	gtk_status_icon_set_from_icon_name (_tmp1_, "ibus-keyboard");
#line 457 "panel.vala"
	_tmp2_ = binding_common_get_xdisplay (FALSE);
#line 457 "panel.vala"
	display = _tmp2_;
#line 458 "panel.vala"
	_tmp3_ = display;
#line 458 "panel.vala"
	if (_tmp3_ == NULL) {
#line 459 "panel.vala"
		g_warning ("panel.vala:459: No Gdk.X11.Display");
#line 460 "panel.vala"
		_g_object_unref0 (display);
#line 460 "panel.vala"
		block11_data_unref (_data11_);
#line 460 "panel.vala"
		_data11_ = NULL;
#line 460 "panel.vala"
		return;
#line 2994 "panel.c"
	}
#line 462 "panel.vala"
	_tmp4_ = display;
#line 462 "panel.vala"
	_tmp5_ = self->priv->m_status_icon;
#line 462 "panel.vala"
	_tmp6_ = gdk_x11_window_lookup_for_display (_tmp4_, (Window) gtk_status_icon_get_x11_window_id (_tmp5_));
#line 462 "panel.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_window_get_type ()) ? ((GdkWindow*) _tmp6_) : NULL);
#line 462 "panel.vala"
	_g_object_unref0 (_data11_->window);
#line 462 "panel.vala"
	_data11_->window = _tmp7_;
#line 465 "panel.vala"
	_tmp9_ = _data11_->window;
#line 465 "panel.vala"
	if (_tmp9_ == NULL) {
#line 465 "panel.vala"
		_tmp8_ = self->priv->m_is_wayland;
#line 3014 "panel.c"
	} else {
#line 465 "panel.vala"
		_tmp8_ = FALSE;
#line 3018 "panel.c"
	}
#line 465 "panel.vala"
	if (_tmp8_) {
#line 3022 "panel.c"
		Display* xdisplay = NULL;
		GdkX11Display* _tmp10_;
		Display* _tmp11_;
		Window root = 0;
		Display* _tmp12_;
		GdkX11Display* _tmp13_;
		GdkX11Window* _tmp14_;
		GdkWindow* _tmp15_;
		GdkWindow* _tmp16_;
#line 466 "panel.vala"
		_tmp10_ = display;
#line 466 "panel.vala"
		_tmp11_ = gdk_x11_display_get_xdisplay (_tmp10_);
#line 466 "panel.vala"
		xdisplay = _tmp11_;
#line 467 "panel.vala"
		_tmp12_ = xdisplay;
#line 467 "panel.vala"
		root = DefaultRootWindow (_tmp12_);
#line 468 "panel.vala"
		_tmp13_ = display;
#line 468 "panel.vala"
		_tmp14_ = gdk_x11_window_lookup_for_display (_tmp13_, root);
#line 468 "panel.vala"
		_tmp15_ = _g_object_ref0 ((GdkWindow*) _tmp14_);
#line 468 "panel.vala"
		_g_object_unref0 (_data11_->window);
#line 468 "panel.vala"
		_data11_->window = _tmp15_;
#line 471 "panel.vala"
		_tmp16_ = _data11_->window;
#line 471 "panel.vala"
		if (_tmp16_ == NULL) {
#line 3056 "panel.c"
			GdkX11Display* _tmp17_;
			GdkX11Window* _tmp18_;
#line 472 "panel.vala"
			_tmp17_ = display;
#line 472 "panel.vala"
			_tmp18_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp17_, root);
#line 472 "panel.vala"
			_g_object_unref0 (_data11_->window);
#line 472 "panel.vala"
			_data11_->window = (GdkWindow*) _tmp18_;
#line 3067 "panel.c"
		}
	}
#line 477 "panel.vala"
	_tmp19_ = _data11_->window;
#line 477 "panel.vala"
	if (_tmp19_ == NULL) {
#line 478 "panel.vala"
		g_warning ("panel.vala:478: StatusIcon does not have GdkWindow");
#line 479 "panel.vala"
		_g_object_unref0 (display);
#line 479 "panel.vala"
		block11_data_unref (_data11_);
#line 479 "panel.vala"
		_data11_ = NULL;
#line 479 "panel.vala"
		return;
#line 3084 "panel.c"
	}
#line 482 "panel.vala"
	_tmp20_ = self->priv->m_status_icon;
#line 482 "panel.vala"
	gtk_status_icon_get_geometry (_tmp20_, NULL, &_tmp21_, &_tmp22_);
#line 482 "panel.vala"
	_data11_->area = _tmp21_;
#line 482 "panel.vala"
	orient = _tmp22_;
#line 483 "panel.vala"
	win_x = 0;
#line 484 "panel.vala"
	win_y = 0;
#line 485 "panel.vala"
	_tmp23_ = _data11_->window;
#line 485 "panel.vala"
	gdk_window_get_origin (_tmp23_, &_tmp24_, &_tmp25_);
#line 485 "panel.vala"
	win_x = _tmp24_;
#line 485 "panel.vala"
	win_y = _tmp25_;
#line 488 "panel.vala"
	_data11_->area.x = _data11_->area.x - win_x;
#line 489 "panel.vala"
	_data11_->area.y = _data11_->area.y - win_y;
#line 490 "panel.vala"
	_tmp26_ = self->priv->m_status_icon;
#line 490 "panel.vala"
	_tmp27_ = g_signal_connect_data (_tmp26_, "popup-menu", (GCallback) ___lambda100__gtk_status_icon_popup_menu, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 490 "panel.vala"
	self->priv->m_popup_menu_id = _tmp27_;
#line 495 "panel.vala"
	_tmp28_ = self->priv->m_status_icon;
#line 495 "panel.vala"
	_tmp29_ = g_signal_connect_data (_tmp28_, "activate", (GCallback) ___lambda101__gtk_status_icon_activate, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 495 "panel.vala"
	self->priv->m_activate_id = _tmp29_;
#line 452 "panel.vala"
	_g_object_unref0 (display);
#line 452 "panel.vala"
	block11_data_unref (_data11_);
#line 452 "panel.vala"
	_data11_ = NULL;
#line 3128 "panel.c"
}

static void
_panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                               gpointer self)
{
#line 511 "panel.vala"
	panel_handle_engine_switch_normal ((Panel*) self, event);
#line 3137 "panel.c"
}

static void
_panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                gpointer self)
{
#line 511 "panel.vala"
	panel_handle_engine_switch_reverse ((Panel*) self, event);
#line 3146 "panel.c"
}

static void
_vala_array_add18 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 526 "panel.vala"
	if ((*length) == (*size)) {
#line 526 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 526 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 3161 "panel.c"
	}
#line 526 "panel.vala"
	(*array)[(*length)++] = *value;
#line 3165 "panel.c"
}

static void
_vala_array_add19 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 531 "panel.vala"
	if ((*length) == (*size)) {
#line 531 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 531 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 3180 "panel.c"
	}
#line 531 "panel.vala"
	(*array)[(*length)++] = *value;
#line 3184 "panel.c"
}

static void
panel_bind_switch_shortcut (Panel* self)
{
	gchar** accelerators = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint accelerators_length1;
	gint _accelerators_size_;
	KeybindingManager* keybinding_manager = NULL;
	KeybindingManager* _tmp3_;
	BindingCommonKeyEventFuncType ftype = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	IBusProcessKeyEventData* keys = NULL;
	IBusProcessKeyEventData* _tmp8_;
	gint keys_length1;
	gint _keys_size_;
	IBusProcessKeyEventData key = {0};
	GList* _tmp9_;
	IBusProcessKeyEventData* _tmp23_;
	gint _tmp23__length1;
	IBusProcessKeyEventData _tmp24_ = {0};
	IBusProcessKeyEventData _tmp25_;
	IBusBus* _tmp26_;
	IBusProcessKeyEventData* _tmp27_;
	gint _tmp27__length1;
#line 502 "panel.vala"
	g_return_if_fail (self != NULL);
#line 503 "panel.vala"
	_tmp0_ = self->priv->m_settings_hotkey;
#line 503 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "triggers");
#line 503 "panel.vala"
	accelerators = _tmp2_;
#line 503 "panel.vala"
	accelerators_length1 = _vala_array_length (_tmp1_);
#line 503 "panel.vala"
	_accelerators_size_ = accelerators_length1;
#line 505 "panel.vala"
	_tmp3_ = keybinding_manager_get_instance (self->priv->m_is_wayland_im);
#line 505 "panel.vala"
	keybinding_manager = _tmp3_;
#line 508 "panel.vala"
	ftype = BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER;
#line 510 "panel.vala"
	_tmp4_ = accelerators;
#line 510 "panel.vala"
	_tmp4__length1 = accelerators_length1;
#line 3236 "panel.c"
	{
		gchar** accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 510 "panel.vala"
		accelerator_collection = _tmp4_;
#line 510 "panel.vala"
		accelerator_collection_length1 = _tmp4__length1;
#line 510 "panel.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 3248 "panel.c"
			gchar* _tmp5_;
			gchar* accelerator = NULL;
#line 510 "panel.vala"
			_tmp5_ = g_strdup (accelerator_collection[accelerator_it]);
#line 510 "panel.vala"
			accelerator = _tmp5_;
#line 3255 "panel.c"
			{
				KeybindingManager* _tmp6_;
				const gchar* _tmp7_;
#line 511 "panel.vala"
				_tmp6_ = keybinding_manager;
#line 511 "panel.vala"
				_tmp7_ = accelerator;
#line 511 "panel.vala"
				binding_common_keybinding_manager_bind (_tmp6_, &self->priv->m_keybindings, _tmp7_, ftype, _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func, self, _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func, self);
#line 510 "panel.vala"
				_g_free0 (accelerator);
#line 3267 "panel.c"
			}
		}
	}
#line 520 "panel.vala"
	if (!self->priv->m_is_wayland) {
#line 521 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 521 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 521 "panel.vala"
		return;
#line 3279 "panel.c"
	}
#line 522 "panel.vala"
	_tmp8_ = g_new0 (IBusProcessKeyEventData, 0);
#line 522 "panel.vala"
	keys = _tmp8_;
#line 522 "panel.vala"
	keys_length1 = 0;
#line 522 "panel.vala"
	_keys_size_ = keys_length1;
#line 524 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 3291 "panel.c"
	{
		GList* kb_collection = NULL;
		GList* kb_it = NULL;
#line 524 "panel.vala"
		kb_collection = _tmp9_;
#line 524 "panel.vala"
		for (kb_it = kb_collection; kb_it != NULL; kb_it = kb_it->next) {
#line 3299 "panel.c"
			BindingCommonKeybinding* _tmp10_;
			BindingCommonKeybinding* kb = NULL;
#line 524 "panel.vala"
			_tmp10_ = _g_object_ref0 ((BindingCommonKeybinding*) kb_it->data);
#line 524 "panel.vala"
			kb = _tmp10_;
#line 3306 "panel.c"
			{
				gint _tmp11_ = 0;
				BindingCommonKeybinding* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				BindingCommonKeybinding* _tmp15_;
				guint _tmp16_;
				guint _tmp17_;
				BindingCommonKeybinding* _tmp18_;
				GdkModifierType _tmp19_;
				GdkModifierType _tmp20_;
				IBusProcessKeyEventData _tmp21_ = {0};
				IBusProcessKeyEventData _tmp22_;
#line 525 "panel.vala"
				_tmp12_ = kb;
#line 525 "panel.vala"
				_tmp13_ = binding_common_keybinding_get_reverse (_tmp12_);
#line 525 "panel.vala"
				_tmp14_ = _tmp13_;
#line 525 "panel.vala"
				if (_tmp14_) {
#line 525 "panel.vala"
					_tmp11_ = 1;
#line 3330 "panel.c"
				} else {
#line 525 "panel.vala"
					_tmp11_ = 0;
#line 3334 "panel.c"
				}
#line 525 "panel.vala"
				_tmp15_ = kb;
#line 525 "panel.vala"
				_tmp16_ = binding_common_keybinding_get_keysym (_tmp15_);
#line 525 "panel.vala"
				_tmp17_ = _tmp16_;
#line 525 "panel.vala"
				_tmp18_ = kb;
#line 525 "panel.vala"
				_tmp19_ = binding_common_keybinding_get_modifiers (_tmp18_);
#line 525 "panel.vala"
				_tmp20_ = _tmp19_;
#line 525 "panel.vala"
				_tmp21_.keyval = _tmp17_;
#line 525 "panel.vala"
				_tmp21_.keycode = (guint) _tmp11_;
#line 525 "panel.vala"
				_tmp21_.state = (guint) _tmp20_;
#line 525 "panel.vala"
				key = _tmp21_;
#line 526 "panel.vala"
				_tmp22_ = key;
#line 526 "panel.vala"
				_vala_array_add18 (&keys, &keys_length1, &_keys_size_, &_tmp22_);
#line 524 "panel.vala"
				_g_object_unref0 (kb);
#line 3362 "panel.c"
			}
		}
	}
#line 528 "panel.vala"
	_tmp23_ = keys;
#line 528 "panel.vala"
	_tmp23__length1 = keys_length1;
#line 528 "panel.vala"
	if (_tmp23__length1 == 0) {
#line 529 "panel.vala"
		keys = (g_free (keys), NULL);
#line 529 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 529 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 529 "panel.vala"
		return;
#line 3380 "panel.c"
	}
#line 530 "panel.vala"
	_tmp24_.keyval = (guint) 0;
#line 530 "panel.vala"
	key = _tmp24_;
#line 531 "panel.vala"
	_tmp25_ = key;
#line 531 "panel.vala"
	_vala_array_add19 (&keys, &keys_length1, &_keys_size_, &_tmp25_);
#line 532 "panel.vala"
	_tmp26_ = self->priv->m_bus;
#line 532 "panel.vala"
	_tmp27_ = keys;
#line 532 "panel.vala"
	_tmp27__length1 = keys_length1;
#line 532 "panel.vala"
	ibus_bus_set_global_shortcut_keys_async (_tmp26_, IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER, _tmp27_, -1, NULL, NULL, NULL);
#line 502 "panel.vala"
	keys = (g_free (keys), NULL);
#line 502 "panel.vala"
	_g_object_unref0 (keybinding_manager);
#line 502 "panel.vala"
	accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 3404 "panel.c"
}

/**
     * panel_get_engines_from_xkb:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus xkb engines
     *
     * Made ibus engines from the current XKB keymaps.
     * This returns only XKB engines whose name start with "xkb:".
     */
static GList*
panel_get_engines_from_xkb (Panel* self,
                            GList* engines)
{
	gchar* layouts = NULL;
	gchar* variants = NULL;
	gchar* option = NULL;
	XKBLayout* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GList* xkb_engines = NULL;
	IBusEngineDesc* us_engine = NULL;
	IBusEngineDesc* _tmp4_;
	gchar** layout_array = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint layout_array_length1;
	gint _layout_array_size_;
	gchar** variant_array = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint variant_array_length1;
	gint _variant_array_size_;
	GList* _tmp46_;
	GList* result;
#line 566 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 571 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 571 "panel.vala"
	xkb_layout_get_layout (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 571 "panel.vala"
	_g_free0 (layouts);
#line 571 "panel.vala"
	layouts = _tmp1_;
#line 571 "panel.vala"
	_g_free0 (variants);
#line 571 "panel.vala"
	variants = _tmp2_;
#line 571 "panel.vala"
	_g_free0 (option);
#line 571 "panel.vala"
	option = _tmp3_;
#line 573 "panel.vala"
	xkb_engines = NULL;
#line 575 "panel.vala"
	_tmp4_ = ibus_engine_desc_new ("xkb:us::eng", "", "", "", "", "", "", "");
#line 575 "panel.vala"
	g_object_ref_sink (_tmp4_);
#line 575 "panel.vala"
	us_engine = _tmp4_;
#line 578 "panel.vala"
	_tmp5_ = layouts;
#line 578 "panel.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ",", 0);
#line 578 "panel.vala"
	layout_array = _tmp7_;
#line 578 "panel.vala"
	layout_array_length1 = _vala_array_length (_tmp6_);
#line 578 "panel.vala"
	_layout_array_size_ = layout_array_length1;
#line 579 "panel.vala"
	_tmp8_ = variants;
#line 579 "panel.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ",", 0);
#line 579 "panel.vala"
	variant_array = _tmp10_;
#line 579 "panel.vala"
	variant_array_length1 = _vala_array_length (_tmp9_);
#line 579 "panel.vala"
	_variant_array_size_ = variant_array_length1;
#line 3490 "panel.c"
	{
		gint i = 0;
#line 581 "panel.vala"
		i = 0;
#line 3495 "panel.c"
		{
			gboolean _tmp11_ = FALSE;
#line 581 "panel.vala"
			_tmp11_ = TRUE;
#line 581 "panel.vala"
			while (TRUE) {
#line 3502 "panel.c"
				gchar** _tmp13_;
				gint _tmp13__length1;
				gchar* layout = NULL;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* variant = NULL;
				IBusEngineDesc* current_engine = NULL;
				gchar** _tmp17_;
				gint _tmp17__length1;
				const gchar* _tmp21_;
				IBusEngineDesc* _tmp36_;
#line 581 "panel.vala"
				if (!_tmp11_) {
#line 3518 "panel.c"
					gint _tmp12_;
#line 581 "panel.vala"
					_tmp12_ = i;
#line 581 "panel.vala"
					i = _tmp12_ + 1;
#line 3524 "panel.c"
				}
#line 581 "panel.vala"
				_tmp11_ = FALSE;
#line 581 "panel.vala"
				_tmp13_ = layout_array;
#line 581 "panel.vala"
				_tmp13__length1 = layout_array_length1;
#line 581 "panel.vala"
				if (!(i < _tmp13__length1)) {
#line 581 "panel.vala"
					break;
#line 3536 "panel.c"
				}
#line 582 "panel.vala"
				_tmp14_ = layout_array;
#line 582 "panel.vala"
				_tmp14__length1 = layout_array_length1;
#line 582 "panel.vala"
				_tmp15_ = _tmp14_[i];
#line 582 "panel.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 582 "panel.vala"
				layout = _tmp16_;
#line 583 "panel.vala"
				variant = NULL;
#line 584 "panel.vala"
				current_engine = NULL;
#line 586 "panel.vala"
				_tmp17_ = variant_array;
#line 586 "panel.vala"
				_tmp17__length1 = variant_array_length1;
#line 586 "panel.vala"
				if (i < _tmp17__length1) {
#line 3558 "panel.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 587 "panel.vala"
					_tmp18_ = variant_array;
#line 587 "panel.vala"
					_tmp18__length1 = variant_array_length1;
#line 587 "panel.vala"
					_tmp19_ = _tmp18_[i];
#line 587 "panel.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 587 "panel.vala"
					_g_free0 (variant);
#line 587 "panel.vala"
					variant = _tmp20_;
#line 3575 "panel.c"
				}
#line 593 "panel.vala"
				_tmp21_ = variant;
#line 593 "panel.vala"
				if (_tmp21_ == NULL) {
#line 3581 "panel.c"
					gchar* _tmp22_;
#line 594 "panel.vala"
					_tmp22_ = g_strdup ("");
#line 594 "panel.vala"
					_g_free0 (variant);
#line 594 "panel.vala"
					variant = _tmp22_;
#line 3589 "panel.c"
				}
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
#line 596 "panel.vala"
					engine_collection = engines;
#line 596 "panel.vala"
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3598 "panel.c"
						IBusEngineDesc* engine = NULL;
#line 596 "panel.vala"
						engine = (IBusEngineDesc*) engine_it->data;
#line 3602 "panel.c"
						{
							gchar* name = NULL;
							IBusEngineDesc* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							const gchar* _tmp26_;
							gboolean _tmp27_ = FALSE;
							IBusEngineDesc* _tmp28_;
							const gchar* _tmp29_;
							const gchar* _tmp30_;
#line 598 "panel.vala"
							_tmp23_ = engine;
#line 598 "panel.vala"
							_tmp24_ = ibus_engine_desc_get_name (_tmp23_);
#line 598 "panel.vala"
							_tmp25_ = g_strdup (_tmp24_);
#line 598 "panel.vala"
							name = _tmp25_;
#line 599 "panel.vala"
							_tmp26_ = name;
#line 599 "panel.vala"
							if (!g_str_has_prefix (_tmp26_, "xkb:")) {
#line 600 "panel.vala"
								_g_free0 (name);
#line 600 "panel.vala"
								continue;
#line 3629 "panel.c"
							}
#line 602 "panel.vala"
							_tmp28_ = engine;
#line 602 "panel.vala"
							_tmp29_ = ibus_engine_desc_get_layout (_tmp28_);
#line 602 "panel.vala"
							_tmp30_ = layout;
#line 602 "panel.vala"
							if (g_strcmp0 (_tmp29_, _tmp30_) == 0) {
#line 3639 "panel.c"
								IBusEngineDesc* _tmp31_;
								const gchar* _tmp32_;
								const gchar* _tmp33_;
#line 603 "panel.vala"
								_tmp31_ = engine;
#line 603 "panel.vala"
								_tmp32_ = ibus_engine_desc_get_layout_variant (_tmp31_);
#line 603 "panel.vala"
								_tmp33_ = variant;
#line 603 "panel.vala"
								_tmp27_ = g_strcmp0 (_tmp32_, _tmp33_) == 0;
#line 3651 "panel.c"
							} else {
#line 602 "panel.vala"
								_tmp27_ = FALSE;
#line 3655 "panel.c"
							}
#line 602 "panel.vala"
							if (_tmp27_) {
#line 3659 "panel.c"
								IBusEngineDesc* _tmp34_;
								IBusEngineDesc* _tmp35_;
#line 604 "panel.vala"
								_tmp34_ = engine;
#line 604 "panel.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 604 "panel.vala"
								_g_object_unref0 (current_engine);
#line 604 "panel.vala"
								current_engine = _tmp35_;
#line 605 "panel.vala"
								_g_free0 (name);
#line 605 "panel.vala"
								break;
#line 3674 "panel.c"
							}
#line 596 "panel.vala"
							_g_free0 (name);
#line 3678 "panel.c"
						}
					}
				}
#line 609 "panel.vala"
				_tmp36_ = current_engine;
#line 609 "panel.vala"
				if (_tmp36_ != NULL) {
#line 3686 "panel.c"
					IBusEngineDesc* _tmp37_;
					IBusEngineDesc* _tmp38_;
#line 610 "panel.vala"
					_tmp37_ = current_engine;
#line 610 "panel.vala"
					_tmp38_ = _g_object_ref0 (_tmp37_);
#line 610 "panel.vala"
					xkb_engines = g_list_append (xkb_engines, _tmp38_);
#line 3695 "panel.c"
				} else {
					GList* _tmp39_;
					IBusEngineDesc* _tmp40_;
					GList* _tmp41_;
#line 611 "panel.vala"
					_tmp39_ = xkb_engines;
#line 611 "panel.vala"
					_tmp40_ = us_engine;
#line 611 "panel.vala"
					_tmp41_ = g_list_find (_tmp39_, _tmp40_);
#line 611 "panel.vala"
					if (_tmp41_ == NULL) {
#line 3708 "panel.c"
						const gchar* _tmp42_;
						const gchar* _tmp43_;
						IBusEngineDesc* _tmp44_;
						IBusEngineDesc* _tmp45_;
#line 612 "panel.vala"
						_tmp42_ = layout;
#line 612 "panel.vala"
						_tmp43_ = variant;
#line 612 "panel.vala"
						g_warning ("panel.vala:612: Fallback %s(%s) to us layout.", _tmp42_, _tmp43_);
#line 613 "panel.vala"
						_tmp44_ = us_engine;
#line 613 "panel.vala"
						_tmp45_ = _g_object_ref0 (_tmp44_);
#line 613 "panel.vala"
						xkb_engines = g_list_append (xkb_engines, _tmp45_);
#line 3725 "panel.c"
					}
				}
#line 581 "panel.vala"
				_g_object_unref0 (current_engine);
#line 581 "panel.vala"
				_g_free0 (variant);
#line 581 "panel.vala"
				_g_free0 (layout);
#line 3734 "panel.c"
			}
		}
	}
#line 617 "panel.vala"
	_tmp46_ = xkb_engines;
#line 617 "panel.vala"
	if (g_list_length (_tmp46_) == ((guint) 0)) {
#line 618 "panel.vala"
		g_warning ("panel.vala:618: Not found IBus XKB engines from the session.");
#line 3744 "panel.c"
	}
#line 620 "panel.vala"
	result = xkb_engines;
#line 620 "panel.vala"
	variant_array = (_vala_array_free (variant_array, variant_array_length1, (GDestroyNotify) g_free), NULL);
#line 620 "panel.vala"
	layout_array = (_vala_array_free (layout_array, layout_array_length1, (GDestroyNotify) g_free), NULL);
#line 620 "panel.vala"
	_g_object_unref0 (us_engine);
#line 620 "panel.vala"
	_g_free0 (option);
#line 620 "panel.vala"
	_g_free0 (variants);
#line 620 "panel.vala"
	_g_free0 (layouts);
#line 620 "panel.vala"
	return result;
#line 3762 "panel.c"
}

/**
     * panel_get_engines_from_locale:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus im engines
     *
     * Made ibus engines from the current locale and IBus.EngineDesc.lang .
     * This returns non-XKB engines whose name does not start "xkb:".
     */
static gint
__lambda112_ (IBusEngineDesc* a,
              IBusEngineDesc* b)
{
	gint result;
#line 672 "panel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 672 "panel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 673 "panel.vala"
	result = ((gint) ibus_engine_desc_get_rank (b)) - ((gint) ibus_engine_desc_get_rank (a));
#line 673 "panel.vala"
	return result;
#line 3787 "panel.c"
}

static gint
___lambda112__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = __lambda112_ ((IBusEngineDesc*) a, (IBusEngineDesc*) b);
#line 672 "panel.vala"
	return result;
#line 3798 "panel.c"
}

static GList*
panel_get_engines_from_locale (Panel* self,
                               GList* engines)
{
	gchar* locale = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* lang = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GList* im_engines = NULL;
	GList* _tmp22_;
	GList* _tmp40_;
	GList* result;
#line 632 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 634 "panel.vala"
	_tmp0_ = setlocale (LC_CTYPE, NULL);
#line 634 "panel.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 634 "panel.vala"
	locale = _tmp1_;
#line 636 "panel.vala"
	_tmp2_ = locale;
#line 636 "panel.vala"
	if (_tmp2_ == NULL) {
#line 3834 "panel.c"
		gchar* _tmp3_;
#line 637 "panel.vala"
		_tmp3_ = g_strdup ("C");
#line 637 "panel.vala"
		_g_free0 (locale);
#line 637 "panel.vala"
		locale = _tmp3_;
#line 3842 "panel.c"
	}
#line 639 "panel.vala"
	_tmp4_ = locale;
#line 639 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ".", 0);
#line 639 "panel.vala"
	_tmp7_ = _tmp6_;
#line 639 "panel.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 639 "panel.vala"
	_tmp8_ = _tmp7_[0];
#line 639 "panel.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 639 "panel.vala"
	_tmp10_ = _tmp9_;
#line 639 "panel.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 639 "panel.vala"
	lang = _tmp10_;
#line 640 "panel.vala"
	im_engines = NULL;
#line 3864 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 643 "panel.vala"
		engine_collection = engines;
#line 643 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3872 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 643 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3876 "panel.c"
			{
				gchar* name = NULL;
				IBusEngineDesc* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				gboolean _tmp15_ = FALSE;
				IBusEngineDesc* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 644 "panel.vala"
				_tmp11_ = engine;
#line 644 "panel.vala"
				_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
#line 644 "panel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 644 "panel.vala"
				name = _tmp13_;
#line 646 "panel.vala"
				_tmp14_ = name;
#line 646 "panel.vala"
				if (g_str_has_prefix (_tmp14_, "xkb:")) {
#line 647 "panel.vala"
					_g_free0 (name);
#line 647 "panel.vala"
					continue;
#line 3903 "panel.c"
				}
#line 649 "panel.vala"
				_tmp16_ = engine;
#line 649 "panel.vala"
				_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
#line 649 "panel.vala"
				_tmp18_ = lang;
#line 649 "panel.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 3913 "panel.c"
					IBusEngineDesc* _tmp19_;
#line 650 "panel.vala"
					_tmp19_ = engine;
#line 650 "panel.vala"
					_tmp15_ = ibus_engine_desc_get_rank (_tmp19_) > ((guint) 0);
#line 3919 "panel.c"
				} else {
#line 649 "panel.vala"
					_tmp15_ = FALSE;
#line 3923 "panel.c"
				}
#line 649 "panel.vala"
				if (_tmp15_) {
#line 3927 "panel.c"
					IBusEngineDesc* _tmp20_;
					IBusEngineDesc* _tmp21_;
#line 651 "panel.vala"
					_tmp20_ = engine;
#line 651 "panel.vala"
					_tmp21_ = _g_object_ref0 (_tmp20_);
#line 651 "panel.vala"
					im_engines = g_list_append (im_engines, _tmp21_);
#line 3936 "panel.c"
				}
#line 643 "panel.vala"
				_g_free0 (name);
#line 3940 "panel.c"
			}
		}
	}
#line 654 "panel.vala"
	_tmp22_ = im_engines;
#line 654 "panel.vala"
	if (g_list_length (_tmp22_) == ((guint) 0)) {
#line 3948 "panel.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 655 "panel.vala"
		_tmp23_ = lang;
#line 655 "panel.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "_", 0);
#line 655 "panel.vala"
		_tmp26_ = _tmp25_;
#line 655 "panel.vala"
		_tmp26__length1 = _vala_array_length (_tmp24_);
#line 655 "panel.vala"
		_tmp27_ = _tmp26_[0];
#line 655 "panel.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 655 "panel.vala"
		_g_free0 (lang);
#line 655 "panel.vala"
		lang = _tmp28_;
#line 655 "panel.vala"
		_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 3974 "panel.c"
		{
			GList* engine_collection = NULL;
			GList* engine_it = NULL;
#line 657 "panel.vala"
			engine_collection = engines;
#line 657 "panel.vala"
			for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3982 "panel.c"
				IBusEngineDesc* engine = NULL;
#line 657 "panel.vala"
				engine = (IBusEngineDesc*) engine_it->data;
#line 3986 "panel.c"
				{
					gchar* name = NULL;
					IBusEngineDesc* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_ = FALSE;
					IBusEngineDesc* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
#line 658 "panel.vala"
					_tmp29_ = engine;
#line 658 "panel.vala"
					_tmp30_ = ibus_engine_desc_get_name (_tmp29_);
#line 658 "panel.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 658 "panel.vala"
					name = _tmp31_;
#line 660 "panel.vala"
					_tmp32_ = name;
#line 660 "panel.vala"
					if (g_str_has_prefix (_tmp32_, "xkb:")) {
#line 661 "panel.vala"
						_g_free0 (name);
#line 661 "panel.vala"
						continue;
#line 4013 "panel.c"
					}
#line 663 "panel.vala"
					_tmp34_ = engine;
#line 663 "panel.vala"
					_tmp35_ = ibus_engine_desc_get_language (_tmp34_);
#line 663 "panel.vala"
					_tmp36_ = lang;
#line 663 "panel.vala"
					if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 4023 "panel.c"
						IBusEngineDesc* _tmp37_;
#line 664 "panel.vala"
						_tmp37_ = engine;
#line 664 "panel.vala"
						_tmp33_ = ibus_engine_desc_get_rank (_tmp37_) > ((guint) 0);
#line 4029 "panel.c"
					} else {
#line 663 "panel.vala"
						_tmp33_ = FALSE;
#line 4033 "panel.c"
					}
#line 663 "panel.vala"
					if (_tmp33_) {
#line 4037 "panel.c"
						IBusEngineDesc* _tmp38_;
						IBusEngineDesc* _tmp39_;
#line 665 "panel.vala"
						_tmp38_ = engine;
#line 665 "panel.vala"
						_tmp39_ = _g_object_ref0 (_tmp38_);
#line 665 "panel.vala"
						im_engines = g_list_append (im_engines, _tmp39_);
#line 4046 "panel.c"
					}
#line 657 "panel.vala"
					_g_free0 (name);
#line 4050 "panel.c"
				}
			}
		}
	}
#line 669 "panel.vala"
	_tmp40_ = im_engines;
#line 669 "panel.vala"
	if (g_list_length (_tmp40_) == ((guint) 0)) {
#line 670 "panel.vala"
		result = im_engines;
#line 670 "panel.vala"
		_g_free0 (lang);
#line 670 "panel.vala"
		_g_free0 (locale);
#line 670 "panel.vala"
		return result;
#line 4067 "panel.c"
	}
#line 672 "panel.vala"
	im_engines = g_list_sort (im_engines, ___lambda112__gcompare_func);
#line 676 "panel.vala"
	result = im_engines;
#line 676 "panel.vala"
	_g_free0 (lang);
#line 676 "panel.vala"
	_g_free0 (locale);
#line 676 "panel.vala"
	return result;
#line 4079 "panel.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 696 "panel.vala"
	if ((*length) == (*size)) {
#line 696 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 696 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4094 "panel.c"
	}
#line 696 "panel.vala"
	(*array)[(*length)++] = value;
#line 696 "panel.vala"
	(*array)[*length] = NULL;
#line 4100 "panel.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 698 "panel.vala"
	if ((*length) == (*size)) {
#line 698 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 698 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4115 "panel.c"
	}
#line 698 "panel.vala"
	(*array)[(*length)++] = value;
#line 698 "panel.vala"
	(*array)[*length] = NULL;
#line 4121 "panel.c"
}

static void
panel_init_engines_order (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_;
	GList* engines = NULL;
	IBusBus* _tmp10_;
	GList* _tmp11_;
	GList* xkb_engines = NULL;
	GList* _tmp12_;
	GList* _tmp13_;
	GList* im_engines = NULL;
	GList* _tmp14_;
	GList* _tmp15_;
	gchar** names = NULL;
	gchar** _tmp16_;
	gint names_length1;
	gint _names_size_;
	GList* _tmp17_;
	GList* _tmp21_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
#line 679 "panel.vala"
	g_return_if_fail (self != NULL);
#line 680 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 680 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 680 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "xkb-latin-layouts");
#line 680 "panel.vala"
	_tmp4_ = _tmp3_;
#line 680 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 680 "panel.vala"
	xkb_layout_set_latin_layouts (_tmp0_, _tmp4_, (gint) _vala_array_length (_tmp2_));
#line 680 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 683 "panel.vala"
	if (self->priv->inited_engines_order) {
#line 684 "panel.vala"
		return;
#line 4177 "panel.c"
	}
#line 686 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 686 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "preload-engines");
#line 686 "panel.vala"
	_tmp8_ = _tmp7_;
#line 686 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 686 "panel.vala"
	_tmp9_ = _vala_array_length (_tmp6_) > 0;
#line 686 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 686 "panel.vala"
	if (_tmp9_) {
#line 687 "panel.vala"
		return;
#line 4195 "panel.c"
	}
#line 689 "panel.vala"
	_tmp10_ = self->priv->m_bus;
#line 689 "panel.vala"
	_tmp11_ = ibus_bus_list_engines (_tmp10_);
#line 689 "panel.vala"
	engines = _tmp11_;
#line 690 "panel.vala"
	_tmp12_ = engines;
#line 690 "panel.vala"
	_tmp13_ = panel_get_engines_from_xkb (self, _tmp12_);
#line 690 "panel.vala"
	xkb_engines = _tmp13_;
#line 691 "panel.vala"
	_tmp14_ = engines;
#line 691 "panel.vala"
	_tmp15_ = panel_get_engines_from_locale (self, _tmp14_);
#line 691 "panel.vala"
	im_engines = _tmp15_;
#line 694 "panel.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 694 "panel.vala"
	names = _tmp16_;
#line 694 "panel.vala"
	names_length1 = 0;
#line 694 "panel.vala"
	_names_size_ = names_length1;
#line 695 "panel.vala"
	_tmp17_ = xkb_engines;
#line 4225 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 695 "panel.vala"
		engine_collection = _tmp17_;
#line 695 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 4233 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 695 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 4237 "panel.c"
			{
				IBusEngineDesc* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
#line 696 "panel.vala"
				_tmp18_ = engine;
#line 696 "panel.vala"
				_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 696 "panel.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 696 "panel.vala"
				_vala_array_add20 (&names, &names_length1, &_names_size_, _tmp20_);
#line 4250 "panel.c"
			}
		}
	}
#line 697 "panel.vala"
	_tmp21_ = im_engines;
#line 4256 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 697 "panel.vala"
		engine_collection = _tmp21_;
#line 697 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 4264 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 697 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 4268 "panel.c"
			{
				IBusEngineDesc* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 698 "panel.vala"
				_tmp22_ = engine;
#line 698 "panel.vala"
				_tmp23_ = ibus_engine_desc_get_name (_tmp22_);
#line 698 "panel.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 698 "panel.vala"
				_vala_array_add21 (&names, &names_length1, &_names_size_, _tmp24_);
#line 4281 "panel.c"
			}
		}
	}
#line 700 "panel.vala"
	_tmp25_ = self->priv->m_settings_general;
#line 700 "panel.vala"
	_tmp26_ = names;
#line 700 "panel.vala"
	_tmp26__length1 = names_length1;
#line 700 "panel.vala"
	g_settings_set_strv (_tmp25_, "preload-engines", _tmp26_);
#line 679 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 679 "panel.vala"
	(im_engines == NULL) ? NULL : (im_engines = (_g_list_free__g_object_unref0_ (im_engines), NULL));
#line 679 "panel.vala"
	(xkb_engines == NULL) ? NULL : (xkb_engines = (_g_list_free__g_object_unref0_ (xkb_engines), NULL));
#line 679 "panel.vala"
	(engines == NULL) ? NULL : (engines = (_g_list_free__g_object_unref0_ (engines), NULL));
#line 4301 "panel.c"
}

static void
panel_set_switcher_delay_time (Panel* self)
{
	GSettings* _tmp0_;
#line 704 "panel.vala"
	g_return_if_fail (self != NULL);
#line 705 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 705 "panel.vala"
	self->priv->m_switcher_delay_time = g_settings_get_int (_tmp0_, "switcher-delay-time");
#line 708 "panel.vala"
	if (self->priv->m_switcher_delay_time >= 0) {
#line 4316 "panel.c"
		Switcher* _tmp1_;
		Switcher* _tmp3_;
#line 709 "panel.vala"
		_tmp1_ = self->priv->m_switcher;
#line 709 "panel.vala"
		if (_tmp1_ != NULL) {
#line 4323 "panel.c"
			Switcher* _tmp2_;
#line 710 "panel.vala"
			_tmp2_ = self->priv->m_switcher;
#line 710 "panel.vala"
			switcher_set_popup_delay_time (_tmp2_, (guint) self->priv->m_switcher_delay_time);
#line 4329 "panel.c"
		}
#line 712 "panel.vala"
		_tmp3_ = self->priv->m_switcher_x11;
#line 712 "panel.vala"
		if (_tmp3_ != NULL) {
#line 4335 "panel.c"
			Switcher* _tmp4_;
#line 713 "panel.vala"
			_tmp4_ = self->priv->m_switcher_x11;
#line 713 "panel.vala"
			switcher_set_popup_delay_time (_tmp4_, (guint) self->priv->m_switcher_delay_time);
#line 4341 "panel.c"
		}
	}
}

static void
panel_set_use_system_keyboard_layout (Panel* self)
{
	GSettings* _tmp0_;
#line 720 "panel.vala"
	g_return_if_fail (self != NULL);
#line 721 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 721 "panel.vala"
	self->priv->m_use_system_keyboard_layout = g_settings_get_boolean (_tmp0_, "use-system-keyboard-layout");
#line 4356 "panel.c"
}

static void
panel_set_embed_preedit_text (Panel* self)
{
	GVariant* variant = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	IBusBus* _tmp3_;
	GVariant* _tmp4_;
#line 725 "panel.vala"
	g_return_if_fail (self != NULL);
#line 726 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 726 "panel.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "embed-preedit-text");
#line 726 "panel.vala"
	variant = _tmp1_;
#line 729 "panel.vala"
	_tmp2_ = variant;
#line 729 "panel.vala"
	if (_tmp2_ == NULL) {
#line 730 "panel.vala"
		_g_variant_unref0 (variant);
#line 730 "panel.vala"
		return;
#line 4384 "panel.c"
	}
#line 733 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 733 "panel.vala"
	_tmp4_ = variant;
#line 733 "panel.vala"
	ibus_bus_set_ibus_property (_tmp3_, "EmbedPreeditText", _tmp4_);
#line 725 "panel.vala"
	_g_variant_unref0 (variant);
#line 4394 "panel.c"
}

static void
panel_set_use_global_engine (Panel* self)
{
	GSettings* _tmp0_;
#line 736 "panel.vala"
	g_return_if_fail (self != NULL);
#line 737 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 737 "panel.vala"
	self->priv->m_use_global_engine = g_settings_get_boolean (_tmp0_, "use-global-engine");
#line 4407 "panel.c"
}

static void
panel_set_use_xmodmap (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
#line 741 "panel.vala"
	g_return_if_fail (self != NULL);
#line 742 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 742 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 742 "panel.vala"
	xkb_layout_set_use_xmodmap (_tmp0_, g_settings_get_boolean (_tmp1_, "use-xmodmap"));
#line 4423 "panel.c"
}

static void
panel_set_use_glyph_from_engine_lang (Panel* self)
{
	GSettings* _tmp0_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
#line 746 "panel.vala"
	g_return_if_fail (self != NULL);
#line 747 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 747 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 749 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 749 "panel.vala"
	_tmp2_ = ibus_bus_get_global_engine (_tmp1_);
#line 749 "panel.vala"
	engine = _tmp2_;
#line 750 "panel.vala"
	_tmp3_ = engine;
#line 750 "panel.vala"
	if (_tmp3_ != NULL) {
#line 4450 "panel.c"
		IBusEngineDesc* _tmp4_;
#line 751 "panel.vala"
		_tmp4_ = engine;
#line 751 "panel.vala"
		panel_set_language_from_engine (self, _tmp4_);
#line 4456 "panel.c"
	}
#line 746 "panel.vala"
	_g_object_unref0 (engine);
#line 4460 "panel.c"
}

static void
panel_set_show_icon_on_systray (Panel* self,
                                gboolean update_now)
{
#line 754 "panel.vala"
	g_return_if_fail (self != NULL);
#line 755 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4471 "panel.c"
		GtkStatusIcon* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GSettings* _tmp2_;
#line 756 "panel.vala"
		_tmp0_ = self->priv->m_status_icon;
#line 756 "panel.vala"
		if (_tmp0_ == NULL) {
#line 757 "panel.vala"
			return;
#line 4481 "panel.c"
		}
#line 760 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 760 "panel.vala"
		_tmp2_ = self->priv->m_settings_panel;
#line 760 "panel.vala"
		gtk_status_icon_set_visible (_tmp1_, g_settings_get_boolean (_tmp2_, "show-icon-on-systray"));
#line 4489 "panel.c"
	} else {
#line 764 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4493 "panel.c"
			Indicator* _tmp3_;
			GSettings* _tmp4_;
#line 765 "panel.vala"
			_tmp3_ = self->priv->m_indicator;
#line 765 "panel.vala"
			if (_tmp3_ == NULL) {
#line 766 "panel.vala"
				return;
#line 4502 "panel.c"
			}
#line 768 "panel.vala"
			_tmp4_ = self->priv->m_settings_panel;
#line 768 "panel.vala"
			if (g_settings_get_boolean (_tmp4_, "show-icon-on-systray")) {
#line 769 "panel.vala"
				self->priv->m_indicator_show_status = INDICATOR_STATUS_ACTIVE;
#line 4510 "panel.c"
			} else {
#line 771 "panel.vala"
				self->priv->m_indicator_show_status = INDICATOR_STATUS_PASSIVE;
#line 4514 "panel.c"
			}
#line 775 "panel.vala"
			if (update_now) {
#line 4518 "panel.c"
				Indicator* _tmp5_;
#line 776 "panel.vala"
				_tmp5_ = self->priv->m_indicator;
#line 776 "panel.vala"
				indicator_set_status (_tmp5_, self->priv->m_indicator_show_status);
#line 4524 "panel.c"
			}
		}
	}
}

static void
panel_set_lookup_table_orientation (Panel* self)
{
	CandidatePanel* _tmp0_;
#line 781 "panel.vala"
	g_return_if_fail (self != NULL);
#line 783 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 783 "panel.vala"
	if (_tmp0_ != NULL) {
#line 4540 "panel.c"
		CandidatePanel* _tmp1_;
		GSettings* _tmp2_;
#line 784 "panel.vala"
		_tmp1_ = self->priv->m_candidate_panel_active;
#line 784 "panel.vala"
		_tmp2_ = self->priv->m_settings_panel;
#line 784 "panel.vala"
		candidate_panel_set_vertical (_tmp1_, g_settings_get_int (_tmp2_, "lookup-table-orientation") == ((gint) IBUS_ORIENTATION_VERTICAL));
#line 4549 "panel.c"
	}
}

static void
panel_set_show_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 790 "panel.vala"
	g_return_if_fail (self != NULL);
#line 791 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 791 "panel.vala"
	if (_tmp0_ == NULL) {
#line 792 "panel.vala"
		return;
#line 4567 "panel.c"
	}
#line 794 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 794 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 794 "panel.vala"
	property_panel_set_show (_tmp1_, g_settings_get_int (_tmp2_, "show"));
#line 4575 "panel.c"
}

static void
panel_set_timeout_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 797 "panel.vala"
	g_return_if_fail (self != NULL);
#line 798 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 798 "panel.vala"
	if (_tmp0_ == NULL) {
#line 799 "panel.vala"
		return;
#line 4592 "panel.c"
	}
#line 801 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 801 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 801 "panel.vala"
	property_panel_set_auto_hide_timeout (_tmp1_, (guint) g_settings_get_int (_tmp2_, "auto-hide-timeout"));
#line 4600 "panel.c"
}

static void
panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 805 "panel.vala"
	g_return_if_fail (self != NULL);
#line 806 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 806 "panel.vala"
	if (_tmp0_ == NULL) {
#line 807 "panel.vala"
		return;
#line 4617 "panel.c"
	}
#line 809 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 809 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 809 "panel.vala"
	property_panel_set_follow_input_cursor_when_always_shown (_tmp1_, g_settings_get_boolean (_tmp2_, "follow-input-cursor-when-always-shown"));
#line 4625 "panel.c"
}

static void
panel_set_xkb_icon_rgba (Panel* self)
{
	gchar* spec = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp2_ = {0};
	const gchar* _tmp3_;
#line 814 "panel.vala"
	g_return_if_fail (self != NULL);
#line 815 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 815 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "xkb-icon-rgba");
#line 815 "panel.vala"
	spec = _tmp1_;
#line 817 "panel.vala"
	_tmp2_.red = (gdouble) 0;
#line 817 "panel.vala"
	rgba = _tmp2_;
#line 819 "panel.vala"
	_tmp3_ = spec;
#line 819 "panel.vala"
	if (!gdk_rgba_parse (&rgba, _tmp3_)) {
#line 4653 "panel.c"
		const gchar* _tmp4_;
		GdkRGBA _tmp5_ = {0};
#line 820 "panel.vala"
		_tmp4_ = spec;
#line 820 "panel.vala"
		g_warning ("panel.vala:820: invalid format of xkb-icon-rgba: %s", _tmp4_);
#line 821 "panel.vala"
		memset (&_tmp5_, 0, sizeof (GdkRGBA));
#line 821 "panel.vala"
		_tmp5_.red = 0.0;
#line 821 "panel.vala"
		_tmp5_.green = 0.0;
#line 821 "panel.vala"
		_tmp5_.blue = 0.0;
#line 821 "panel.vala"
		_tmp5_.alpha = 1.0;
#line 821 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp5_;
#line 4672 "panel.c"
	} else {
		GdkRGBA _tmp6_;
#line 824 "panel.vala"
		_tmp6_ = rgba;
#line 824 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp6_;
#line 4679 "panel.c"
	}
#line 826 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4683 "panel.c"
		GHashTable* _tmp7_;
#line 827 "panel.vala"
		_tmp7_ = self->priv->m_xkb_icon_pixbufs;
#line 827 "panel.vala"
		if (g_hash_table_size (_tmp7_) > ((guint) 0)) {
#line 4689 "panel.c"
			GHashTable* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GtkStatusIcon* _tmp10_;
#line 828 "panel.vala"
			_tmp8_ = self->priv->m_xkb_icon_pixbufs;
#line 828 "panel.vala"
			g_hash_table_remove_all (_tmp8_);
#line 830 "panel.vala"
			_tmp10_ = self->priv->m_status_icon;
#line 830 "panel.vala"
			if (_tmp10_ != NULL) {
#line 4701 "panel.c"
				Switcher* _tmp11_;
#line 830 "panel.vala"
				_tmp11_ = self->priv->m_switcher_active;
#line 830 "panel.vala"
				_tmp9_ = _tmp11_ != NULL;
#line 4707 "panel.c"
			} else {
#line 830 "panel.vala"
				_tmp9_ = FALSE;
#line 4711 "panel.c"
			}
#line 830 "panel.vala"
			if (_tmp9_) {
#line 831 "panel.vala"
				g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4717 "panel.c"
			}
		}
	} else {
#line 835 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4723 "panel.c"
			GHashTable* _tmp12_;
#line 836 "panel.vala"
			_tmp12_ = self->priv->m_xkb_icon_image;
#line 836 "panel.vala"
			if (g_hash_table_size (_tmp12_) > ((guint) 0)) {
#line 4729 "panel.c"
				GHashTable* _tmp13_;
				gboolean _tmp14_ = FALSE;
				Indicator* _tmp15_;
#line 837 "panel.vala"
				_tmp13_ = self->priv->m_xkb_icon_image;
#line 837 "panel.vala"
				g_hash_table_remove_all (_tmp13_);
#line 839 "panel.vala"
				_tmp15_ = self->priv->m_indicator;
#line 839 "panel.vala"
				if (_tmp15_ != NULL) {
#line 4741 "panel.c"
					Switcher* _tmp16_;
#line 839 "panel.vala"
					_tmp16_ = self->priv->m_switcher_active;
#line 839 "panel.vala"
					_tmp14_ = _tmp16_ != NULL;
#line 4747 "panel.c"
				} else {
#line 839 "panel.vala"
					_tmp14_ = FALSE;
#line 4751 "panel.c"
				}
#line 839 "panel.vala"
				if (_tmp14_) {
#line 840 "panel.vala"
					g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4757 "panel.c"
				}
			}
		}
	}
#line 814 "panel.vala"
	_g_free0 (spec);
#line 4764 "panel.c"
}

static void
panel_set_property_icon_delay_time (Panel* self)
{
	GSettings* _tmp0_;
#line 846 "panel.vala"
	g_return_if_fail (self != NULL);
#line 847 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 847 "panel.vala"
	self->priv->m_property_icon_delay_time = g_settings_get_int (_tmp0_, "property-icon-delay-time");
#line 4777 "panel.c"
}

static gint
panel_compare_versions (Panel* self,
                        const gchar* version1,
                        const gchar* version2)
{
	gchar** version1_list = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint version1_list_length1;
	gint _version1_list_size_;
	gchar** version2_list = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint version2_list_length1;
	gint _version2_list_size_;
	gint major1 = 0;
	gint minor1 = 0;
	gint micro1 = 0;
	gint major2 = 0;
	gint minor2 = 0;
	gint micro2 = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gint result;
#line 852 "panel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 852 "panel.vala"
	g_return_val_if_fail (version1 != NULL, 0);
#line 852 "panel.vala"
	g_return_val_if_fail (version2 != NULL, 0);
#line 853 "panel.vala"
	_tmp1_ = _tmp0_ = g_strsplit (version1, ".", 0);
#line 853 "panel.vala"
	version1_list = _tmp1_;
#line 853 "panel.vala"
	version1_list_length1 = _vala_array_length (_tmp0_);
#line 853 "panel.vala"
	_version1_list_size_ = version1_list_length1;
#line 854 "panel.vala"
	_tmp3_ = _tmp2_ = g_strsplit (version2, ".", 0);
#line 854 "panel.vala"
	version2_list = _tmp3_;
#line 854 "panel.vala"
	version2_list_length1 = _vala_array_length (_tmp2_);
#line 854 "panel.vala"
	_version2_list_size_ = version2_list_length1;
#line 857 "panel.vala"
	if (g_strcmp0 (version1, version2) == 0) {
#line 858 "panel.vala"
		result = 0;
#line 858 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 858 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 858 "panel.vala"
		return result;
#line 4860 "panel.c"
	}
#line 862 "panel.vala"
	if (g_strcmp0 (version1, "") == 0) {
#line 863 "panel.vala"
		result = -1;
#line 863 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 863 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 863 "panel.vala"
		return result;
#line 4872 "panel.c"
	}
#line 865 "panel.vala"
	if (g_strcmp0 (version2, "") == 0) {
#line 866 "panel.vala"
		result = 1;
#line 866 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 866 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 866 "panel.vala"
		return result;
#line 4884 "panel.c"
	}
#line 869 "panel.vala"
	_tmp4_ = version1_list;
#line 869 "panel.vala"
	_tmp4__length1 = version1_list_length1;
#line 869 "panel.vala"
	_vala_assert (_tmp4__length1 >= 3, "version1_list.length >= 3");
#line 870 "panel.vala"
	_tmp5_ = version2_list;
#line 870 "panel.vala"
	_tmp5__length1 = version2_list_length1;
#line 870 "panel.vala"
	_vala_assert (_tmp5__length1 >= 3, "version2_list.length >= 3");
#line 872 "panel.vala"
	_tmp6_ = version1_list;
#line 872 "panel.vala"
	_tmp6__length1 = version1_list_length1;
#line 872 "panel.vala"
	_tmp7_ = _tmp6_[0];
#line 872 "panel.vala"
	major1 = atoi (_tmp7_);
#line 873 "panel.vala"
	_tmp8_ = version1_list;
#line 873 "panel.vala"
	_tmp8__length1 = version1_list_length1;
#line 873 "panel.vala"
	_tmp9_ = _tmp8_[1];
#line 873 "panel.vala"
	minor1 = atoi (_tmp9_);
#line 874 "panel.vala"
	_tmp10_ = version1_list;
#line 874 "panel.vala"
	_tmp10__length1 = version1_list_length1;
#line 874 "panel.vala"
	_tmp11_ = _tmp10_[2];
#line 874 "panel.vala"
	micro1 = atoi (_tmp11_);
#line 876 "panel.vala"
	_tmp12_ = version2_list;
#line 876 "panel.vala"
	_tmp12__length1 = version2_list_length1;
#line 876 "panel.vala"
	_tmp13_ = _tmp12_[0];
#line 876 "panel.vala"
	major2 = atoi (_tmp13_);
#line 877 "panel.vala"
	_tmp14_ = version2_list;
#line 877 "panel.vala"
	_tmp14__length1 = version2_list_length1;
#line 877 "panel.vala"
	_tmp15_ = _tmp14_[1];
#line 877 "panel.vala"
	minor2 = atoi (_tmp15_);
#line 878 "panel.vala"
	_tmp16_ = version2_list;
#line 878 "panel.vala"
	_tmp16__length1 = version2_list_length1;
#line 878 "panel.vala"
	_tmp17_ = _tmp16_[2];
#line 878 "panel.vala"
	micro2 = atoi (_tmp17_);
#line 880 "panel.vala"
	if (major1 == minor1) {
#line 880 "panel.vala"
		_tmp19_ = minor1 == minor2;
#line 4950 "panel.c"
	} else {
#line 880 "panel.vala"
		_tmp19_ = FALSE;
#line 4954 "panel.c"
	}
#line 880 "panel.vala"
	if (_tmp19_) {
#line 880 "panel.vala"
		_tmp18_ = micro1 == micro2;
#line 4960 "panel.c"
	} else {
#line 880 "panel.vala"
		_tmp18_ = FALSE;
#line 4964 "panel.c"
	}
#line 880 "panel.vala"
	if (_tmp18_) {
#line 881 "panel.vala"
		result = 0;
#line 881 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 881 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 881 "panel.vala"
		return result;
#line 4976 "panel.c"
	}
#line 883 "panel.vala"
	if (major1 > major2) {
#line 883 "panel.vala"
		_tmp21_ = TRUE;
#line 4982 "panel.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 884 "panel.vala"
		if (major1 == major2) {
#line 884 "panel.vala"
			_tmp22_ = minor1 > minor2;
#line 4989 "panel.c"
		} else {
#line 884 "panel.vala"
			_tmp22_ = FALSE;
#line 4993 "panel.c"
		}
#line 884 "panel.vala"
		_tmp21_ = _tmp22_;
#line 4997 "panel.c"
	}
#line 883 "panel.vala"
	if (_tmp21_) {
#line 883 "panel.vala"
		_tmp20_ = TRUE;
#line 5003 "panel.c"
	} else {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 885 "panel.vala"
		if (major1 == major2) {
#line 885 "panel.vala"
			_tmp24_ = minor1 == minor2;
#line 5011 "panel.c"
		} else {
#line 885 "panel.vala"
			_tmp24_ = FALSE;
#line 5015 "panel.c"
		}
#line 885 "panel.vala"
		if (_tmp24_) {
#line 886 "panel.vala"
			_tmp23_ = micro1 > micro2;
#line 5021 "panel.c"
		} else {
#line 885 "panel.vala"
			_tmp23_ = FALSE;
#line 5025 "panel.c"
		}
#line 885 "panel.vala"
		_tmp20_ = _tmp23_;
#line 5029 "panel.c"
	}
#line 883 "panel.vala"
	if (_tmp20_) {
#line 887 "panel.vala"
		result = 1;
#line 887 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 887 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 887 "panel.vala"
		return result;
#line 5041 "panel.c"
	}
#line 889 "panel.vala"
	result = -1;
#line 889 "panel.vala"
	version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 889 "panel.vala"
	version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 889 "panel.vala"
	return result;
#line 5051 "panel.c"
}

static void
panel_update_version_1_5_8 (Panel* self)
{
#line 893 "panel.vala"
	g_return_if_fail (self != NULL);
#line 894 "panel.vala"
	self->priv->inited_engines_order = FALSE;
#line 5061 "panel.c"
}

static void
panel_set_version (Panel* self)
{
	gchar* prev_version = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* current_version = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
#line 898 "panel.vala"
	g_return_if_fail (self != NULL);
#line 899 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 899 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "version");
#line 899 "panel.vala"
	prev_version = _tmp1_;
#line 900 "panel.vala"
	current_version = NULL;
#line 902 "panel.vala"
	_tmp2_ = prev_version;
#line 902 "panel.vala"
	if (panel_compare_versions (self, _tmp2_, "1.5.8") < 0) {
#line 903 "panel.vala"
		panel_update_version_1_5_8 (self);
#line 5093 "panel.c"
	}
#line 905 "panel.vala"
	_tmp3_ = g_strdup_printf ("%d.%d.%d", IBUS_MAJOR_VERSION, IBUS_MINOR_VERSION, IBUS_MICRO_VERSION);
#line 905 "panel.vala"
	_g_free0 (current_version);
#line 905 "panel.vala"
	current_version = _tmp3_;
#line 909 "panel.vala"
	_tmp4_ = prev_version;
#line 909 "panel.vala"
	_tmp5_ = current_version;
#line 909 "panel.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 910 "panel.vala"
		_g_free0 (current_version);
#line 910 "panel.vala"
		_g_free0 (prev_version);
#line 910 "panel.vala"
		return;
#line 5113 "panel.c"
	}
#line 913 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 913 "panel.vala"
	_tmp7_ = current_version;
#line 913 "panel.vala"
	g_settings_set_string (_tmp6_, "version", _tmp7_);
#line 898 "panel.vala"
	_g_free0 (current_version);
#line 898 "panel.vala"
	_g_free0 (prev_version);
#line 5125 "panel.c"
}

static void
panel_check_wayland (Panel* self)
{
	gchar* message = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp19_;
	NotifyNotification* notification = NULL;
	const gchar* _tmp20_;
	NotifyNotification* _tmp21_;
	NotifyNotification* _tmp22_;
	NotifyNotification* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 917 "panel.vala"
	g_return_if_fail (self != NULL);
#line 918 "panel.vala"
	message = NULL;
#line 919 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 919 "panel.vala"
		_tmp1_ = !self->priv->m_is_wayland_im;
#line 5150 "panel.c"
	} else {
#line 919 "panel.vala"
		_tmp1_ = FALSE;
#line 5154 "panel.c"
	}
#line 919 "panel.vala"
	if (_tmp1_) {
#line 919 "panel.vala"
		_tmp0_ = !panel_is_gnome ();
#line 5160 "panel.c"
	} else {
#line 919 "panel.vala"
		_tmp0_ = FALSE;
#line 5164 "panel.c"
	}
#line 919 "panel.vala"
	if (_tmp0_) {
#line 5168 "panel.c"
		gchar* format = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 920 "panel.vala"
		_tmp2_ = g_strdup (_ ("IBus should be called from the desktop session in " "%s. For KDE, you can launch '%s' " "utility and go to \"Input Devices\" -> " "\"Virtual Keyboard\" section and select " "\"%s\" icon and click \"Apply\" button to " "configure IBus in %s. For other desktop " "sessions, you can copy the 'Exec=' line in %s file " "to a configuration file of the session. " "Please refer each document about the \"Wayland " "input method\" configuration. Before you configure " "the \"Wayland input method\", you should make sure " "that QT_IM_MODULE and GTK_IM_MODULE environment " "variables are unset in the desktop session."));
#line 920 "panel.vala"
		format = _tmp2_;
#line 934 "panel.vala"
		_tmp3_ = format;
#line 934 "panel.vala"
		_tmp4_ = g_strdup_printf (_tmp3_, "Wayland", "systemsettings5", "IBus Wayland", "Wayland", "org.freedesktop.IBus.Panel.Wayland.Gtk3.desktop");
#line 934 "panel.vala"
		_g_free0 (message);
#line 934 "panel.vala"
		message = _tmp4_;
#line 919 "panel.vala"
		_g_free0 (format);
#line 5187 "panel.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 940 "panel.vala"
		if (self->priv->m_is_wayland) {
#line 940 "panel.vala"
			_tmp6_ = self->priv->m_is_wayland_im;
#line 5195 "panel.c"
		} else {
#line 940 "panel.vala"
			_tmp6_ = FALSE;
#line 5199 "panel.c"
		}
#line 940 "panel.vala"
		if (_tmp6_) {
#line 940 "panel.vala"
			_tmp5_ = !panel_is_gnome ();
#line 5205 "panel.c"
		} else {
#line 940 "panel.vala"
			_tmp5_ = FALSE;
#line 5209 "panel.c"
		}
#line 940 "panel.vala"
		if (_tmp5_) {
#line 5213 "panel.c"
			const gchar* _tmp7_;
#line 941 "panel.vala"
			_tmp7_ = g_getenv ("QT_IM_MODULE");
#line 941 "panel.vala"
			if (g_strcmp0 (_tmp7_, "ibus") == 0) {
#line 5219 "panel.c"
				gchar* format = NULL;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 942 "panel.vala"
				_tmp8_ = g_strdup (_ ("Please unset QT_IM_MODULE and GTK_IM_MODULE " "environment variables and 'ibus-daemon --panel " "disable' should be executed as a child process " "of %s component."));
#line 942 "panel.vala"
				format = _tmp8_;
#line 947 "panel.vala"
				_tmp9_ = format;
#line 947 "panel.vala"
				_tmp10_ = g_get_prgname ();
#line 947 "panel.vala"
				_tmp11_ = g_strdup_printf (_tmp9_, _tmp10_);
#line 947 "panel.vala"
				_g_free0 (message);
#line 947 "panel.vala"
				message = _tmp11_;
#line 941 "panel.vala"
				_g_free0 (format);
#line 5241 "panel.c"
			}
		}
	}
#line 950 "panel.vala"
	if (!self->priv->m_is_wayland) {
#line 950 "panel.vala"
		_tmp12_ = self->priv->m_is_wayland_im;
#line 5249 "panel.c"
	} else {
#line 950 "panel.vala"
		_tmp12_ = FALSE;
#line 5253 "panel.c"
	}
#line 950 "panel.vala"
	if (_tmp12_) {
#line 5257 "panel.c"
		gchar* format = NULL;
		gchar* _tmp13_;
		const gchar* prgname = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 951 "panel.vala"
		_tmp13_ = g_strdup (_ ("Seems you run %s with '--enable-wayland-im' " "option but your display server is Xorg so the Wayland " "feature is disabled. You would be better off running " "ibus-daemon directly instead or %s without that " "option."));
#line 951 "panel.vala"
		format = _tmp13_;
#line 957 "panel.vala"
		_tmp14_ = g_get_prgname ();
#line 957 "panel.vala"
		prgname = _tmp14_;
#line 958 "panel.vala"
		_tmp15_ = format;
#line 958 "panel.vala"
		_tmp16_ = prgname;
#line 958 "panel.vala"
		_tmp17_ = prgname;
#line 958 "panel.vala"
		_tmp18_ = g_strdup_printf (_tmp15_, _tmp16_, _tmp17_);
#line 958 "panel.vala"
		_g_free0 (message);
#line 958 "panel.vala"
		message = _tmp18_;
#line 950 "panel.vala"
		_g_free0 (format);
#line 5288 "panel.c"
	}
#line 960 "panel.vala"
	_tmp19_ = message;
#line 960 "panel.vala"
	if (_tmp19_ == NULL) {
#line 961 "panel.vala"
		_g_free0 (message);
#line 961 "panel.vala"
		return;
#line 5298 "panel.c"
	}
#line 963 "panel.vala"
	if (!notify_is_initted ()) {
#line 964 "panel.vala"
		notify_init ("ibus");
#line 5304 "panel.c"
	}
#line 967 "panel.vala"
	_tmp20_ = message;
#line 967 "panel.vala"
	_tmp21_ = notify_notification_new (_ ("IBus Notification"), _tmp20_, "ibus");
#line 967 "panel.vala"
	notification = _tmp21_;
#line 971 "panel.vala"
	_tmp22_ = notification;
#line 971 "panel.vala"
	notify_notification_set_timeout (_tmp22_, 60 * 1000);
#line 972 "panel.vala"
	_tmp23_ = notification;
#line 972 "panel.vala"
	notify_notification_set_category (_tmp23_, "wayland");
#line 5320 "panel.c"
	{
		NotifyNotification* _tmp24_;
#line 975 "panel.vala"
		_tmp24_ = notification;
#line 975 "panel.vala"
		notify_notification_show (_tmp24_, &_inner_error0_);
#line 975 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5329 "panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp25_;
#line 974 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 977 "panel.vala"
		_tmp25_ = message;
#line 977 "panel.vala"
		g_warning ("panel.vala:977: %s", _tmp25_);
#line 5343 "panel.c"
	}
	__finally0:
#line 974 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 974 "panel.vala"
		_g_object_unref0 (notification);
#line 974 "panel.vala"
		_g_free0 (message);
#line 974 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 974 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 974 "panel.vala"
		return;
#line 5358 "panel.c"
	}
#line 917 "panel.vala"
	_g_object_unref0 (notification);
#line 917 "panel.vala"
	_g_free0 (message);
#line 5364 "panel.c"
}

static void
panel_save_log (Panel* self,
                const gchar* format)
{
	FILE* _tmp0_;
	FILE* _tmp1_;
	FILE* _tmp2_;
#line 985 "panel.vala"
	g_return_if_fail (self != NULL);
#line 985 "panel.vala"
	g_return_if_fail (format != NULL);
#line 986 "panel.vala"
	_tmp0_ = self->priv->m_log;
#line 986 "panel.vala"
	if (_tmp0_ == NULL) {
#line 987 "panel.vala"
		return;
#line 5384 "panel.c"
	}
#line 988 "panel.vala"
	_tmp1_ = self->priv->m_log;
#line 988 "panel.vala"
	fputs (format, _tmp1_);
#line 989 "panel.vala"
	_tmp2_ = self->priv->m_log;
#line 989 "panel.vala"
	fflush (_tmp2_);
#line 5394 "panel.c"
}

void
panel_load_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GList* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
#line 993 "panel.vala"
	g_return_if_fail (self != NULL);
#line 994 "panel.vala"
	panel_init_engines_order (self);
#line 998 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 999 "panel.vala"
	panel_set_use_global_engine (self);
#line 1000 "panel.vala"
	panel_set_use_xmodmap (self);
#line 1001 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 1001 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 1003 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 1003 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "preload-engines");
#line 1003 "panel.vala"
	_tmp4_ = _tmp3_;
#line 1003 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 1003 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 1003 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "engines-order");
#line 1003 "panel.vala"
	_tmp8_ = _tmp7_;
#line 1003 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1003 "panel.vala"
	panel_update_engines (self, _tmp4_, (gint) _vala_array_length (_tmp2_), _tmp8_, (gint) _vala_array_length (_tmp6_));
#line 1003 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 1003 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 1005 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 1005 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp9_);
#line 1008 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 1008 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 1009 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 1010 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 1011 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 1012 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 1012 "panel.vala"
	binding_common_set_custom_font (_tmp10_, NULL, &self->priv->m_css_provider);
#line 1015 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 1015 "panel.vala"
	binding_common_set_custom_theme (_tmp11_);
#line 1016 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 1016 "panel.vala"
	binding_common_set_custom_icon (_tmp12_);
#line 1017 "panel.vala"
	panel_set_show_icon_on_systray (self, FALSE);
#line 1018 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 1019 "panel.vala"
	panel_set_show_property_panel (self);
#line 1020 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 1021 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 1022 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 1023 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 5491 "panel.c"
}

/**
     * disconnect_signals:
     *
     * Call this API before m_panel = null so that the ref_count becomes 0
     */
void
panel_disconnect_signals (Panel* self)
{
	GObject* object = NULL;
	GtkStatusIcon* _tmp0_;
#line 1031 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1032 "panel.vala"
	_tmp0_ = self->priv->m_status_icon;
#line 1032 "panel.vala"
	object = (GObject*) _tmp0_;
#line 1034 "panel.vala"
	if (self->priv->m_is_indicator) {
#line 5512 "panel.c"
		Indicator* _tmp1_;
#line 1035 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 1035 "panel.vala"
		object = (GObject*) _tmp1_;
#line 5518 "panel.c"
	}
#line 1037 "panel.vala"
	if (self->priv->m_popup_menu_id > ((gulong) 0)) {
#line 5522 "panel.c"
		GObject* _tmp2_;
#line 1039 "panel.vala"
		_tmp2_ = object;
#line 1039 "panel.vala"
		if (g_signal_handler_is_connected (_tmp2_, self->priv->m_popup_menu_id)) {
#line 5528 "panel.c"
			GObject* _tmp3_;
#line 1040 "panel.vala"
			_tmp3_ = object;
#line 1040 "panel.vala"
			g_signal_handler_disconnect (_tmp3_, self->priv->m_popup_menu_id);
#line 5534 "panel.c"
		}
#line 1041 "panel.vala"
		self->priv->m_popup_menu_id = (gulong) 0;
#line 5538 "panel.c"
	}
#line 1043 "panel.vala"
	if (self->priv->m_activate_id > ((gulong) 0)) {
#line 5542 "panel.c"
		GObject* _tmp4_;
#line 1044 "panel.vala"
		_tmp4_ = object;
#line 1044 "panel.vala"
		if (g_signal_handler_is_connected (_tmp4_, self->priv->m_activate_id)) {
#line 5548 "panel.c"
			GObject* _tmp5_;
#line 1045 "panel.vala"
			_tmp5_ = object;
#line 1045 "panel.vala"
			g_signal_handler_disconnect (_tmp5_, self->priv->m_activate_id);
#line 5554 "panel.c"
		}
#line 1046 "panel.vala"
		self->priv->m_activate_id = (gulong) 0;
#line 5558 "panel.c"
	}
#line 1048 "panel.vala"
	if (self->priv->m_registered_status_notifier_item_id > ((gulong) 0)) {
#line 5562 "panel.c"
		GObject* _tmp6_;
#line 1049 "panel.vala"
		_tmp6_ = object;
#line 1049 "panel.vala"
		if (g_signal_handler_is_connected (_tmp6_, self->priv->m_registered_status_notifier_item_id)) {
#line 5568 "panel.c"
			GObject* _tmp7_;
#line 1052 "panel.vala"
			_tmp7_ = object;
#line 1052 "panel.vala"
			g_signal_handler_disconnect (_tmp7_, self->priv->m_registered_status_notifier_item_id);
#line 5574 "panel.c"
		}
#line 1054 "panel.vala"
		self->priv->m_registered_status_notifier_item_id = (gulong) 0;
#line 5578 "panel.c"
	}
#line 1056 "panel.vala"
	if (self->priv->m_preload_engines_id > ((guint) 0)) {
#line 1057 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 1058 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 5586 "panel.c"
	}
}

/**
     * set_global_shortcut_key_state:
     *
     * Handle IME switcher dialog or Emojier on the focused context only
     * so this API is assumed to use in Wayland.
     */
void
panel_set_global_shortcut_key_state (Panel* self,
                                     IBusBusGlobalBindingType type,
                                     guint keyval,
                                     guint keycode,
                                     guint state,
                                     gboolean is_backward)
{
#line 1069 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1075 "panel.vala"
	switch (type) {
#line 1075 "panel.vala"
		case IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER:
#line 5610 "panel.c"
		{
#line 1077 "panel.vala"
			panel_handle_engine_switch_focused (self, keyval, keycode, state, is_backward);
#line 1078 "panel.vala"
			break;
#line 5616 "panel.c"
		}
		default:
		{
#line 1079 "panel.vala"
			break;
#line 5622 "panel.c"
		}
	}
}

void
panel_set_log (Panel* self,
               FILE* log,
               gboolean verbose)
{
#line 1084 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1084 "panel.vala"
	g_return_if_fail (log != NULL);
#line 1085 "panel.vala"
	self->priv->m_log = log;
#line 1086 "panel.vala"
	self->priv->m_verbose = verbose;
#line 5640 "panel.c"
}

static void
panel_engine_contexts_insert (Panel* self,
                              IBusEngineDesc* engine)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	IBusEngineDesc* _tmp5_;
#line 1090 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1090 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1091 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1092 "panel.vala"
		return;
#line 5660 "panel.c"
	}
#line 1094 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1094 "panel.vala"
	if (g_hash_table_size (_tmp0_) >= ((guint) 200)) {
#line 5666 "panel.c"
		GHashTable* _tmp1_;
#line 1095 "panel.vala"
		g_warning ("panel.vala:1095: Contexts by windows are too much counted!");
#line 1096 "panel.vala"
		_tmp1_ = self->priv->m_engine_contexts;
#line 1096 "panel.vala"
		g_hash_table_remove_all (_tmp1_);
#line 5674 "panel.c"
	}
#line 1099 "panel.vala"
	_tmp2_ = self->priv->m_engine_contexts;
#line 1099 "panel.vala"
	_tmp3_ = self->priv->m_current_context_path;
#line 1099 "panel.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 1099 "panel.vala"
	_tmp5_ = _g_object_ref0 (engine);
#line 1099 "panel.vala"
	g_hash_table_replace (_tmp2_, _tmp4_, _tmp5_);
#line 5686 "panel.c"
}

static void
panel_set_language_from_engine (Panel* self,
                                IBusEngineDesc* engine)
{
	const gchar* _tmp0_ = NULL;
	CandidatePanel* _tmp2_;
	PangoLanguage* _tmp3_;
	PangoAttrLanguage* _tmp4_;
	PangoAttrLanguage* _tmp5_;
	CandidatePanel* _tmp6_;
#line 1102 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1102 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1104 "panel.vala"
	if (self->priv->m_use_engine_lang) {
#line 5705 "panel.c"
		const gchar* _tmp1_;
#line 1105 "panel.vala"
		_tmp1_ = ibus_engine_desc_get_language (engine);
#line 1105 "panel.vala"
		_tmp0_ = _tmp1_;
#line 5711 "panel.c"
	} else {
#line 1106 "panel.vala"
		_tmp0_ = NULL;
#line 5715 "panel.c"
	}
#line 1103 "panel.vala"
	_tmp2_ = self->priv->m_candidate_panel;
#line 1103 "panel.vala"
	_tmp3_ = pango_language_from_string (_tmp0_);
#line 1103 "panel.vala"
	_tmp4_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp3_);
#line 1103 "panel.vala"
	_tmp5_ = _tmp4_;
#line 1103 "panel.vala"
	candidate_panel_set_language (_tmp2_, (PangoAttribute*) _tmp5_);
#line 1103 "panel.vala"
	_pango_attribute_destroy0 (_tmp5_);
#line 1108 "panel.vala"
	_tmp6_ = self->priv->m_candidate_panel_x11;
#line 1108 "panel.vala"
	if (_tmp6_ != NULL) {
#line 5733 "panel.c"
		const gchar* _tmp7_ = NULL;
		CandidatePanel* _tmp9_;
		PangoLanguage* _tmp10_;
		PangoAttrLanguage* _tmp11_;
		PangoAttrLanguage* _tmp12_;
#line 1110 "panel.vala"
		if (self->priv->m_use_engine_lang) {
#line 5741 "panel.c"
			const gchar* _tmp8_;
#line 1111 "panel.vala"
			_tmp8_ = ibus_engine_desc_get_language (engine);
#line 1111 "panel.vala"
			_tmp7_ = _tmp8_;
#line 5747 "panel.c"
		} else {
#line 1112 "panel.vala"
			_tmp7_ = NULL;
#line 5751 "panel.c"
		}
#line 1109 "panel.vala"
		_tmp9_ = self->priv->m_candidate_panel_x11;
#line 1109 "panel.vala"
		_tmp10_ = pango_language_from_string (_tmp7_);
#line 1109 "panel.vala"
		_tmp11_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp10_);
#line 1109 "panel.vala"
		_tmp12_ = _tmp11_;
#line 1109 "panel.vala"
		candidate_panel_set_language (_tmp9_, (PangoAttribute*) _tmp12_);
#line 1109 "panel.vala"
		_pango_attribute_destroy0 (_tmp12_);
#line 5765 "panel.c"
	}
}

static void
panel_set_engine (Panel* self,
                  IBusEngineDesc* engine)
{
	IBusBus* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 1117 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1117 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1118 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1119 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1120 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 5787 "panel.c"
	}
#line 1123 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1123 "panel.vala"
	_tmp1_ = ibus_engine_desc_get_name (engine);
#line 1123 "panel.vala"
	if (!ibus_bus_set_global_engine (_tmp0_, _tmp1_)) {
#line 5795 "panel.c"
		const gchar* _tmp2_;
#line 1124 "panel.vala"
		_tmp2_ = ibus_engine_desc_get_name (engine);
#line 1124 "panel.vala"
		g_warning ("panel.vala:1124: Switch engine to %s failed.", _tmp2_);
#line 1125 "panel.vala"
		return;
#line 5803 "panel.c"
	}
#line 1132 "panel.vala"
	_tmp3_ = g_strdup ("");
#line 1132 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 1132 "panel.vala"
	self->priv->m_icon_prop_key = _tmp3_;
#line 1135 "panel.vala"
	if (!self->priv->m_use_system_keyboard_layout) {
#line 1135 "panel.vala"
		_tmp4_ = !self->priv->m_is_wayland;
#line 5815 "panel.c"
	} else {
#line 1135 "panel.vala"
		_tmp4_ = FALSE;
#line 5819 "panel.c"
	}
#line 1135 "panel.vala"
	if (_tmp4_) {
#line 5823 "panel.c"
		XKBLayout* _tmp5_;
#line 1136 "panel.vala"
		_tmp5_ = self->priv->m_xkblayout;
#line 1136 "panel.vala"
		xkb_layout_set_layout (_tmp5_, engine);
#line 5829 "panel.c"
	}
#line 1138 "panel.vala"
	panel_set_language_from_engine (self, engine);
#line 1139 "panel.vala"
	panel_engine_contexts_insert (self, engine);
#line 5835 "panel.c"
}

static void
panel_switch_engine (Panel* self,
                     gint i,
                     gboolean force)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	IBusEngineDesc* engine = NULL;
	IBusEngineDesc** _tmp3_;
	gint _tmp3__length1;
	IBusEngineDesc* _tmp4_;
	IBusEngineDesc* _tmp5_;
	IBusEngineDesc* _tmp6_;
#line 1142 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1143 "panel.vala"
	if (i >= 0) {
#line 5855 "panel.c"
		IBusEngineDesc** _tmp1_;
		gint _tmp1__length1;
#line 1143 "panel.vala"
		_tmp1_ = self->priv->m_engines;
#line 1143 "panel.vala"
		_tmp1__length1 = self->priv->m_engines_length1;
#line 1143 "panel.vala"
		_tmp0_ = i < _tmp1__length1;
#line 5864 "panel.c"
	} else {
#line 1143 "panel.vala"
		_tmp0_ = FALSE;
#line 5868 "panel.c"
	}
#line 1143 "panel.vala"
	_vala_assert (_tmp0_, "i >= 0 && i < m_engines.length");
#line 1146 "panel.vala"
	if (i == 0) {
#line 1146 "panel.vala"
		_tmp2_ = !force;
#line 5876 "panel.c"
	} else {
#line 1146 "panel.vala"
		_tmp2_ = FALSE;
#line 5880 "panel.c"
	}
#line 1146 "panel.vala"
	if (_tmp2_) {
#line 1147 "panel.vala"
		return;
#line 5886 "panel.c"
	}
#line 1149 "panel.vala"
	_tmp3_ = self->priv->m_engines;
#line 1149 "panel.vala"
	_tmp3__length1 = self->priv->m_engines_length1;
#line 1149 "panel.vala"
	_tmp4_ = _tmp3_[i];
#line 1149 "panel.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1149 "panel.vala"
	engine = _tmp5_;
#line 1151 "panel.vala"
	_tmp6_ = engine;
#line 1151 "panel.vala"
	panel_set_engine (self, _tmp6_);
#line 1142 "panel.vala"
	_g_object_unref0 (engine);
#line 5904 "panel.c"
}

static void
panel_handle_engine_switch_normal (Panel* self,
                                   GdkEvent* event)
{
#line 1154 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1154 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1155 "panel.vala"
	panel_handle_engine_switch (self, event, FALSE);
#line 5917 "panel.c"
}

static void
panel_handle_engine_switch_reverse (Panel* self,
                                    GdkEvent* event)
{
#line 1158 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1158 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1159 "panel.vala"
	panel_handle_engine_switch (self, event, TRUE);
#line 5930 "panel.c"
}

static void
panel_handle_engine_switch (Panel* self,
                            GdkEvent* event,
                            gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
	guint keyval = 0U;
	GdkEventKey* _tmp1_;
	GdkEventKey* _tmp2_;
	guint modifiers = 0U;
	GdkEventKey* _tmp3_;
	GdkEventKey* _tmp4_;
	guint primary_modifiers = 0U;
	GdkEventKey* _tmp5_;
	GdkEventKey* _tmp6_;
	gboolean pressed = FALSE;
	gboolean _tmp7_ = FALSE;
#line 1162 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1162 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1164 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1164 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1164 "panel.vala"
	if (_tmp0__length1 <= 1) {
#line 1165 "panel.vala"
		return;
#line 5963 "panel.c"
	}
#line 1167 "panel.vala"
	_tmp1_ = (GdkEventKey *) (event);
#line 1167 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1167 "panel.vala"
	keyval = _tmp2_->keyval;
#line 1168 "panel.vala"
	_tmp3_ = (GdkEventKey *) (event);
#line 1168 "panel.vala"
	_tmp4_ = _tmp3_;
#line 1168 "panel.vala"
	modifiers = (guint) (IBUS_MODIFIER_FILTER & _tmp4_->state);
#line 1170 "panel.vala"
	_tmp5_ = (GdkEventKey *) (event);
#line 1170 "panel.vala"
	_tmp6_ = _tmp5_;
#line 1170 "panel.vala"
	primary_modifiers = (guint) keybinding_manager_get_primary_modifier ((guint) _tmp6_->state);
#line 1173 "panel.vala"
	pressed = keybinding_manager_primary_modifier_still_pressed (event, primary_modifiers);
#line 1176 "panel.vala"
	if (reverse) {
#line 1177 "panel.vala"
		modifiers &= (guint) (~GDK_SHIFT_MASK);
#line 5989 "panel.c"
	}
#line 1180 "panel.vala"
	if (pressed) {
#line 1180 "panel.vala"
		_tmp7_ = self->priv->m_switcher_delay_time >= 0;
#line 5995 "panel.c"
	} else {
#line 1180 "panel.vala"
		_tmp7_ = FALSE;
#line 5999 "panel.c"
	}
#line 1180 "panel.vala"
	if (_tmp7_) {
#line 6003 "panel.c"
		gint _tmp8_ = 0;
		gint i = 0;
		Switcher* _tmp10_;
		IBusEngineDesc** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 1181 "panel.vala"
		if (reverse) {
#line 6012 "panel.c"
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 1181 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 1181 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 1181 "panel.vala"
			_tmp8_ = _tmp9__length1 - 1;
#line 6021 "panel.c"
		} else {
#line 1181 "panel.vala"
			_tmp8_ = 1;
#line 6025 "panel.c"
		}
#line 1181 "panel.vala"
		i = _tmp8_;
#line 1192 "panel.vala"
		_tmp10_ = self->priv->m_switcher_active;
#line 1192 "panel.vala"
		_tmp11_ = self->priv->m_engines;
#line 1192 "panel.vala"
		_tmp11__length1 = self->priv->m_engines_length1;
#line 1192 "panel.vala"
		_tmp12_ = self->priv->m_real_current_context_path;
#line 1192 "panel.vala"
		i = switcher_run (_tmp10_, keyval, modifiers, event, _tmp11_, (gint) _tmp11__length1, i, _tmp12_);
#line 1195 "panel.vala"
		if (i < 0) {
#line 1196 "panel.vala"
			g_debug ("panel.vala:1196: switch cancelled");
#line 6043 "panel.c"
		} else {
#line 1197 "panel.vala"
			if (i == 0) {
#line 1198 "panel.vala"
				g_debug ("panel.vala:1198: do not have to switch");
#line 6049 "panel.c"
			} else {
#line 1200 "panel.vala"
				panel_switcher_focus_set_engine (self);
#line 6053 "panel.c"
			}
		}
	} else {
		gint _tmp13_ = 0;
		gint i = 0;
#line 1203 "panel.vala"
		if (reverse) {
#line 6061 "panel.c"
			IBusEngineDesc** _tmp14_;
			gint _tmp14__length1;
#line 1203 "panel.vala"
			_tmp14_ = self->priv->m_engines;
#line 1203 "panel.vala"
			_tmp14__length1 = self->priv->m_engines_length1;
#line 1203 "panel.vala"
			_tmp13_ = _tmp14__length1 - 1;
#line 6070 "panel.c"
		} else {
#line 1203 "panel.vala"
			_tmp13_ = 1;
#line 6074 "panel.c"
		}
#line 1203 "panel.vala"
		i = _tmp13_;
#line 1204 "panel.vala"
		panel_switch_engine (self, i, FALSE);
#line 6080 "panel.c"
	}
}

static void
panel_handle_engine_switch_focused (Panel* self,
                                    guint keyval,
                                    guint keycode,
                                    guint state,
                                    gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp1_ = FALSE;
	gboolean pressed = FALSE;
#line 1209 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1213 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1213 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1213 "panel.vala"
	if (_tmp0__length1 < 2) {
#line 1214 "panel.vala"
		return;
#line 6105 "panel.c"
	}
#line 1215 "panel.vala"
	if ((state & IBUS_RELEASE_MASK) != ((guint) 0)) {
#line 1216 "panel.vala"
		_tmp1_ = FALSE;
#line 6111 "panel.c"
	} else {
#line 1216 "panel.vala"
		_tmp1_ = TRUE;
#line 6115 "panel.c"
	}
#line 1215 "panel.vala"
	pressed = _tmp1_;
#line 1217 "panel.vala"
	if (pressed) {
#line 6121 "panel.c"
		gint _tmp2_ = 0;
		gint i = 0;
#line 1218 "panel.vala"
		if (reverse) {
#line 6126 "panel.c"
			IBusEngineDesc** _tmp3_;
			gint _tmp3__length1;
#line 1218 "panel.vala"
			_tmp3_ = self->priv->m_engines;
#line 1218 "panel.vala"
			_tmp3__length1 = self->priv->m_engines_length1;
#line 1218 "panel.vala"
			_tmp2_ = _tmp3__length1 - 1;
#line 6135 "panel.c"
		} else {
#line 1218 "panel.vala"
			_tmp2_ = 1;
#line 6139 "panel.c"
		}
#line 1218 "panel.vala"
		i = _tmp2_;
#line 1219 "panel.vala"
		if (self->priv->m_switcher_selected_index >= 0) {
#line 6145 "panel.c"
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
#line 1220 "panel.vala"
			if (reverse) {
#line 1220 "panel.vala"
				_tmp4_ = self->priv->m_switcher_selected_index - 1;
#line 6152 "panel.c"
			} else {
#line 1221 "panel.vala"
				_tmp4_ = self->priv->m_switcher_selected_index + 1;
#line 6156 "panel.c"
			}
#line 1220 "panel.vala"
			i = _tmp4_;
#line 1222 "panel.vala"
			if (i < 0) {
#line 6162 "panel.c"
				IBusEngineDesc** _tmp6_;
				gint _tmp6__length1;
#line 1222 "panel.vala"
				_tmp6_ = self->priv->m_engines;
#line 1222 "panel.vala"
				_tmp6__length1 = self->priv->m_engines_length1;
#line 1222 "panel.vala"
				_tmp5_ = _tmp6__length1 - 1;
#line 6171 "panel.c"
			} else {
				gint _tmp7_ = 0;
				IBusEngineDesc** _tmp8_;
				gint _tmp8__length1;
#line 1223 "panel.vala"
				_tmp8_ = self->priv->m_engines;
#line 1223 "panel.vala"
				_tmp8__length1 = self->priv->m_engines_length1;
#line 1223 "panel.vala"
				if (i == _tmp8__length1) {
#line 1223 "panel.vala"
					_tmp7_ = 0;
#line 6184 "panel.c"
				} else {
#line 1223 "panel.vala"
					_tmp7_ = i;
#line 6188 "panel.c"
				}
#line 1223 "panel.vala"
				_tmp5_ = _tmp7_;
#line 6192 "panel.c"
			}
#line 1222 "panel.vala"
			i = _tmp5_;
#line 6196 "panel.c"
		}
#line 1225 "panel.vala"
		if (self->priv->m_switcher_delay_time >= 0) {
#line 6200 "panel.c"
			Switcher* _tmp9_;
			Switcher* _tmp10_;
			IBusEngineDesc** _tmp11_;
			gint _tmp11__length1;
#line 1227 "panel.vala"
			_tmp9_ = panel_get_active_switcher (self);
#line 1227 "panel.vala"
			_g_object_unref0 (self->priv->m_switcher_active);
#line 1227 "panel.vala"
			self->priv->m_switcher_active = _tmp9_;
#line 1229 "panel.vala"
			_tmp10_ = self->priv->m_switcher_active;
#line 1229 "panel.vala"
			_tmp11_ = self->priv->m_engines;
#line 1229 "panel.vala"
			_tmp11__length1 = self->priv->m_engines_length1;
#line 1229 "panel.vala"
			self->priv->m_switcher_selected_index = switcher_run_popup (_tmp10_, keyval, state, _tmp11_, (gint) _tmp11__length1, i);
#line 6219 "panel.c"
		} else {
#line 1235 "panel.vala"
			self->priv->m_switcher_selected_index = i;
#line 6223 "panel.c"
		}
#line 1237 "panel.vala"
		if (self->priv->m_verbose) {
#line 6227 "panel.c"
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 1238 "panel.vala"
			_tmp12_ = g_strdup_printf ("Panel.%s switcher release %d timer\n", G_STRFUNC, self->priv->m_switcher_selected_index);
#line 1238 "panel.vala"
			_tmp13_ = _tmp12_;
#line 1238 "panel.vala"
			panel_save_log (self, _tmp13_);
#line 1238 "panel.vala"
			_g_free0 (_tmp13_);
#line 6238 "panel.c"
		}
	} else {
#line 1242 "panel.vala"
		panel_handle_engine_switch_release (self, FALSE);
#line 6243 "panel.c"
	}
}

static void
panel_handle_engine_switch_release (Panel* self,
                                    gboolean is_timeout)
{
	Switcher* _tmp3_;
#line 1246 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1247 "panel.vala"
	if (self->priv->m_verbose) {
#line 6256 "panel.c"
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1250 "panel.vala"
		if (is_timeout) {
#line 1250 "panel.vala"
			_tmp0_ = "timeout";
#line 6264 "panel.c"
		} else {
#line 1250 "panel.vala"
			_tmp0_ = "normal";
#line 6268 "panel.c"
		}
#line 1248 "panel.vala"
		_tmp1_ = g_strdup_printf ("Panel.%s switcher release %d %s\n", G_STRFUNC, self->priv->m_switcher_selected_index, _tmp0_);
#line 1248 "panel.vala"
		_tmp2_ = _tmp1_;
#line 1248 "panel.vala"
		panel_save_log (self, _tmp2_);
#line 1248 "panel.vala"
		_g_free0 (_tmp2_);
#line 6278 "panel.c"
	}
#line 1255 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, NULL);
#line 1259 "panel.vala"
	_tmp3_ = self->priv->m_switcher_active;
#line 1259 "panel.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1260 "panel.vala"
	while (TRUE) {
#line 1260 "panel.vala"
		if (!gtk_events_pending ()) {
#line 1260 "panel.vala"
			break;
#line 6292 "panel.c"
		}
#line 1261 "panel.vala"
		gtk_main_iteration ();
#line 6296 "panel.c"
	}
#line 1263 "panel.vala"
	if (self->priv->m_switcher_selected_index < 0) {
#line 1264 "panel.vala"
		return;
#line 6302 "panel.c"
	}
#line 1265 "panel.vala"
	panel_switch_engine (self, self->priv->m_switcher_selected_index, FALSE);
#line 1266 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 6308 "panel.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 1270 "panel.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 1270 "panel.vala"
	return _data12_;
#line 6318 "panel.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 1270 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 6328 "panel.c"
		Panel* self;
#line 1270 "panel.vala"
		self = _data12_->self;
#line 1270 "panel.vala"
		_data12_->names = (_vala_array_free (_data12_->names, _data12_->names_length1, (GDestroyNotify) g_free), NULL);
#line 1270 "panel.vala"
		_g_object_unref0 (self);
#line 1270 "panel.vala"
		g_slice_free (Block12Data, _data12_);
#line 6338 "panel.c"
	}
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1282 "panel.vala"
	if ((*length) == (*size)) {
#line 1282 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1282 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6354 "panel.c"
	}
#line 1282 "panel.vala"
	(*array)[(*length)++] = value;
#line 1282 "panel.vala"
	(*array)[*length] = NULL;
#line 6360 "panel.c"
}

static gboolean
__lambda68_ (Block12Data* _data12_)
{
	Panel* self;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 1286 "panel.vala"
	self = _data12_->self;
#line 1287 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1287 "panel.vala"
	if (!ibus_bus_is_connected (_tmp0_)) {
#line 1288 "panel.vala"
		result = FALSE;
#line 1288 "panel.vala"
		return result;
#line 6382 "panel.c"
	}
#line 1289 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 1289 "panel.vala"
	_tmp2_ = _data12_->names;
#line 1289 "panel.vala"
	_tmp2__length1 = _data12_->names_length1;
#line 1289 "panel.vala"
	ibus_bus_preload_engines_async (_tmp1_, _tmp2_, -1, NULL, NULL, NULL);
#line 1292 "panel.vala"
	result = FALSE;
#line 1292 "panel.vala"
	return result;
#line 6396 "panel.c"
}

static gboolean
___lambda68__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda68_ (self);
#line 1283 "panel.vala"
	return result;
#line 6406 "panel.c"
}

static void
panel_run_preload_engines (Panel* self,
                           IBusEngineDesc** engines,
                           gint engines_length1,
                           gint index)
{
	Block12Data* _data12_;
	gchar** _tmp0_;
	IBusEngineDesc* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 1270 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1270 "panel.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 1270 "panel.vala"
	_data12_->_ref_count_ = 1;
#line 1270 "panel.vala"
	_data12_->self = g_object_ref (self);
#line 1271 "panel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 1271 "panel.vala"
	_data12_->names = _tmp0_;
#line 1271 "panel.vala"
	_data12_->names_length1 = 0;
#line 1271 "panel.vala"
	_data12_->_names_size_ = _data12_->names_length1;
#line 1273 "panel.vala"
	if (engines_length1 <= index) {
#line 1274 "panel.vala"
		block12_data_unref (_data12_);
#line 1274 "panel.vala"
		_data12_ = NULL;
#line 1274 "panel.vala"
		return;
#line 6444 "panel.c"
	}
#line 1277 "panel.vala"
	if (self->priv->m_preload_engines_id != ((guint) 0)) {
#line 1278 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 1279 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 6452 "panel.c"
	}
#line 1282 "panel.vala"
	_tmp1_ = engines[index];
#line 1282 "panel.vala"
	_tmp2_ = ibus_engine_desc_get_name (_tmp1_);
#line 1282 "panel.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1282 "panel.vala"
	_vala_array_add22 (&_data12_->names, &_data12_->names_length1, &_data12_->_names_size_, _tmp3_);
#line 1283 "panel.vala"
	self->priv->m_preload_engines_id = g_timeout_add_full (G_PRIORITY_DEFAULT, PANEL_PRELOAD_ENGINES_DELAY_TIME, ___lambda68__gsource_func, block12_data_ref (_data12_), block12_data_unref);
#line 1270 "panel.vala"
	block12_data_unref (_data12_);
#line 1270 "panel.vala"
	_data12_ = NULL;
#line 6468 "panel.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 1298 "panel.vala"
	if (length >= 0) {
#line 6477 "panel.c"
		gchar** result;
		gssize i;
#line 1298 "panel.vala"
		result = g_new0 (gchar*, length + 1);
#line 1298 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6484 "panel.c"
			gchar* _tmp0_;
#line 1298 "panel.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1298 "panel.vala"
			result[i] = _tmp0_;
#line 6490 "panel.c"
		}
#line 1298 "panel.vala"
		return result;
#line 6494 "panel.c"
	}
#line 1298 "panel.vala"
	return NULL;
#line 6498 "panel.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 1306 "panel.vala"
	for (i = 0; i < stack_length; i++) {
#line 1306 "panel.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 1306 "panel.vala"
			return TRUE;
#line 6513 "panel.c"
		}
	}
#line 1306 "panel.vala"
	return FALSE;
#line 6518 "panel.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1307 "panel.vala"
	if ((*length) == (*size)) {
#line 1307 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1307 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6533 "panel.c"
	}
#line 1307 "panel.vala"
	(*array)[(*length)++] = value;
#line 1307 "panel.vala"
	(*array)[*length] = NULL;
#line 6539 "panel.c"
}

static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1313 "panel.vala"
	if ((*length) == (*size)) {
#line 1313 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1313 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6554 "panel.c"
	}
#line 1313 "panel.vala"
	(*array)[(*length)++] = value;
#line 1313 "panel.vala"
	(*array)[*length] = NULL;
#line 6560 "panel.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 1321 "panel.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 1321 "panel.vala"
	return _data13_;
#line 6570 "panel.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 1321 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 6580 "panel.c"
		Panel* self;
#line 1321 "panel.vala"
		self = _data13_->self;
#line 1321 "panel.vala"
		_g_object_unref0 (_data13_->dialog);
#line 1321 "panel.vala"
		_g_object_unref0 (self);
#line 1321 "panel.vala"
		g_slice_free (Block13Data, _data13_);
#line 6590 "panel.c"
	}
}

static void
___lambda67_ (Block13Data* _data13_,
              gint id)
{
	Panel* self;
	GtkMessageDialog* _tmp0_;
#line 1344 "panel.vala"
	self = _data13_->self;
#line 1345 "panel.vala"
	_tmp0_ = _data13_->dialog;
#line 1345 "panel.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 6606 "panel.c"
}

static void
____lambda67__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 1344 "panel.vala"
	___lambda67_ (self, response_id);
#line 6616 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup3 (IBusEngineDesc** self,
                  gssize length)
{
#line 1351 "panel.vala"
	if (length >= 0) {
#line 6625 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1351 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1351 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6632 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1351 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1351 "panel.vala"
			result[i] = _tmp0_;
#line 6638 "panel.c"
		}
#line 1351 "panel.vala"
		return result;
#line 6642 "panel.c"
	}
#line 1351 "panel.vala"
	return NULL;
#line 6646 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup4 (IBusEngineDesc** self,
                  gssize length)
{
#line 1356 "panel.vala"
	if (length >= 0) {
#line 6655 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1356 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1356 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6662 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1356 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1356 "panel.vala"
			result[i] = _tmp0_;
#line 6668 "panel.c"
		}
#line 1356 "panel.vala"
		return result;
#line 6672 "panel.c"
	}
#line 1356 "panel.vala"
	return NULL;
#line 6676 "panel.c"
}

static void
panel_update_engines (Panel* self,
                      gchar** unowned_engine_names,
                      gint unowned_engine_names_length1,
                      gchar** order_names,
                      gint order_names_length1)
{
	gchar** engine_names = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint engine_names_length1;
	gint _engine_names_size_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** names = NULL;
	gchar** _tmp6_;
	gint names_length1;
	gint _names_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	IBusEngineDesc** engines = NULL;
	IBusBus* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	IBusEngineDesc** _tmp20_;
	IBusEngineDesc** _tmp21_;
	gint engines_length1;
	gint _engines_size_;
	IBusEngineDesc** _tmp22_;
	gint _tmp22__length1;
	gchar** _tmp23_;
	gint _tmp23__length1;
	IBusEngineDesc** _tmp43_;
	gint _tmp43__length1;
#line 1296 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1298 "panel.vala"
	_tmp0_ = (unowned_engine_names != NULL) ? _vala_array_dup2 (unowned_engine_names, unowned_engine_names_length1) : unowned_engine_names;
#line 1298 "panel.vala"
	_tmp0__length1 = unowned_engine_names_length1;
#line 1298 "panel.vala"
	engine_names = _tmp0_;
#line 1298 "panel.vala"
	engine_names_length1 = _tmp0__length1;
#line 1298 "panel.vala"
	_engine_names_size_ = engine_names_length1;
#line 1300 "panel.vala"
	_tmp2_ = engine_names;
#line 1300 "panel.vala"
	_tmp2__length1 = engine_names_length1;
#line 1300 "panel.vala"
	if (_tmp2_ == NULL) {
#line 1300 "panel.vala"
		_tmp1_ = TRUE;
#line 6734 "panel.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 1300 "panel.vala"
		_tmp3_ = engine_names;
#line 1300 "panel.vala"
		_tmp3__length1 = engine_names_length1;
#line 1300 "panel.vala"
		_tmp1_ = _tmp3__length1 == 0;
#line 6744 "panel.c"
	}
#line 1300 "panel.vala"
	if (_tmp1_) {
#line 6748 "panel.c"
		gchar* _tmp4_;
		gchar** _tmp5_;
#line 1301 "panel.vala"
		_tmp4_ = g_strdup ("xkb:us::eng");
#line 1301 "panel.vala"
		_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 1301 "panel.vala"
		_tmp5_[0] = _tmp4_;
#line 1301 "panel.vala"
		engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1301 "panel.vala"
		engine_names = _tmp5_;
#line 1301 "panel.vala"
		engine_names_length1 = 1;
#line 1301 "panel.vala"
		_engine_names_size_ = engine_names_length1;
#line 6765 "panel.c"
	}
#line 1303 "panel.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 1303 "panel.vala"
	names = _tmp6_;
#line 1303 "panel.vala"
	names_length1 = 0;
#line 1303 "panel.vala"
	_names_size_ = names_length1;
#line 6775 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1305 "panel.vala"
		name_collection = order_names;
#line 1305 "panel.vala"
		name_collection_length1 = order_names_length1;
#line 1305 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6787 "panel.c"
			gchar* _tmp7_;
			gchar* name = NULL;
#line 1305 "panel.vala"
			_tmp7_ = g_strdup (name_collection[name_it]);
#line 1305 "panel.vala"
			name = _tmp7_;
#line 6794 "panel.c"
			{
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
#line 1306 "panel.vala"
				_tmp8_ = name;
#line 1306 "panel.vala"
				_tmp9_ = engine_names;
#line 1306 "panel.vala"
				_tmp9__length1 = engine_names_length1;
#line 1306 "panel.vala"
				if (_vala_string_array_contains (_tmp9_, _tmp9__length1, _tmp8_)) {
#line 6807 "panel.c"
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 1307 "panel.vala"
					_tmp10_ = name;
#line 1307 "panel.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 1307 "panel.vala"
					_vala_array_add23 (&names, &names_length1, &_names_size_, _tmp11_);
#line 6816 "panel.c"
				}
#line 1305 "panel.vala"
				_g_free0 (name);
#line 6820 "panel.c"
			}
		}
	}
#line 1310 "panel.vala"
	_tmp12_ = engine_names;
#line 1310 "panel.vala"
	_tmp12__length1 = engine_names_length1;
#line 6828 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1310 "panel.vala"
		name_collection = _tmp12_;
#line 1310 "panel.vala"
		name_collection_length1 = _tmp12__length1;
#line 1310 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6840 "panel.c"
			gchar* _tmp13_;
			gchar* name = NULL;
#line 1310 "panel.vala"
			_tmp13_ = g_strdup (name_collection[name_it]);
#line 1310 "panel.vala"
			name = _tmp13_;
#line 6847 "panel.c"
			{
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 1311 "panel.vala"
				_tmp14_ = name;
#line 1311 "panel.vala"
				_tmp15_ = names;
#line 1311 "panel.vala"
				_tmp15__length1 = names_length1;
#line 1311 "panel.vala"
				if (_vala_string_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
#line 1312 "panel.vala"
					_g_free0 (name);
#line 1312 "panel.vala"
					continue;
#line 6866 "panel.c"
				}
#line 1313 "panel.vala"
				_tmp16_ = name;
#line 1313 "panel.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 1313 "panel.vala"
				_vala_array_add24 (&names, &names_length1, &_names_size_, _tmp17_);
#line 1310 "panel.vala"
				_g_free0 (name);
#line 6876 "panel.c"
			}
		}
	}
#line 1316 "panel.vala"
	_tmp18_ = self->priv->m_bus;
#line 1316 "panel.vala"
	_tmp19_ = names;
#line 1316 "panel.vala"
	_tmp19__length1 = names_length1;
#line 1316 "panel.vala"
	_tmp21_ = _tmp20_ = ibus_bus_get_engines_by_names (_tmp18_, _tmp19_);
#line 1316 "panel.vala"
	engines = _tmp21_;
#line 1316 "panel.vala"
	engines_length1 = _vala_array_length (_tmp20_);
#line 1316 "panel.vala"
	_engines_size_ = engines_length1;
#line 1321 "panel.vala"
	_tmp22_ = engines;
#line 1321 "panel.vala"
	_tmp22__length1 = engines_length1;
#line 1321 "panel.vala"
	_tmp23_ = names;
#line 1321 "panel.vala"
	_tmp23__length1 = names_length1;
#line 1321 "panel.vala"
	if (_tmp22__length1 < _tmp23__length1) {
#line 6904 "panel.c"
		Block13Data* _data13_;
		gchar* message1 = NULL;
		IBusEngineDesc** _tmp24_;
		gint _tmp24__length1;
		gchar* message2 = NULL;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		GtkMessageDialog* _tmp40_;
		GtkMessageDialog* _tmp41_;
		GtkMessageDialog* _tmp42_;
#line 1321 "panel.vala"
		_data13_ = g_slice_new0 (Block13Data);
#line 1321 "panel.vala"
		_data13_->_ref_count_ = 1;
#line 1321 "panel.vala"
		_data13_->self = g_object_ref (self);
#line 1323 "panel.vala"
		_tmp24_ = engines;
#line 1323 "panel.vala"
		_tmp24__length1 = engines_length1;
#line 1323 "panel.vala"
		if (_tmp24__length1 == 0) {
#line 6928 "panel.c"
			gchar** fallback_names = NULL;
			gchar* _tmp25_;
			gchar** _tmp26_;
			gint fallback_names_length1;
			gint _fallback_names_size_;
			GSettings* _tmp27_;
			gchar** _tmp28_;
			gint _tmp28__length1;
			IBusBus* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			IBusEngineDesc** _tmp31_;
			IBusEngineDesc** _tmp32_;
			gchar** _tmp33_;
			gint _tmp33__length1;
			const gchar* _tmp34_;
			gchar* _tmp35_;
#line 1324 "panel.vala"
			_tmp25_ = g_strdup ("xkb:us::eng");
#line 1324 "panel.vala"
			_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 1324 "panel.vala"
			_tmp26_[0] = _tmp25_;
#line 1324 "panel.vala"
			fallback_names = _tmp26_;
#line 1324 "panel.vala"
			fallback_names_length1 = 1;
#line 1324 "panel.vala"
			_fallback_names_size_ = fallback_names_length1;
#line 1325 "panel.vala"
			_tmp27_ = self->priv->m_settings_general;
#line 1325 "panel.vala"
			_tmp28_ = fallback_names;
#line 1325 "panel.vala"
			_tmp28__length1 = fallback_names_length1;
#line 1325 "panel.vala"
			g_settings_set_strv (_tmp27_, "preload-engines", _tmp28_);
#line 1326 "panel.vala"
			_tmp29_ = self->priv->m_bus;
#line 1326 "panel.vala"
			_tmp30_ = fallback_names;
#line 1326 "panel.vala"
			_tmp30__length1 = fallback_names_length1;
#line 1326 "panel.vala"
			_tmp32_ = _tmp31_ = ibus_bus_get_engines_by_names (_tmp29_, _tmp30_);
#line 1326 "panel.vala"
			engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1326 "panel.vala"
			engines = _tmp32_;
#line 1326 "panel.vala"
			engines_length1 = _vala_array_length (_tmp31_);
#line 1326 "panel.vala"
			_engines_size_ = engines_length1;
#line 1327 "panel.vala"
			_tmp33_ = names;
#line 1327 "panel.vala"
			_tmp33__length1 = names_length1;
#line 1327 "panel.vala"
			_tmp34_ = _tmp33_[0];
#line 1327 "panel.vala"
			_tmp35_ = g_strdup_printf (_ ("Your configured input method %s does not exist " "in IBus input methods so \"US\" layout was " "configured instead of your input method."), _tmp34_);
#line 1327 "panel.vala"
			_g_free0 (message1);
#line 1327 "panel.vala"
			message1 = _tmp35_;
#line 1323 "panel.vala"
			fallback_names = (_vala_array_free (fallback_names, fallback_names_length1, (GDestroyNotify) g_free), NULL);
#line 6996 "panel.c"
		} else {
			gchar* _tmp36_;
#line 1332 "panel.vala"
			_tmp36_ = g_strdup (_ ("At least one of your configured input methods " "does not exist in IBus input methods."));
#line 1332 "panel.vala"
			_g_free0 (message1);
#line 1332 "panel.vala"
			message1 = _tmp36_;
#line 7005 "panel.c"
		}
#line 1335 "panel.vala"
		_tmp37_ = g_strdup (_ ("Please run `ibus-setup` command, open \"Input " "Method\" tab, and configure your input methods " "again."));
#line 1335 "panel.vala"
		message2 = _tmp37_;
#line 1338 "panel.vala"
		_tmp38_ = message1;
#line 1338 "panel.vala"
		_tmp39_ = message2;
#line 1338 "panel.vala"
		_tmp40_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "%s %s", _tmp38_, _tmp39_);
#line 1338 "panel.vala"
		g_object_ref_sink (_tmp40_);
#line 1338 "panel.vala"
		_data13_->dialog = _tmp40_;
#line 1344 "panel.vala"
		_tmp41_ = _data13_->dialog;
#line 1344 "panel.vala"
		g_signal_connect_data ((GtkDialog*) _tmp41_, "response", (GCallback) ____lambda67__gtk_dialog_response, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 1347 "panel.vala"
		_tmp42_ = _data13_->dialog;
#line 1347 "panel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp42_);
#line 1321 "panel.vala"
		_g_free0 (message2);
#line 1321 "panel.vala"
		_g_free0 (message1);
#line 1321 "panel.vala"
		block13_data_unref (_data13_);
#line 1321 "panel.vala"
		_data13_ = NULL;
#line 7037 "panel.c"
	}
#line 1350 "panel.vala"
	_tmp43_ = self->priv->m_engines;
#line 1350 "panel.vala"
	_tmp43__length1 = self->priv->m_engines_length1;
#line 1350 "panel.vala"
	if (_tmp43__length1 == 0) {
#line 7045 "panel.c"
		IBusEngineDesc** _tmp44_;
		gint _tmp44__length1;
		IBusEngineDesc** _tmp45_;
		gint _tmp45__length1;
		IBusEngineDesc** _tmp46_;
		gint _tmp46__length1;
#line 1351 "panel.vala"
		_tmp44_ = engines;
#line 1351 "panel.vala"
		_tmp44__length1 = engines_length1;
#line 1351 "panel.vala"
		_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup3 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 1351 "panel.vala"
		_tmp45__length1 = _tmp44__length1;
#line 1351 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1351 "panel.vala"
		self->priv->m_engines = _tmp45_;
#line 1351 "panel.vala"
		self->priv->m_engines_length1 = _tmp45__length1;
#line 1351 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 1352 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1353 "panel.vala"
		_tmp46_ = self->priv->m_engines;
#line 1353 "panel.vala"
		_tmp46__length1 = self->priv->m_engines_length1;
#line 1353 "panel.vala"
		panel_run_preload_engines (self, _tmp46_, (gint) _tmp46__length1, 1);
#line 7076 "panel.c"
	} else {
		IBusEngineDesc* current_engine = NULL;
		IBusEngineDesc** _tmp47_;
		gint _tmp47__length1;
		IBusEngineDesc* _tmp48_;
		IBusEngineDesc* _tmp49_;
		IBusEngineDesc** _tmp50_;
		gint _tmp50__length1;
		IBusEngineDesc** _tmp51_;
		gint _tmp51__length1;
		gint i = 0;
		IBusEngineDesc** _tmp62_;
		gint _tmp62__length1;
#line 1355 "panel.vala"
		_tmp47_ = self->priv->m_engines;
#line 1355 "panel.vala"
		_tmp47__length1 = self->priv->m_engines_length1;
#line 1355 "panel.vala"
		_tmp48_ = _tmp47_[0];
#line 1355 "panel.vala"
		_tmp49_ = _g_object_ref0 (_tmp48_);
#line 1355 "panel.vala"
		current_engine = _tmp49_;
#line 1356 "panel.vala"
		_tmp50_ = engines;
#line 1356 "panel.vala"
		_tmp50__length1 = engines_length1;
#line 1356 "panel.vala"
		_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup4 (_tmp50_, _tmp50__length1) : _tmp50_;
#line 1356 "panel.vala"
		_tmp51__length1 = _tmp50__length1;
#line 1356 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1356 "panel.vala"
		self->priv->m_engines = _tmp51_;
#line 1356 "panel.vala"
		self->priv->m_engines_length1 = _tmp51__length1;
#line 1356 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 7116 "panel.c"
		{
			gboolean _tmp52_ = FALSE;
#line 1358 "panel.vala"
			i = 0;
#line 1358 "panel.vala"
			_tmp52_ = TRUE;
#line 1358 "panel.vala"
			while (TRUE) {
#line 7125 "panel.c"
				IBusEngineDesc** _tmp54_;
				gint _tmp54__length1;
				IBusEngineDesc* _tmp55_;
				const gchar* _tmp56_;
				IBusEngineDesc** _tmp57_;
				gint _tmp57__length1;
				IBusEngineDesc* _tmp58_;
				const gchar* _tmp59_;
#line 1358 "panel.vala"
				if (!_tmp52_) {
#line 7136 "panel.c"
					gint _tmp53_;
#line 1358 "panel.vala"
					_tmp53_ = i;
#line 1358 "panel.vala"
					i = _tmp53_ + 1;
#line 7142 "panel.c"
				}
#line 1358 "panel.vala"
				_tmp52_ = FALSE;
#line 1358 "panel.vala"
				_tmp54_ = self->priv->m_engines;
#line 1358 "panel.vala"
				_tmp54__length1 = self->priv->m_engines_length1;
#line 1358 "panel.vala"
				if (!(i < _tmp54__length1)) {
#line 1358 "panel.vala"
					break;
#line 7154 "panel.c"
				}
#line 1359 "panel.vala"
				_tmp55_ = current_engine;
#line 1359 "panel.vala"
				_tmp56_ = ibus_engine_desc_get_name (_tmp55_);
#line 1359 "panel.vala"
				_tmp57_ = engines;
#line 1359 "panel.vala"
				_tmp57__length1 = engines_length1;
#line 1359 "panel.vala"
				_tmp58_ = _tmp57_[i];
#line 1359 "panel.vala"
				_tmp59_ = ibus_engine_desc_get_name (_tmp58_);
#line 1359 "panel.vala"
				if (g_strcmp0 (_tmp56_, _tmp59_) == 0) {
#line 1360 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1361 "panel.vala"
					if (i != 0) {
#line 7174 "panel.c"
						IBusEngineDesc** _tmp60_;
						gint _tmp60__length1;
#line 1362 "panel.vala"
						_tmp60_ = engines;
#line 1362 "panel.vala"
						_tmp60__length1 = engines_length1;
#line 1362 "panel.vala"
						panel_run_preload_engines (self, _tmp60_, (gint) _tmp60__length1, 0);
#line 7183 "panel.c"
					} else {
						IBusEngineDesc** _tmp61_;
						gint _tmp61__length1;
#line 1364 "panel.vala"
						_tmp61_ = engines;
#line 1364 "panel.vala"
						_tmp61__length1 = engines_length1;
#line 1364 "panel.vala"
						panel_run_preload_engines (self, _tmp61_, (gint) _tmp61__length1, 1);
#line 7193 "panel.c"
					}
#line 1366 "panel.vala"
					_g_object_unref0 (current_engine);
#line 1366 "panel.vala"
					engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1366 "panel.vala"
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1366 "panel.vala"
					engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1366 "panel.vala"
					return;
#line 7205 "panel.c"
				}
			}
		}
#line 1369 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1370 "panel.vala"
		_tmp62_ = engines;
#line 1370 "panel.vala"
		_tmp62__length1 = engines_length1;
#line 1370 "panel.vala"
		panel_run_preload_engines (self, _tmp62_, (gint) _tmp62__length1, 1);
#line 1350 "panel.vala"
		_g_object_unref0 (current_engine);
#line 7219 "panel.c"
	}
#line 1296 "panel.vala"
	engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1296 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1296 "panel.vala"
	engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 7227 "panel.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 1385 "panel.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 7235 "panel.c"
}

static void
panel_context_render_string (Panel* self,
                             cairo_t* cr,
                             const gchar* symbol,
                             gint image_width,
                             gint image_height)
{
	gint lwidth = 0;
	gint lheight = 0;
	PangoFontDescription* desc = NULL;
	PangoFontDescription* _tmp0_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	PangoLayout* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoLayout* _tmp7_;
	PangoLayout* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	PangoLayout* _tmp15_;
#line 1375 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1375 "panel.vala"
	g_return_if_fail (cr != NULL);
#line 1375 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1379 "panel.vala"
	lwidth = 0;
#line 1380 "panel.vala"
	lheight = 0;
#line 1381 "panel.vala"
	_tmp0_ = pango_font_description_from_string ("Monospace Bold 22");
#line 1381 "panel.vala"
	desc = _tmp0_;
#line 1382 "panel.vala"
	_tmp1_ = pango_cairo_create_layout (cr);
#line 1382 "panel.vala"
	layout = _tmp1_;
#line 1384 "panel.vala"
	_tmp2_ = strlen (symbol);
#line 1384 "panel.vala"
	_tmp3_ = _tmp2_;
#line 1384 "panel.vala"
	if (_tmp3_ >= 3) {
#line 7288 "panel.c"
		PangoFontDescription* _tmp4_;
#line 1385 "panel.vala"
		_tmp4_ = pango_font_description_from_string ("Monospace Bold 18");
#line 1385 "panel.vala"
		__vala_PangoFontDescription_free0 (desc);
#line 1385 "panel.vala"
		desc = _tmp4_;
#line 7296 "panel.c"
	}
#line 1387 "panel.vala"
	_tmp5_ = layout;
#line 1387 "panel.vala"
	_tmp6_ = desc;
#line 1387 "panel.vala"
	pango_layout_set_font_description (_tmp5_, _tmp6_);
#line 1388 "panel.vala"
	_tmp7_ = layout;
#line 1388 "panel.vala"
	pango_layout_set_text (_tmp7_, symbol, -1);
#line 1389 "panel.vala"
	_tmp8_ = layout;
#line 1389 "panel.vala"
	pango_layout_get_size (_tmp8_, &_tmp9_, &_tmp10_);
#line 1389 "panel.vala"
	lwidth = _tmp9_;
#line 1389 "panel.vala"
	lheight = _tmp10_;
#line 1390 "panel.vala"
	cairo_move_to (cr, (gdouble) ((image_width - (lwidth / PANGO_SCALE)) / 2), (gdouble) ((image_height - (lheight / PANGO_SCALE)) / 2));
#line 1392 "panel.vala"
	_tmp11_ = self->priv->m_xkb_icon_rgba;
#line 1392 "panel.vala"
	_tmp12_ = self->priv->m_xkb_icon_rgba;
#line 1392 "panel.vala"
	_tmp13_ = self->priv->m_xkb_icon_rgba;
#line 1392 "panel.vala"
	_tmp14_ = self->priv->m_xkb_icon_rgba;
#line 1392 "panel.vala"
	cairo_set_source_rgba (cr, _tmp11_.red, _tmp12_.green, _tmp13_.blue, _tmp14_.alpha);
#line 1396 "panel.vala"
	_tmp15_ = layout;
#line 1396 "panel.vala"
	pango_cairo_show_layout (cr, _tmp15_);
#line 1375 "panel.vala"
	_g_object_unref0 (layout);
#line 1375 "panel.vala"
	__vala_PangoFontDescription_free0 (desc);
#line 7336 "panel.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 1404 "panel.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 7344 "panel.c"
}

static cairo_surface_t*
panel_create_cairo_image_surface_with_string (Panel* self,
                                              const gchar* symbol,
                                              gboolean cache)
{
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	gint width = 0;
	cairo_surface_t* _tmp7_;
	gint height = 0;
	cairo_surface_t* _tmp8_;
	gint stride = 0;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_surface_t* result;
#line 1399 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1399 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1401 "panel.vala"
	image = NULL;
#line 1403 "panel.vala"
	if (cache) {
#line 7378 "panel.c"
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 1404 "panel.vala"
		_tmp0_ = self->priv->m_xkb_icon_image;
#line 1404 "panel.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1404 "panel.vala"
		_tmp2_ = _cairo_surface_reference0 ((cairo_surface_t*) _tmp1_);
#line 1404 "panel.vala"
		_cairo_surface_destroy0 (image);
#line 1404 "panel.vala"
		image = _tmp2_;
#line 1406 "panel.vala"
		_tmp3_ = image;
#line 1406 "panel.vala"
		if (_tmp3_ != NULL) {
#line 1407 "panel.vala"
			result = image;
#line 1407 "panel.vala"
			return result;
#line 7401 "panel.c"
		}
	}
#line 1410 "panel.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 48, 48);
#line 1410 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1410 "panel.vala"
	image = _tmp4_;
#line 1411 "panel.vala"
	_tmp5_ = image;
#line 1411 "panel.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 1411 "panel.vala"
	cr = _tmp6_;
#line 1412 "panel.vala"
	_tmp7_ = image;
#line 1412 "panel.vala"
	width = cairo_image_surface_get_width (_tmp7_);
#line 1413 "panel.vala"
	_tmp8_ = image;
#line 1413 "panel.vala"
	height = cairo_image_surface_get_height (_tmp8_);
#line 1414 "panel.vala"
	_tmp9_ = image;
#line 1414 "panel.vala"
	stride = cairo_image_surface_get_stride (_tmp9_);
#line 1416 "panel.vala"
	_tmp10_ = cr;
#line 1416 "panel.vala"
	cairo_set_source_rgba (_tmp10_, 0.0, 0.0, 0.0, 0.0);
#line 1417 "panel.vala"
	_tmp11_ = cr;
#line 1417 "panel.vala"
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
#line 1418 "panel.vala"
	_tmp12_ = cr;
#line 1418 "panel.vala"
	cairo_paint (_tmp12_);
#line 1419 "panel.vala"
	_tmp13_ = cr;
#line 1419 "panel.vala"
	cairo_set_operator (_tmp13_, CAIRO_OPERATOR_OVER);
#line 1420 "panel.vala"
	_tmp14_ = cr;
#line 1420 "panel.vala"
	panel_context_render_string (self, _tmp14_, symbol, width, height);
#line 1421 "panel.vala"
	_tmp15_ = image;
#line 1421 "panel.vala"
	cairo_surface_flush (_tmp15_);
#line 1423 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 1424 "panel.vala"
		if (G_BYTE_ORDER == G_LITTLE_ENDIAN) {
#line 7456 "panel.c"
			guint* data = NULL;
			cairo_surface_t* _tmp16_;
			guchar* _tmp17_;
			gint data_length1;
			gint _data_size_;
			gint length = 0;
#line 1425 "panel.vala"
			_tmp16_ = image;
#line 1425 "panel.vala"
			_tmp17_ = cairo_image_surface_get_data (_tmp16_);
#line 1425 "panel.vala"
			data = (guint*) _tmp17_;
#line 1425 "panel.vala"
			data_length1 = (-1 * sizeof (guchar)) / sizeof (guint);
#line 1425 "panel.vala"
			_data_size_ = data_length1;
#line 1426 "panel.vala"
			length = (stride * height) / ((gint) sizeof (guint));
#line 7475 "panel.c"
			{
				gint i = 0;
#line 1427 "panel.vala"
				i = 0;
#line 7480 "panel.c"
				{
					gboolean _tmp18_ = FALSE;
#line 1427 "panel.vala"
					_tmp18_ = TRUE;
#line 1427 "panel.vala"
					while (TRUE) {
#line 7487 "panel.c"
						guint* _tmp20_;
						gint _tmp20__length1;
						guint* _tmp21_;
						gint _tmp21__length1;
						guint _tmp22_;
#line 1427 "panel.vala"
						if (!_tmp18_) {
#line 7495 "panel.c"
							gint _tmp19_;
#line 1427 "panel.vala"
							_tmp19_ = i;
#line 1427 "panel.vala"
							i = _tmp19_ + 1;
#line 7501 "panel.c"
						}
#line 1427 "panel.vala"
						_tmp18_ = FALSE;
#line 1427 "panel.vala"
						if (!(i < length)) {
#line 1427 "panel.vala"
							break;
#line 7509 "panel.c"
						}
#line 1428 "panel.vala"
						_tmp20_ = data;
#line 1428 "panel.vala"
						_tmp20__length1 = data_length1;
#line 1428 "panel.vala"
						_tmp21_ = data;
#line 1428 "panel.vala"
						_tmp21__length1 = data_length1;
#line 1428 "panel.vala"
						_tmp22_ = _tmp21_[i];
#line 1428 "panel.vala"
						_tmp20_[i] = GUINT_TO_BE (_tmp22_);
#line 7523 "panel.c"
					}
				}
			}
		}
	}
#line 1432 "panel.vala"
	if (cache) {
#line 7531 "panel.c"
		GHashTable* _tmp23_;
		gchar* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
#line 1433 "panel.vala"
		_tmp23_ = self->priv->m_xkb_icon_image;
#line 1433 "panel.vala"
		_tmp24_ = g_strdup (symbol);
#line 1433 "panel.vala"
		_tmp25_ = image;
#line 1433 "panel.vala"
		_tmp26_ = _cairo_surface_reference0 (_tmp25_);
#line 1433 "panel.vala"
		g_hash_table_insert (_tmp23_, _tmp24_, _tmp26_);
#line 7546 "panel.c"
	}
#line 1435 "panel.vala"
	result = image;
#line 1435 "panel.vala"
	_cairo_destroy0 (cr);
#line 1435 "panel.vala"
	return result;
#line 7554 "panel.c"
}

static GdkPixbuf*
panel_create_icon_pixbuf_with_string (Panel* self,
                                      const gchar* symbol)
{
	GdkPixbuf* pixbuf = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	gint width = 0;
	cairo_surface_t* _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	GdkPixbuf* _tmp8_;
	GHashTable* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* result;
#line 1438 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1438 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1439 "panel.vala"
	_tmp0_ = self->priv->m_xkb_icon_pixbufs;
#line 1439 "panel.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1439 "panel.vala"
	_tmp2_ = _g_object_ref0 ((GdkPixbuf*) _tmp1_);
#line 1439 "panel.vala"
	pixbuf = _tmp2_;
#line 1441 "panel.vala"
	_tmp3_ = pixbuf;
#line 1441 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1442 "panel.vala"
		result = pixbuf;
#line 1442 "panel.vala"
		return result;
#line 7599 "panel.c"
	}
#line 1444 "panel.vala"
	_tmp4_ = panel_create_cairo_image_surface_with_string (self, symbol, FALSE);
#line 1444 "panel.vala"
	image = _tmp4_;
#line 1445 "panel.vala"
	_tmp5_ = image;
#line 1445 "panel.vala"
	width = cairo_image_surface_get_width (_tmp5_);
#line 1446 "panel.vala"
	_tmp6_ = image;
#line 1446 "panel.vala"
	height = cairo_image_surface_get_height (_tmp6_);
#line 1447 "panel.vala"
	_tmp7_ = image;
#line 1447 "panel.vala"
	_tmp8_ = gdk_pixbuf_get_from_surface (_tmp7_, 0, 0, width, height);
#line 1447 "panel.vala"
	_g_object_unref0 (pixbuf);
#line 1447 "panel.vala"
	pixbuf = _tmp8_;
#line 1448 "panel.vala"
	_tmp9_ = self->priv->m_xkb_icon_pixbufs;
#line 1448 "panel.vala"
	_tmp10_ = g_strdup (symbol);
#line 1448 "panel.vala"
	_tmp11_ = pixbuf;
#line 1448 "panel.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1448 "panel.vala"
	g_hash_table_insert (_tmp9_, _tmp10_, _tmp12_);
#line 1449 "panel.vala"
	result = pixbuf;
#line 1449 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1449 "panel.vala"
	return result;
#line 7637 "panel.c"
}

static void
__lambda94_ (Panel* self,
             GPid pid,
             gint state)
{
#line 1473 "panel.vala"
	if (pid != self->priv->m_setup_pid) {
#line 1474 "panel.vala"
		return;
#line 7649 "panel.c"
	}
#line 1475 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 1476 "panel.vala"
	g_spawn_close_pid (pid);
#line 7655 "panel.c"
}

static void
___lambda94__gchild_watch_func (GPid pid,
                                gint wait_status,
                                gpointer self)
{
#line 1472 "panel.vala"
	__lambda94_ ((Panel*) self, pid, wait_status);
#line 7665 "panel.c"
}

static void
panel_show_setup_dialog (Panel* self)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1452 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1453 "panel.vala"
	if (self->priv->m_setup_pid != ((GPid) 0)) {
#line 1454 "panel.vala"
		if (kill ((pid_t) self->priv->m_setup_pid, (gint) SIGUSR1) == 0) {
#line 1455 "panel.vala"
			return;
#line 7682 "panel.c"
		}
#line 1456 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 7686 "panel.c"
	}
#line 1459 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus-setup", NULL);
#line 1459 "panel.vala"
	binary = _tmp0_;
#line 7692 "panel.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		GPid _tmp6_ = 0;
#line 1461 "panel.vala"
		_tmp1_ = binary;
#line 1461 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1461 "panel.vala"
		_tmp3_ = g_strdup ("ibus-setup");
#line 1461 "panel.vala"
		_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 1461 "panel.vala"
		_tmp4_[0] = _tmp2_;
#line 1461 "panel.vala"
		_tmp4_[1] = _tmp3_;
#line 1461 "panel.vala"
		_tmp5_ = _tmp4_;
#line 1461 "panel.vala"
		_tmp5__length1 = 2;
#line 1461 "panel.vala"
		g_spawn_async (NULL, _tmp5_, NULL, G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp6_, &_inner_error0_);
#line 1461 "panel.vala"
		self->priv->m_setup_pid = _tmp6_;
#line 1461 "panel.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 1461 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1461 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 7727 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1461 "panel.vala"
			_g_free0 (binary);
#line 1461 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1461 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1461 "panel.vala"
			return;
#line 7738 "panel.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1460 "panel.vala"
		e = _inner_error0_;
#line 1460 "panel.vala"
		_inner_error0_ = NULL;
#line 1468 "panel.vala"
		_tmp7_ = binary;
#line 1468 "panel.vala"
		_tmp8_ = e;
#line 1468 "panel.vala"
		_tmp9_ = _tmp8_->message;
#line 1468 "panel.vala"
		g_warning ("panel.vala:1468: Execute %s failed! %s", _tmp7_, _tmp9_);
#line 1469 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 1460 "panel.vala"
		_g_error_free0 (e);
#line 7764 "panel.c"
	}
	__finally0:
#line 1460 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1460 "panel.vala"
		_g_free0 (binary);
#line 1460 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1460 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1460 "panel.vala"
		return;
#line 7777 "panel.c"
	}
#line 1472 "panel.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->m_setup_pid, ___lambda94__gchild_watch_func, g_object_ref (self), g_object_unref);
#line 1452 "panel.vala"
	_g_free0 (binary);
#line 7783 "panel.c"
}

static void
panel_show_about_dialog (Panel* self)
{
	GtkAboutDialog* _tmp0_;
	GtkAboutDialog* _tmp21_;
#line 1480 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1481 "panel.vala"
	_tmp0_ = self->priv->m_about_dialog;
#line 1481 "panel.vala"
	if (_tmp0_ == NULL) {
#line 7797 "panel.c"
		GtkAboutDialog* _tmp1_;
		GtkAboutDialog* _tmp2_;
		GtkAboutDialog* _tmp3_;
		gchar* copyright = NULL;
		gchar* _tmp4_;
		GtkAboutDialog* _tmp5_;
		const gchar* _tmp6_;
		GtkAboutDialog* _tmp7_;
		GtkAboutDialog* _tmp8_;
		GtkAboutDialog* _tmp9_;
		GtkAboutDialog* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GtkAboutDialog* _tmp14_;
		gchar* _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		GtkAboutDialog* _tmp18_;
		GtkAboutDialog* _tmp19_;
		GtkAboutDialog* _tmp20_;
#line 1482 "panel.vala"
		_tmp1_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 1482 "panel.vala"
		g_object_ref_sink (_tmp1_);
#line 1482 "panel.vala"
		_g_object_unref0 (self->priv->m_about_dialog);
#line 1482 "panel.vala"
		self->priv->m_about_dialog = _tmp1_;
#line 1483 "panel.vala"
		_tmp2_ = self->priv->m_about_dialog;
#line 1483 "panel.vala"
		gtk_about_dialog_set_program_name (_tmp2_, "IBus");
#line 1484 "panel.vala"
		_tmp3_ = self->priv->m_about_dialog;
#line 1484 "panel.vala"
		gtk_about_dialog_set_version (_tmp3_, PACKAGE_VERSION);
#line 1486 "panel.vala"
		_tmp4_ = g_strdup ("Copyright © 2007-2015 Peng Huang\n" "Copyright © 2015-2022 Takao Fujiwara\n" "Copyright © 2007-2015 Red Hat, Inc.\n");
#line 1486 "panel.vala"
		copyright = _tmp4_;
#line 1491 "panel.vala"
		_tmp5_ = self->priv->m_about_dialog;
#line 1491 "panel.vala"
		_tmp6_ = copyright;
#line 1491 "panel.vala"
		gtk_about_dialog_set_copyright (_tmp5_, _tmp6_);
#line 1492 "panel.vala"
		_tmp7_ = self->priv->m_about_dialog;
#line 1492 "panel.vala"
		gtk_about_dialog_set_license (_tmp7_, "LGPL");
#line 1493 "panel.vala"
		_tmp8_ = self->priv->m_about_dialog;
#line 1493 "panel.vala"
		gtk_about_dialog_set_comments (_tmp8_, _ ("IBus is an intelligent input bus for Linux/Unix."));
#line 1494 "panel.vala"
		_tmp9_ = self->priv->m_about_dialog;
#line 1494 "panel.vala"
		gtk_about_dialog_set_website (_tmp9_, "https://github.com/ibus/ibus/wiki");
#line 1495 "panel.vala"
		_tmp10_ = self->priv->m_about_dialog;
#line 1495 "panel.vala"
		_tmp11_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1495 "panel.vala"
		_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 1495 "panel.vala"
		_tmp12_[0] = _tmp11_;
#line 1495 "panel.vala"
		_tmp13_ = _tmp12_;
#line 1495 "panel.vala"
		_tmp13__length1 = 1;
#line 1495 "panel.vala"
		gtk_about_dialog_set_authors (_tmp10_, _tmp13_);
#line 1495 "panel.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 1496 "panel.vala"
		_tmp14_ = self->priv->m_about_dialog;
#line 1496 "panel.vala"
		_tmp15_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1496 "panel.vala"
		_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 1496 "panel.vala"
		_tmp16_[0] = _tmp15_;
#line 1496 "panel.vala"
		_tmp17_ = _tmp16_;
#line 1496 "panel.vala"
		_tmp17__length1 = 1;
#line 1496 "panel.vala"
		gtk_about_dialog_set_documenters (_tmp14_, _tmp17_);
#line 1496 "panel.vala"
		_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 1497 "panel.vala"
		_tmp18_ = self->priv->m_about_dialog;
#line 1497 "panel.vala"
		gtk_about_dialog_set_translator_credits (_tmp18_, _ ("translator-credits"));
#line 1498 "panel.vala"
		_tmp19_ = self->priv->m_about_dialog;
#line 1498 "panel.vala"
		gtk_about_dialog_set_logo_icon_name (_tmp19_, "ibus");
#line 1499 "panel.vala"
		_tmp20_ = self->priv->m_about_dialog;
#line 1499 "panel.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp20_, "ibus");
#line 1481 "panel.vala"
		_g_free0 (copyright);
#line 7905 "panel.c"
	}
#line 1502 "panel.vala"
	_tmp21_ = self->priv->m_about_dialog;
#line 1502 "panel.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp21_)) {
#line 7911 "panel.c"
		GtkAboutDialog* _tmp22_;
		GtkAboutDialog* _tmp23_;
#line 1503 "panel.vala"
		_tmp22_ = self->priv->m_about_dialog;
#line 1503 "panel.vala"
		gtk_dialog_run ((GtkDialog*) _tmp22_);
#line 1504 "panel.vala"
		_tmp23_ = self->priv->m_about_dialog;
#line 1504 "panel.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 7922 "panel.c"
	} else {
		GtkAboutDialog* _tmp24_;
#line 1506 "panel.vala"
		_tmp24_ = self->priv->m_about_dialog;
#line 1506 "panel.vala"
		gtk_window_present ((GtkWindow*) _tmp24_);
#line 7929 "panel.c"
	}
}

static void
_vala_array_add25 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1514 "panel.vala"
	if ((*length) == (*size)) {
#line 1514 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1514 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7945 "panel.c"
	}
#line 1514 "panel.vala"
	(*array)[(*length)++] = value;
#line 1514 "panel.vala"
	(*array)[*length] = NULL;
#line 7951 "panel.c"
}

static void
_vala_array_add26 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1515 "panel.vala"
	if ((*length) == (*size)) {
#line 1515 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1515 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7966 "panel.c"
	}
#line 1515 "panel.vala"
	(*array)[(*length)++] = value;
#line 1515 "panel.vala"
	(*array)[*length] = NULL;
#line 7972 "panel.c"
}

static void
_vala_array_add27 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1517 "panel.vala"
	if ((*length) == (*size)) {
#line 1517 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1517 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7987 "panel.c"
	}
#line 1517 "panel.vala"
	(*array)[(*length)++] = value;
#line 1517 "panel.vala"
	(*array)[*length] = NULL;
#line 7993 "panel.c"
}

static void
panel_run_ibus_command (Panel* self,
                        const gchar* args)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1510 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1510 "panel.vala"
	g_return_if_fail (args != NULL);
#line 1511 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus", NULL);
#line 1511 "panel.vala"
	binary = _tmp0_;
#line 8011 "panel.c"
	{
		gchar** _args = NULL;
		gchar** _tmp1_;
		gint _args_length1;
		gint __args_size_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gchar* standard_out = NULL;
		gchar* standard_error = NULL;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		const gchar* _tmp13_;
		const gchar* _tmp15_;
#line 1513 "panel.vala"
		_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 1513 "panel.vala"
		_args = _tmp1_;
#line 1513 "panel.vala"
		_args_length1 = 0;
#line 1513 "panel.vala"
		__args_size_ = _args_length1;
#line 1514 "panel.vala"
		_tmp2_ = binary;
#line 1514 "panel.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 1514 "panel.vala"
		_vala_array_add25 (&_args, &_args_length1, &__args_size_, _tmp3_);
#line 1515 "panel.vala"
		_tmp4_ = g_strdup (args);
#line 1515 "panel.vala"
		_vala_array_add26 (&_args, &_args_length1, &__args_size_, _tmp4_);
#line 1516 "panel.vala"
		if (g_strcmp0 (args, "exit") == 0) {
#line 1516 "panel.vala"
			_tmp5_ = TRUE;
#line 8055 "panel.c"
		} else {
#line 1516 "panel.vala"
			_tmp5_ = g_strcmp0 (args, "restart") == 0;
#line 8059 "panel.c"
		}
#line 1516 "panel.vala"
		if (_tmp5_) {
#line 8063 "panel.c"
			gchar* _tmp6_;
#line 1517 "panel.vala"
			_tmp6_ = g_strdup ("--type=kde-wayland");
#line 1517 "panel.vala"
			_vala_array_add27 (&_args, &_args_length1, &__args_size_, _tmp6_);
#line 8069 "panel.c"
		}
#line 1518 "panel.vala"
		standard_out = NULL;
#line 1519 "panel.vala"
		standard_error = NULL;
#line 1520 "panel.vala"
		_tmp7_ = _args;
#line 1520 "panel.vala"
		_tmp7__length1 = _args_length1;
#line 1520 "panel.vala"
		_tmp9_ = _tmp8_ = g_get_environ ();
#line 1520 "panel.vala"
		_tmp10_ = _tmp9_;
#line 1520 "panel.vala"
		_tmp10__length1 = _vala_array_length (_tmp8_);
#line 1520 "panel.vala"
		g_spawn_sync (NULL, _tmp7_, _tmp10_, 0, NULL, NULL, &_tmp11_, &_tmp12_, NULL, &_inner_error0_);
#line 1520 "panel.vala"
		_g_free0 (standard_out);
#line 1520 "panel.vala"
		standard_out = _tmp11_;
#line 1520 "panel.vala"
		_g_free0 (standard_error);
#line 1520 "panel.vala"
		standard_error = _tmp12_;
#line 1520 "panel.vala"
		_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 1520 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1520 "panel.vala"
			_g_free0 (standard_error);
#line 1520 "panel.vala"
			_g_free0 (standard_out);
#line 1520 "panel.vala"
			_args = (_vala_array_free (_args, _args_length1, (GDestroyNotify) g_free), NULL);
#line 1520 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 8107 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1520 "panel.vala"
			_g_free0 (binary);
#line 1520 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1520 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1520 "panel.vala"
			return;
#line 8118 "panel.c"
		}
#line 1528 "panel.vala"
		_tmp13_ = standard_out;
#line 1528 "panel.vala"
		if (_tmp13_ != NULL) {
#line 8124 "panel.c"
			const gchar* _tmp14_;
#line 1529 "panel.vala"
			_tmp14_ = standard_out;
#line 1529 "panel.vala"
			g_print ("%s", _tmp14_);
#line 8130 "panel.c"
		}
#line 1530 "panel.vala"
		_tmp15_ = standard_error;
#line 1530 "panel.vala"
		if (_tmp15_ != NULL) {
#line 8136 "panel.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 1531 "panel.vala"
			_tmp16_ = binary;
#line 1531 "panel.vala"
			_tmp17_ = standard_error;
#line 1531 "panel.vala"
			g_warning ("panel.vala:1531: Execute %s failed! %s", _tmp16_, _tmp17_);
#line 8145 "panel.c"
		}
#line 1512 "panel.vala"
		_g_free0 (standard_error);
#line 1512 "panel.vala"
		_g_free0 (standard_out);
#line 1512 "panel.vala"
		_args = (_vala_array_free (_args, _args_length1, (GDestroyNotify) g_free), NULL);
#line 8153 "panel.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 1512 "panel.vala"
		e = _inner_error0_;
#line 1512 "panel.vala"
		_inner_error0_ = NULL;
#line 1533 "panel.vala"
		_tmp18_ = binary;
#line 1533 "panel.vala"
		_tmp19_ = e;
#line 1533 "panel.vala"
		_tmp20_ = _tmp19_->message;
#line 1533 "panel.vala"
		g_warning ("panel.vala:1533: Execute %s failed! %s", _tmp18_, _tmp20_);
#line 1512 "panel.vala"
		_g_error_free0 (e);
#line 8176 "panel.c"
	}
	__finally0:
#line 1512 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1512 "panel.vala"
		_g_free0 (binary);
#line 1512 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1512 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1512 "panel.vala"
		return;
#line 8189 "panel.c"
	}
#line 1510 "panel.vala"
	_g_free0 (binary);
#line 8193 "panel.c"
}

static void
__lambda93_ (Panel* self,
             GtkMenuItem* i)
{
#line 1539 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1539 "panel.vala"
	panel_show_setup_dialog (self);
#line 8204 "panel.c"
}

static void
___lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1539 "panel.vala"
	__lambda93_ ((Panel*) self, _sender);
#line 8213 "panel.c"
}

static void
panel_append_preferences_menu (Panel* self,
                               GtkMenu* menu)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
#line 1537 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1537 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 1538 "panel.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
#line 1538 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1538 "panel.vala"
	item = _tmp0_;
#line 1539 "panel.vala"
	g_signal_connect_object (item, "activate", (GCallback) ___lambda93__gtk_menu_item_activate, self, 0);
#line 1541 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, (GtkWidget*) item, -1);
#line 1537 "panel.vala"
	_g_object_unref0 (item);
#line 8238 "panel.c"
}

static void
__lambda95_ (Panel* self,
             GtkMenuItem* i)
{
	IBusExtensionEvent* event = NULL;
	IBusExtensionEvent* _tmp0_;
	IBusExtensionEvent* _tmp1_;
#line 1547 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1548 "panel.vala"
	_tmp0_ = ibus_extension_event_new ("name", "emoji", "is-enabled", TRUE, "params", "category-list", NULL);
#line 1548 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1548 "panel.vala"
	event = _tmp0_;
#line 1556 "panel.vala"
	_tmp1_ = _g_object_ref0 (event);
#line 1556 "panel.vala"
	ibus_panel_service_panel_extension ((IBusPanelService*) self, _tmp1_);
#line 1547 "panel.vala"
	_g_object_unref0 (event);
#line 8262 "panel.c"
}

static void
___lambda95__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1547 "panel.vala"
	__lambda95_ ((Panel*) self, _sender);
#line 8271 "panel.c"
}

static void
panel_append_emoji_menu (Panel* self,
                         GtkMenu* menu)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
#line 1544 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1544 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 1546 "panel.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Emoji Choice"));
#line 1546 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1546 "panel.vala"
	item = _tmp0_;
#line 1547 "panel.vala"
	g_signal_connect_object (item, "activate", (GCallback) ___lambda95__gtk_menu_item_activate, self, 0);
#line 1559 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, (GtkWidget*) item, -1);
#line 1544 "panel.vala"
	_g_object_unref0 (item);
#line 8296 "panel.c"
}

static void
__lambda96_ (Panel* self,
             GtkMenuItem* i)
{
#line 1586 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1586 "panel.vala"
	panel_show_about_dialog (self);
#line 8307 "panel.c"
}

static void
___lambda96__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1586 "panel.vala"
	__lambda96_ ((Panel*) self, _sender);
#line 8316 "panel.c"
}

static void
__lambda97_ (Panel* self,
             GtkMenuItem* i)
{
	gboolean _tmp0_ = FALSE;
#line 1592 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1593 "panel.vala"
	if (self->priv->m_is_indicator) {
#line 1593 "panel.vala"
		_tmp0_ = self->priv->m_is_wayland;
#line 8330 "panel.c"
	} else {
#line 1593 "panel.vala"
		_tmp0_ = FALSE;
#line 8334 "panel.c"
	}
#line 1593 "panel.vala"
	if (_tmp0_) {
#line 1594 "panel.vala"
		panel_run_ibus_command (self, "restart");
#line 8340 "panel.c"
	} else {
		IBusBus* _tmp1_;
#line 1596 "panel.vala"
		_tmp1_ = self->priv->m_bus;
#line 1596 "panel.vala"
		ibus_bus_exit (_tmp1_, TRUE);
#line 8347 "panel.c"
	}
}

static void
___lambda97__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1592 "panel.vala"
	__lambda97_ ((Panel*) self, _sender);
#line 8357 "panel.c"
}

static void
__lambda98_ (Panel* self,
             GtkMenuItem* i)
{
	gboolean _tmp0_ = FALSE;
#line 1601 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1602 "panel.vala"
	if (self->priv->m_is_indicator) {
#line 1602 "panel.vala"
		_tmp0_ = self->priv->m_is_wayland;
#line 8371 "panel.c"
	} else {
#line 1602 "panel.vala"
		_tmp0_ = FALSE;
#line 8375 "panel.c"
	}
#line 1602 "panel.vala"
	if (_tmp0_) {
#line 1603 "panel.vala"
		panel_run_ibus_command (self, "exit");
#line 8381 "panel.c"
	} else {
		IBusBus* _tmp1_;
#line 1605 "panel.vala"
		_tmp1_ = self->priv->m_bus;
#line 1605 "panel.vala"
		ibus_bus_exit (_tmp1_, FALSE);
#line 8388 "panel.c"
	}
}

static void
___lambda98__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1601 "panel.vala"
	__lambda98_ ((Panel*) self, _sender);
#line 8398 "panel.c"
}

static GtkMenu*
panel_create_context_menu (Panel* self,
                           gboolean use_x11)
{
	GtkMenu* _tmp0_;
	GdkDisplay* display_backup = NULL;
	gboolean _tmp3_ = FALSE;
	GtkMenuItem* item = NULL;
	GtkMenu* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkSeparatorMenuItem* _tmp18_;
	GtkSeparatorMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GdkDisplay* _tmp29_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenu* result;
#line 1564 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1565 "panel.vala"
	_tmp0_ = self->priv->m_sys_menu;
#line 1565 "panel.vala"
	if (_tmp0_ != NULL) {
#line 8438 "panel.c"
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 1566 "panel.vala"
		_tmp1_ = self->priv->m_sys_menu;
#line 1566 "panel.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1566 "panel.vala"
		result = _tmp2_;
#line 1566 "panel.vala"
		return result;
#line 8449 "panel.c"
	}
#line 1568 "panel.vala"
	display_backup = NULL;
#line 1569 "panel.vala"
	if (use_x11) {
#line 1569 "panel.vala"
		_tmp3_ = self->priv->m_is_wayland;
#line 8457 "panel.c"
	} else {
#line 1569 "panel.vala"
		_tmp3_ = FALSE;
#line 8461 "panel.c"
	}
#line 1569 "panel.vala"
	if (_tmp3_) {
#line 8465 "panel.c"
		GdkX11Display* display = NULL;
		GdkX11Display* _tmp4_;
		GdkDisplay* _tmp5_;
		GdkDisplay* _tmp6_;
		GdkX11Display* _tmp7_;
#line 1570 "panel.vala"
		_tmp4_ = binding_common_get_xdisplay (FALSE);
#line 1570 "panel.vala"
		display = _tmp4_;
#line 1571 "panel.vala"
		_tmp5_ = gdk_display_get_default ();
#line 1571 "panel.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1571 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1571 "panel.vala"
		display_backup = _tmp6_;
#line 1572 "panel.vala"
		_tmp7_ = display;
#line 1572 "panel.vala"
		if (_tmp7_ != NULL) {
#line 8487 "panel.c"
			GdkDisplayManager* _tmp8_;
			GdkX11Display* _tmp9_;
#line 1573 "panel.vala"
			_tmp8_ = gdk_display_manager_get ();
#line 1573 "panel.vala"
			_tmp9_ = display;
#line 1573 "panel.vala"
			gdk_display_manager_set_default_display (_tmp8_, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gdk_display_get_type (), GdkDisplay));
#line 8496 "panel.c"
		}
#line 1569 "panel.vala"
		_g_object_unref0 (display);
#line 8500 "panel.c"
	}
#line 1580 "panel.vala"
	_tmp10_ = (GtkMenu*) gtk_menu_new ();
#line 1580 "panel.vala"
	g_object_ref_sink (_tmp10_);
#line 1580 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 1580 "panel.vala"
	self->priv->m_sys_menu = _tmp10_;
#line 1582 "panel.vala"
	_tmp11_ = self->priv->m_sys_menu;
#line 1582 "panel.vala"
	panel_append_preferences_menu (self, _tmp11_);
#line 1583 "panel.vala"
	_tmp12_ = self->priv->m_sys_menu;
#line 1583 "panel.vala"
	panel_append_emoji_menu (self, _tmp12_);
#line 1585 "panel.vala"
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("About"));
#line 1585 "panel.vala"
	g_object_ref_sink (_tmp13_);
#line 1585 "panel.vala"
	_g_object_unref0 (item);
#line 1585 "panel.vala"
	item = _tmp13_;
#line 1586 "panel.vala"
	_tmp14_ = item;
#line 1586 "panel.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) ___lambda96__gtk_menu_item_activate, self, 0);
#line 1587 "panel.vala"
	_tmp15_ = self->priv->m_sys_menu;
#line 1587 "panel.vala"
	_tmp16_ = item;
#line 1587 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp15_, (GtkWidget*) _tmp16_, -1);
#line 1589 "panel.vala"
	_tmp17_ = self->priv->m_sys_menu;
#line 1589 "panel.vala"
	_tmp18_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1589 "panel.vala"
	g_object_ref_sink (_tmp18_);
#line 1589 "panel.vala"
	_tmp19_ = _tmp18_;
#line 1589 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp17_, (GtkWidget*) _tmp19_, -1);
#line 1589 "panel.vala"
	_g_object_unref0 (_tmp19_);
#line 1591 "panel.vala"
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restart"));
#line 1591 "panel.vala"
	g_object_ref_sink (_tmp20_);
#line 1591 "panel.vala"
	_g_object_unref0 (item);
#line 1591 "panel.vala"
	item = _tmp20_;
#line 1592 "panel.vala"
	_tmp21_ = item;
#line 1592 "panel.vala"
	g_signal_connect_object (_tmp21_, "activate", (GCallback) ___lambda97__gtk_menu_item_activate, self, 0);
#line 1598 "panel.vala"
	_tmp22_ = self->priv->m_sys_menu;
#line 1598 "panel.vala"
	_tmp23_ = item;
#line 1598 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp22_, (GtkWidget*) _tmp23_, -1);
#line 1600 "panel.vala"
	_tmp24_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit"));
#line 1600 "panel.vala"
	g_object_ref_sink (_tmp24_);
#line 1600 "panel.vala"
	_g_object_unref0 (item);
#line 1600 "panel.vala"
	item = _tmp24_;
#line 1601 "panel.vala"
	_tmp25_ = item;
#line 1601 "panel.vala"
	g_signal_connect_object (_tmp25_, "activate", (GCallback) ___lambda98__gtk_menu_item_activate, self, 0);
#line 1607 "panel.vala"
	_tmp26_ = self->priv->m_sys_menu;
#line 1607 "panel.vala"
	_tmp27_ = item;
#line 1607 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp26_, (GtkWidget*) _tmp27_, -1);
#line 1609 "panel.vala"
	_tmp28_ = self->priv->m_sys_menu;
#line 1609 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
#line 1611 "panel.vala"
	_tmp29_ = display_backup;
#line 1611 "panel.vala"
	if (_tmp29_ != NULL) {
#line 8592 "panel.c"
		GdkDisplayManager* _tmp30_;
		GdkDisplay* _tmp31_;
#line 1612 "panel.vala"
		_tmp30_ = gdk_display_manager_get ();
#line 1612 "panel.vala"
		_tmp31_ = display_backup;
#line 1612 "panel.vala"
		gdk_display_manager_set_default_display (_tmp30_, _tmp31_);
#line 8601 "panel.c"
	}
#line 1614 "panel.vala"
	_tmp32_ = self->priv->m_sys_menu;
#line 1614 "panel.vala"
	_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1614 "panel.vala"
	result = _tmp33_;
#line 1614 "panel.vala"
	_g_object_unref0 (item);
#line 1614 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1614 "panel.vala"
	return result;
#line 8615 "panel.c"
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 1636 "panel.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 1636 "panel.vala"
	return _data14_;
#line 8625 "panel.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 1636 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 8635 "panel.c"
		Panel* self;
#line 1636 "panel.vala"
		self = _data14_->self;
#line 1636 "panel.vala"
		_g_object_unref0 (_data14_->e);
#line 1636 "panel.vala"
		_g_object_unref0 (self);
#line 1636 "panel.vala"
		g_slice_free (Block14Data, _data14_);
#line 8645 "panel.c"
	}
}

static void
____lambda99_ (Block14Data* _data14_,
               GtkMenuItem* item)
{
	Panel* self;
#line 1646 "panel.vala"
	self = _data14_->self;
#line 1646 "panel.vala"
	g_return_if_fail (item != NULL);
#line 8658 "panel.c"
	{
		gint i = 0;
#line 1647 "panel.vala"
		i = 0;
#line 8663 "panel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1647 "panel.vala"
			_tmp0_ = TRUE;
#line 1647 "panel.vala"
			while (TRUE) {
#line 8670 "panel.c"
				IBusEngineDesc** _tmp2_;
				gint _tmp2__length1;
				IBusEngineDesc* _tmp3_;
				IBusEngineDesc** _tmp4_;
				gint _tmp4__length1;
				IBusEngineDesc* _tmp5_;
#line 1647 "panel.vala"
				if (!_tmp0_) {
#line 8679 "panel.c"
					gint _tmp1_;
#line 1647 "panel.vala"
					_tmp1_ = i;
#line 1647 "panel.vala"
					i = _tmp1_ + 1;
#line 8685 "panel.c"
				}
#line 1647 "panel.vala"
				_tmp0_ = FALSE;
#line 1647 "panel.vala"
				_tmp2_ = self->priv->m_engines;
#line 1647 "panel.vala"
				_tmp2__length1 = self->priv->m_engines_length1;
#line 1647 "panel.vala"
				if (!(i < _tmp2__length1)) {
#line 1647 "panel.vala"
					break;
#line 8697 "panel.c"
				}
#line 1648 "panel.vala"
				_tmp3_ = _data14_->e;
#line 1648 "panel.vala"
				_tmp4_ = self->priv->m_engines;
#line 1648 "panel.vala"
				_tmp4__length1 = self->priv->m_engines_length1;
#line 1648 "panel.vala"
				_tmp5_ = _tmp4_[i];
#line 1648 "panel.vala"
				if (_tmp3_ == _tmp5_) {
#line 1649 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1650 "panel.vala"
					break;
#line 8713 "panel.c"
				}
			}
		}
	}
}

static void
_____lambda99__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 1646 "panel.vala"
	____lambda99_ (self, _sender);
#line 8726 "panel.c"
}

static GtkMenu*
panel_create_activate_menu (Panel* self,
                            gboolean use_x11)
{
	GdkDisplay* display_backup = NULL;
	gboolean _tmp0_ = FALSE;
	GtkMenu* _tmp7_;
	PropertyManager* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenu* _tmp10_;
	GtkSeparatorMenuItem* _tmp11_;
	GtkSeparatorMenuItem* _tmp12_;
	IBusEngineDesc** _tmp13_;
	gint _tmp13__length1;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GdkDisplay* _tmp47_;
	GtkMenu* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenu* result;
#line 1617 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1618 "panel.vala"
	display_backup = NULL;
#line 1619 "panel.vala"
	if (use_x11) {
#line 1619 "panel.vala"
		_tmp0_ = !binding_common_default_is_xdisplay ();
#line 8757 "panel.c"
	} else {
#line 1619 "panel.vala"
		_tmp0_ = FALSE;
#line 8761 "panel.c"
	}
#line 1619 "panel.vala"
	if (_tmp0_) {
#line 8765 "panel.c"
		GdkX11Display* display = NULL;
		GdkX11Display* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkDisplay* _tmp3_;
		GdkX11Display* _tmp4_;
#line 1620 "panel.vala"
		_tmp1_ = binding_common_get_xdisplay (FALSE);
#line 1620 "panel.vala"
		display = _tmp1_;
#line 1621 "panel.vala"
		_tmp2_ = gdk_display_get_default ();
#line 1621 "panel.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1621 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1621 "panel.vala"
		display_backup = _tmp3_;
#line 1622 "panel.vala"
		_tmp4_ = display;
#line 1622 "panel.vala"
		if (_tmp4_ != NULL) {
#line 8787 "panel.c"
			GdkDisplayManager* _tmp5_;
			GdkX11Display* _tmp6_;
#line 1623 "panel.vala"
			_tmp5_ = gdk_display_manager_get ();
#line 1623 "panel.vala"
			_tmp6_ = display;
#line 1623 "panel.vala"
			gdk_display_manager_set_default_display (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gdk_display_get_type (), GdkDisplay));
#line 8796 "panel.c"
		}
#line 1619 "panel.vala"
		_g_object_unref0 (display);
#line 8800 "panel.c"
	}
#line 1627 "panel.vala"
	_tmp7_ = (GtkMenu*) gtk_menu_new ();
#line 1627 "panel.vala"
	g_object_ref_sink (_tmp7_);
#line 1627 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 1627 "panel.vala"
	self->priv->m_ime_menu = _tmp7_;
#line 1630 "panel.vala"
	_tmp8_ = self->priv->m_property_manager;
#line 1630 "panel.vala"
	_tmp9_ = self->priv->m_ime_menu;
#line 1630 "panel.vala"
	property_manager_create_menu_items (_tmp8_, _tmp9_);
#line 1633 "panel.vala"
	_tmp10_ = self->priv->m_ime_menu;
#line 1633 "panel.vala"
	_tmp11_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1633 "panel.vala"
	g_object_ref_sink (_tmp11_);
#line 1633 "panel.vala"
	_tmp12_ = _tmp11_;
#line 1633 "panel.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _tmp10_, (GtkWidget*) _tmp12_, -1);
#line 1633 "panel.vala"
	_g_object_unref0 (_tmp12_);
#line 1636 "panel.vala"
	_tmp13_ = self->priv->m_engines;
#line 1636 "panel.vala"
	_tmp13__length1 = self->priv->m_engines_length1;
#line 8832 "panel.c"
	{
		IBusEngineDesc** engine_collection = NULL;
		gint engine_collection_length1 = 0;
		gint _engine_collection_size_ = 0;
		gint engine_it = 0;
#line 1636 "panel.vala"
		engine_collection = _tmp13_;
#line 1636 "panel.vala"
		engine_collection_length1 = _tmp13__length1;
#line 1636 "panel.vala"
		for (engine_it = 0; engine_it < engine_collection_length1; engine_it = engine_it + 1) {
#line 8844 "panel.c"
			IBusEngineDesc* _tmp14_;
			IBusEngineDesc* engine = NULL;
#line 1636 "panel.vala"
			_tmp14_ = _g_object_ref0 (engine_collection[engine_it]);
#line 1636 "panel.vala"
			engine = _tmp14_;
#line 8851 "panel.c"
			{
				Block14Data* _data14_;
				gchar* language = NULL;
				IBusEngineDesc* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* longname = NULL;
				IBusEngineDesc* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* textdomain = NULL;
				IBusEngineDesc* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* transname = NULL;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				GtkMenuItem* item = NULL;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				GtkMenuItem* _tmp33_;
				GtkMenuItem* _tmp34_;
				IBusEngineDesc* _tmp35_;
				IBusEngineDesc* _tmp36_;
				GtkMenuItem* _tmp37_;
				GtkMenu* _tmp38_;
				GtkMenuItem* _tmp39_;
#line 1636 "panel.vala"
				_data14_ = g_slice_new0 (Block14Data);
#line 1636 "panel.vala"
				_data14_->_ref_count_ = 1;
#line 1636 "panel.vala"
				_data14_->self = g_object_ref (self);
#line 1637 "panel.vala"
				_tmp15_ = engine;
#line 1637 "panel.vala"
				_tmp16_ = ibus_engine_desc_get_language (_tmp15_);
#line 1637 "panel.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 1637 "panel.vala"
				language = _tmp17_;
#line 1638 "panel.vala"
				_tmp18_ = engine;
#line 1638 "panel.vala"
				_tmp19_ = ibus_engine_desc_get_longname (_tmp18_);
#line 1638 "panel.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 1638 "panel.vala"
				longname = _tmp20_;
#line 1639 "panel.vala"
				_tmp21_ = engine;
#line 1639 "panel.vala"
				_tmp22_ = ibus_engine_desc_get_textdomain (_tmp21_);
#line 1639 "panel.vala"
				_tmp23_ = g_strdup (_tmp22_);
#line 1639 "panel.vala"
				textdomain = _tmp23_;
#line 1640 "panel.vala"
				_tmp24_ = textdomain;
#line 1640 "panel.vala"
				_tmp25_ = longname;
#line 1640 "panel.vala"
				_tmp26_ = g_strdup (g_dgettext (_tmp24_, _tmp25_));
#line 1640 "panel.vala"
				transname = _tmp26_;
#line 1641 "panel.vala"
				_tmp27_ = language;
#line 1641 "panel.vala"
				_tmp28_ = ibus_get_language_name (_tmp27_);
#line 1641 "panel.vala"
				_tmp29_ = _tmp28_;
#line 1641 "panel.vala"
				_tmp30_ = transname;
#line 1641 "panel.vala"
				_tmp31_ = g_strdup_printf ("%s - %s", _tmp29_, _tmp30_);
#line 1641 "panel.vala"
				_tmp32_ = _tmp31_;
#line 1641 "panel.vala"
				_tmp33_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp32_);
#line 1641 "panel.vala"
				g_object_ref_sink (_tmp33_);
#line 1641 "panel.vala"
				_tmp34_ = _tmp33_;
#line 1641 "panel.vala"
				_g_free0 (_tmp32_);
#line 1641 "panel.vala"
				_g_free0 (_tmp29_);
#line 1641 "panel.vala"
				item = _tmp34_;
#line 1645 "panel.vala"
				_tmp35_ = engine;
#line 1645 "panel.vala"
				_tmp36_ = _g_object_ref0 (_tmp35_);
#line 1645 "panel.vala"
				_data14_->e = _tmp36_;
#line 1646 "panel.vala"
				_tmp37_ = item;
#line 1646 "panel.vala"
				g_signal_connect_data (_tmp37_, "activate", (GCallback) _____lambda99__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 1654 "panel.vala"
				_tmp38_ = self->priv->m_ime_menu;
#line 1654 "panel.vala"
				_tmp39_ = item;
#line 1654 "panel.vala"
				gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 1636 "panel.vala"
				_g_object_unref0 (item);
#line 1636 "panel.vala"
				_g_free0 (transname);
#line 1636 "panel.vala"
				_g_free0 (textdomain);
#line 1636 "panel.vala"
				_g_free0 (longname);
#line 1636 "panel.vala"
				_g_free0 (language);
#line 1636 "panel.vala"
				_g_object_unref0 (engine);
#line 1636 "panel.vala"
				block14_data_unref (_data14_);
#line 1636 "panel.vala"
				_data14_ = NULL;
#line 8978 "panel.c"
			}
		}
	}
#line 1658 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8984 "panel.c"
		GtkMenu* _tmp40_;
		GtkSeparatorMenuItem* _tmp41_;
		GtkSeparatorMenuItem* _tmp42_;
		GtkMenu* _tmp43_;
		GtkMenu* _tmp44_;
#line 1659 "panel.vala"
		_tmp40_ = self->priv->m_ime_menu;
#line 1659 "panel.vala"
		_tmp41_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1659 "panel.vala"
		g_object_ref_sink (_tmp41_);
#line 1659 "panel.vala"
		_tmp42_ = _tmp41_;
#line 1659 "panel.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp40_, (GtkWidget*) _tmp42_, -1);
#line 1659 "panel.vala"
		_g_object_unref0 (_tmp42_);
#line 1660 "panel.vala"
		_tmp43_ = self->priv->m_ime_menu;
#line 1660 "panel.vala"
		panel_append_preferences_menu (self, _tmp43_);
#line 1661 "panel.vala"
		_tmp44_ = self->priv->m_ime_menu;
#line 1661 "panel.vala"
		panel_append_emoji_menu (self, _tmp44_);
#line 9010 "panel.c"
	}
#line 1665 "panel.vala"
	_tmp45_ = self->priv->m_ime_menu;
#line 1665 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp45_);
#line 1668 "panel.vala"
	_tmp46_ = self->priv->m_ime_menu;
#line 1668 "panel.vala"
	gtk_menu_shell_set_take_focus ((GtkMenuShell*) _tmp46_, FALSE);
#line 1670 "panel.vala"
	_tmp47_ = display_backup;
#line 1670 "panel.vala"
	if (_tmp47_ != NULL) {
#line 9024 "panel.c"
		GdkDisplayManager* _tmp48_;
		GdkDisplay* _tmp49_;
#line 1671 "panel.vala"
		_tmp48_ = gdk_display_manager_get ();
#line 1671 "panel.vala"
		_tmp49_ = display_backup;
#line 1671 "panel.vala"
		gdk_display_manager_set_default_display (_tmp48_, _tmp49_);
#line 9033 "panel.c"
	}
#line 1672 "panel.vala"
	_tmp50_ = self->priv->m_ime_menu;
#line 1672 "panel.vala"
	_tmp51_ = _g_object_ref0 (_tmp50_);
#line 1672 "panel.vala"
	result = _tmp51_;
#line 1672 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1672 "panel.vala"
	return result;
#line 9045 "panel.c"
}

static void
panel_set_properties (Panel* self,
                      IBusPropList* props)
{
	gint i = 0;
#line 1675 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1675 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1676 "panel.vala"
	i = 0;
#line 1677 "panel.vala"
	while (TRUE) {
#line 9061 "panel.c"
		IBusProperty* prop = NULL;
		IBusProperty* _tmp0_;
		IBusProperty* _tmp1_;
		IBusProperty* _tmp2_;
		IBusProperty* _tmp3_;
		gint _tmp4_;
#line 1678 "panel.vala"
		_tmp0_ = ibus_prop_list_get (props, (guint) i);
#line 1678 "panel.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1678 "panel.vala"
		prop = _tmp1_;
#line 1679 "panel.vala"
		_tmp2_ = prop;
#line 1679 "panel.vala"
		if (_tmp2_ == NULL) {
#line 1680 "panel.vala"
			_g_object_unref0 (prop);
#line 1680 "panel.vala"
			break;
#line 9082 "panel.c"
		}
#line 1681 "panel.vala"
		_tmp3_ = ibus_prop_list_get (props, (guint) i);
#line 1681 "panel.vala"
		panel_set_property (self, _tmp3_, TRUE);
#line 1682 "panel.vala"
		_tmp4_ = i;
#line 1682 "panel.vala"
		i = _tmp4_ + 1;
#line 1677 "panel.vala"
		_g_object_unref0 (prop);
#line 9094 "panel.c"
	}
}

static void
panel_set_property (Panel* self,
                    IBusProperty* prop,
                    gboolean all_update)
{
	gchar* symbol = NULL;
	IBusText* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 1686 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1686 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1687 "panel.vala"
	_tmp0_ = ibus_property_get_symbol (prop);
#line 1687 "panel.vala"
	_tmp1_ = ibus_text_get_text (_tmp0_);
#line 1687 "panel.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1687 "panel.vala"
	symbol = _tmp2_;
#line 1689 "panel.vala"
	_tmp5_ = self->priv->m_icon_prop_key;
#line 1689 "panel.vala"
	if (g_strcmp0 (_tmp5_, "") != 0) {
#line 9126 "panel.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1689 "panel.vala"
		_tmp6_ = ibus_property_get_key (prop);
#line 1689 "panel.vala"
		_tmp7_ = self->priv->m_icon_prop_key;
#line 1689 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 9135 "panel.c"
	} else {
#line 1689 "panel.vala"
		_tmp4_ = FALSE;
#line 9139 "panel.c"
	}
#line 1689 "panel.vala"
	if (_tmp4_) {
#line 9143 "panel.c"
		const gchar* _tmp8_;
#line 1690 "panel.vala"
		_tmp8_ = symbol;
#line 1690 "panel.vala"
		_tmp3_ = g_strcmp0 (_tmp8_, "") != 0;
#line 9149 "panel.c"
	} else {
#line 1689 "panel.vala"
		_tmp3_ = FALSE;
#line 9153 "panel.c"
	}
#line 1689 "panel.vala"
	if (_tmp3_) {
#line 9157 "panel.c"
		const gchar* _tmp9_;
#line 1691 "panel.vala"
		_tmp9_ = symbol;
#line 1691 "panel.vala"
		panel_animate_icon (self, _tmp9_, all_update);
#line 9163 "panel.c"
	}
#line 1686 "panel.vala"
	_g_free0 (symbol);
#line 9167 "panel.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 1694 "panel.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 1694 "panel.vala"
	return _data15_;
#line 9177 "panel.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 1694 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 9187 "panel.c"
		Panel* self;
#line 1694 "panel.vala"
		self = _data15_->self;
#line 1694 "panel.vala"
		_g_free0 (_data15_->symbol);
#line 1694 "panel.vala"
		_g_object_unref0 (self);
#line 1694 "panel.vala"
		g_slice_free (Block15Data, _data15_);
#line 9197 "panel.c"
	}
}

static gboolean
__lambda113_ (Block15Data* _data15_)
{
	Panel* self;
	gboolean result;
#line 1707 "panel.vala"
	self = _data15_->self;
#line 1708 "panel.vala"
	self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 1710 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9212 "panel.c"
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 1711 "panel.vala"
		_tmp0_ = panel_create_icon_pixbuf_with_string (self, _data15_->symbol);
#line 1711 "panel.vala"
		pixbuf = _tmp0_;
#line 1712 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 1712 "panel.vala"
		_tmp2_ = pixbuf;
#line 1712 "panel.vala"
		gtk_status_icon_set_from_pixbuf (_tmp1_, _tmp2_);
#line 1710 "panel.vala"
		_g_object_unref0 (pixbuf);
#line 9229 "panel.c"
	} else {
#line 1715 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9233 "panel.c"
			cairo_surface_t* image = NULL;
			cairo_surface_t* _tmp3_;
			Indicator* _tmp4_;
			cairo_surface_t* _tmp5_;
#line 1716 "panel.vala"
			_tmp3_ = panel_create_cairo_image_surface_with_string (self, _data15_->symbol, TRUE);
#line 1716 "panel.vala"
			image = _tmp3_;
#line 1718 "panel.vala"
			_tmp4_ = self->priv->m_indicator;
#line 1718 "panel.vala"
			_tmp5_ = image;
#line 1718 "panel.vala"
			indicator_set_cairo_image_surface_full (_tmp4_, _tmp5_, "");
#line 1715 "panel.vala"
			_cairo_surface_destroy0 (image);
#line 9250 "panel.c"
		}
	}
#line 1722 "panel.vala"
	result = FALSE;
#line 1722 "panel.vala"
	return result;
#line 9257 "panel.c"
}

static gboolean
___lambda113__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda113_ (self);
#line 1707 "panel.vala"
	return result;
#line 9267 "panel.c"
}

static void
panel_animate_icon (Panel* self,
                    const gchar* symbol,
                    gboolean all_update)
{
	Block15Data* _data15_;
	gchar* _tmp0_;
	guint timeout = 0U;
#line 1694 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1694 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1694 "panel.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 1694 "panel.vala"
	_data15_->_ref_count_ = 1;
#line 1694 "panel.vala"
	_data15_->self = g_object_ref (self);
#line 1694 "panel.vala"
	_tmp0_ = g_strdup (symbol);
#line 1694 "panel.vala"
	_g_free0 (_data15_->symbol);
#line 1694 "panel.vala"
	_data15_->symbol = _tmp0_;
#line 1695 "panel.vala"
	if (self->priv->m_property_icon_delay_time < 0) {
#line 1696 "panel.vala"
		block15_data_unref (_data15_);
#line 1696 "panel.vala"
		_data15_ = NULL;
#line 1696 "panel.vala"
		return;
#line 9302 "panel.c"
	}
#line 1698 "panel.vala"
	timeout = (guint) 0;
#line 1699 "panel.vala"
	if (all_update) {
#line 1700 "panel.vala"
		timeout = (guint) self->priv->m_property_icon_delay_time;
#line 9310 "panel.c"
	}
#line 1702 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1703 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1704 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 9318 "panel.c"
	}
#line 1707 "panel.vala"
	self->priv->m_property_icon_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, timeout, ___lambda113__gsource_func, block15_data_ref (_data15_), block15_data_unref);
#line 1694 "panel.vala"
	block15_data_unref (_data15_);
#line 1694 "panel.vala"
	_data15_ = NULL;
#line 9326 "panel.c"
}

static void
panel_real_set_cursor_location (IBusPanelService* base,
                                gint x,
                                gint y,
                                gint width,
                                gint height)
{
	Panel * self;
	CandidatePanel* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1727 "panel.vala"
	self = (Panel*) base;
#line 1729 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 1729 "panel.vala"
	candidate_panel_set_cursor_location (_tmp0_, x, y, width, height);
#line 1730 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1730 "panel.vala"
	property_panel_set_cursor_location (_tmp1_, x, y, width, height);
#line 9349 "panel.c"
}

static gboolean
panel_switcher_focus_set_engine_real (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
	gboolean result;
#line 1733 "panel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1734 "panel.vala"
	_tmp0_ = self->priv->m_switcher_active;
#line 1734 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1734 "panel.vala"
	selected_engine = _tmp1_;
#line 1736 "panel.vala"
	_tmp2_ = self->priv->m_switcher_active;
#line 1736 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1736 "panel.vala"
	prev_context_path = _tmp3_;
#line 1737 "panel.vala"
	_tmp6_ = selected_engine;
#line 1737 "panel.vala"
	if (_tmp6_ != NULL) {
#line 9383 "panel.c"
		const gchar* _tmp7_;
#line 1738 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1738 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 9389 "panel.c"
	} else {
#line 1737 "panel.vala"
		_tmp5_ = FALSE;
#line 9393 "panel.c"
	}
#line 1737 "panel.vala"
	if (_tmp5_) {
#line 9397 "panel.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 1739 "panel.vala"
		_tmp8_ = prev_context_path;
#line 1739 "panel.vala"
		_tmp9_ = self->priv->m_current_context_path;
#line 1739 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
#line 9406 "panel.c"
	} else {
#line 1737 "panel.vala"
		_tmp4_ = FALSE;
#line 9410 "panel.c"
	}
#line 1737 "panel.vala"
	if (_tmp4_) {
#line 9414 "panel.c"
		IBusEngineDesc* _tmp10_;
		Switcher* _tmp11_;
#line 1740 "panel.vala"
		_tmp10_ = selected_engine;
#line 1740 "panel.vala"
		panel_set_engine (self, _tmp10_);
#line 1741 "panel.vala"
		_tmp11_ = self->priv->m_switcher_active;
#line 1741 "panel.vala"
		switcher_reset (_tmp11_);
#line 1742 "panel.vala"
		result = TRUE;
#line 1742 "panel.vala"
		_g_free0 (prev_context_path);
#line 1742 "panel.vala"
		_g_object_unref0 (selected_engine);
#line 1742 "panel.vala"
		return result;
#line 9433 "panel.c"
	}
#line 1745 "panel.vala"
	result = FALSE;
#line 1745 "panel.vala"
	_g_free0 (prev_context_path);
#line 1745 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 1745 "panel.vala"
	return result;
#line 9443 "panel.c"
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 1755 "panel.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 9451 "panel.c"
}

static gboolean
___lambda75_ (Panel* self)
{
	gboolean result;
#line 1763 "panel.vala"
	panel_switcher_focus_set_engine_real (self);
#line 1764 "panel.vala"
	self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1765 "panel.vala"
	result = FALSE;
#line 1765 "panel.vala"
	return result;
#line 9466 "panel.c"
}

static gboolean
____lambda75__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda75_ ((Panel*) self);
#line 1761 "panel.vala"
	return result;
#line 9476 "panel.c"
}

static void
panel_switcher_focus_set_engine (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
#line 1748 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1749 "panel.vala"
	_tmp0_ = self->priv->m_switcher_active;
#line 1749 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1749 "panel.vala"
	selected_engine = _tmp1_;
#line 1751 "panel.vala"
	_tmp2_ = self->priv->m_switcher_active;
#line 1751 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1751 "panel.vala"
	prev_context_path = _tmp3_;
#line 1752 "panel.vala"
	_tmp6_ = selected_engine;
#line 1752 "panel.vala"
	if (_tmp6_ == NULL) {
#line 9509 "panel.c"
		const gchar* _tmp7_;
#line 1753 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1753 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 9515 "panel.c"
	} else {
#line 1752 "panel.vala"
		_tmp5_ = FALSE;
#line 9519 "panel.c"
	}
#line 1752 "panel.vala"
	if (_tmp5_) {
#line 9523 "panel.c"
		Switcher* _tmp8_;
#line 1754 "panel.vala"
		_tmp8_ = self->priv->m_switcher_active;
#line 1754 "panel.vala"
		_tmp4_ = switcher_is_running (_tmp8_);
#line 9529 "panel.c"
	} else {
#line 1752 "panel.vala"
		_tmp4_ = FALSE;
#line 9533 "panel.c"
	}
#line 1752 "panel.vala"
	if (_tmp4_) {
#line 9537 "panel.c"
		GMainContext* context = NULL;
		GMainContext* _tmp9_;
		GMainContext* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 1755 "panel.vala"
		_tmp9_ = g_main_context_default ();
#line 1755 "panel.vala"
		_tmp10_ = _g_main_context_ref0 (_tmp9_);
#line 1755 "panel.vala"
		context = _tmp10_;
#line 1756 "panel.vala"
		if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 9550 "panel.c"
			GMainContext* _tmp12_;
			GSource* _tmp13_;
#line 1757 "panel.vala"
			_tmp12_ = context;
#line 1757 "panel.vala"
			_tmp13_ = g_main_context_find_source_by_id (_tmp12_, self->priv->m_switcher_focus_set_engine_id);
#line 1757 "panel.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 9559 "panel.c"
		} else {
#line 1756 "panel.vala"
			_tmp11_ = FALSE;
#line 9563 "panel.c"
		}
#line 1756 "panel.vala"
		if (_tmp11_) {
#line 1759 "panel.vala"
			g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 9569 "panel.c"
		}
#line 1761 "panel.vala"
		self->priv->m_switcher_focus_set_engine_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda75__gsource_func, g_object_ref (self), g_object_unref);
#line 1752 "panel.vala"
		_g_main_context_unref0 (context);
#line 9575 "panel.c"
	} else {
#line 1768 "panel.vala"
		if (panel_switcher_focus_set_engine_real (self)) {
#line 9579 "panel.c"
			GMainContext* context = NULL;
			GMainContext* _tmp14_;
			GMainContext* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1769 "panel.vala"
			_tmp14_ = g_main_context_default ();
#line 1769 "panel.vala"
			_tmp15_ = _g_main_context_ref0 (_tmp14_);
#line 1769 "panel.vala"
			context = _tmp15_;
#line 1770 "panel.vala"
			if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 9592 "panel.c"
				GMainContext* _tmp17_;
				GSource* _tmp18_;
#line 1771 "panel.vala"
				_tmp17_ = context;
#line 1771 "panel.vala"
				_tmp18_ = g_main_context_find_source_by_id (_tmp17_, self->priv->m_switcher_focus_set_engine_id);
#line 1771 "panel.vala"
				_tmp16_ = _tmp18_ != NULL;
#line 9601 "panel.c"
			} else {
#line 1770 "panel.vala"
				_tmp16_ = FALSE;
#line 9605 "panel.c"
			}
#line 1770 "panel.vala"
			if (_tmp16_) {
#line 1773 "panel.vala"
				g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 9611 "panel.c"
			}
#line 1775 "panel.vala"
			self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1768 "panel.vala"
			_g_main_context_unref0 (context);
#line 9617 "panel.c"
		}
	}
#line 1748 "panel.vala"
	_g_free0 (prev_context_path);
#line 1748 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 9624 "panel.c"
}

static void
panel_real_focus_in (IBusPanelService* base,
                     const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
	IBusEngineDesc* engine = NULL;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	IBusEngineDesc* _tmp6_;
	IBusEngineDesc* _tmp7_;
	IBusEngineDesc* _tmp20_;
#line 1780 "panel.vala"
	self = (Panel*) base;
#line 1780 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1781 "panel.vala"
	_tmp0_ = g_strdup (input_context_path);
#line 1781 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1781 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 1790 "panel.vala"
	if (!g_str_has_suffix (input_context_path, "InputContext_1")) {
#line 9651 "panel.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1791 "panel.vala"
		_tmp1_ = self->priv->m_current_context_path;
#line 1791 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1791 "panel.vala"
		_g_free0 (self->priv->m_real_current_context_path);
#line 1791 "panel.vala"
		self->priv->m_real_current_context_path = _tmp2_;
#line 1792 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1792 "panel.vala"
		property_panel_focus_in (_tmp3_);
#line 1793 "panel.vala"
		panel_switcher_focus_set_engine (self);
#line 9669 "panel.c"
	}
#line 1796 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1797 "panel.vala"
		return;
#line 9675 "panel.c"
	}
#line 1799 "panel.vala"
	_tmp4_ = self->priv->m_engine_contexts;
#line 1799 "panel.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, input_context_path);
#line 1799 "panel.vala"
	_tmp6_ = _g_object_ref0 ((IBusEngineDesc*) _tmp5_);
#line 1799 "panel.vala"
	engine = _tmp6_;
#line 1801 "panel.vala"
	_tmp7_ = engine;
#line 1801 "panel.vala"
	if (_tmp7_ == NULL) {
#line 9689 "panel.c"
		IBusEngineDesc* _tmp8_ = NULL;
		IBusEngineDesc** _tmp9_;
		gint _tmp9__length1;
		IBusEngineDesc* _tmp12_;
		IBusEngineDesc* _tmp13_;
#line 1813 "panel.vala"
		_tmp9_ = self->priv->m_engines;
#line 1813 "panel.vala"
		_tmp9__length1 = self->priv->m_engines_length1;
#line 1813 "panel.vala"
		if (_tmp9__length1 > 0) {
#line 9701 "panel.c"
			IBusEngineDesc** _tmp10_;
			gint _tmp10__length1;
			IBusEngineDesc* _tmp11_;
#line 1813 "panel.vala"
			_tmp10_ = self->priv->m_engines;
#line 1813 "panel.vala"
			_tmp10__length1 = self->priv->m_engines_length1;
#line 1813 "panel.vala"
			_tmp11_ = _tmp10_[0];
#line 1813 "panel.vala"
			_tmp8_ = _tmp11_;
#line 9713 "panel.c"
		} else {
#line 1813 "panel.vala"
			_tmp8_ = NULL;
#line 9717 "panel.c"
		}
#line 1813 "panel.vala"
		_tmp12_ = _g_object_ref0 (_tmp8_);
#line 1813 "panel.vala"
		_g_object_unref0 (engine);
#line 1813 "panel.vala"
		engine = _tmp12_;
#line 1815 "panel.vala"
		_tmp13_ = engine;
#line 1815 "panel.vala"
		if (_tmp13_ == NULL) {
#line 1816 "panel.vala"
			_g_object_unref0 (engine);
#line 1816 "panel.vala"
			return;
#line 9733 "panel.c"
		}
	} else {
		gboolean in_engines = FALSE;
		IBusEngineDesc** _tmp14_;
		gint _tmp14__length1;
#line 1818 "panel.vala"
		in_engines = FALSE;
#line 1820 "panel.vala"
		_tmp14_ = self->priv->m_engines;
#line 1820 "panel.vala"
		_tmp14__length1 = self->priv->m_engines_length1;
#line 9745 "panel.c"
		{
			IBusEngineDesc** e_collection = NULL;
			gint e_collection_length1 = 0;
			gint _e_collection_size_ = 0;
			gint e_it = 0;
#line 1820 "panel.vala"
			e_collection = _tmp14_;
#line 1820 "panel.vala"
			e_collection_length1 = _tmp14__length1;
#line 1820 "panel.vala"
			for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 9757 "panel.c"
				IBusEngineDesc* _tmp15_;
				IBusEngineDesc* e = NULL;
#line 1820 "panel.vala"
				_tmp15_ = _g_object_ref0 (e_collection[e_it]);
#line 1820 "panel.vala"
				e = _tmp15_;
#line 9764 "panel.c"
				{
					IBusEngineDesc* _tmp16_;
					const gchar* _tmp17_;
					IBusEngineDesc* _tmp18_;
					const gchar* _tmp19_;
#line 1821 "panel.vala"
					_tmp16_ = engine;
#line 1821 "panel.vala"
					_tmp17_ = ibus_engine_desc_get_name (_tmp16_);
#line 1821 "panel.vala"
					_tmp18_ = e;
#line 1821 "panel.vala"
					_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 1821 "panel.vala"
					if (g_strcmp0 (_tmp17_, _tmp19_) == 0) {
#line 1822 "panel.vala"
						in_engines = TRUE;
#line 1823 "panel.vala"
						_g_object_unref0 (e);
#line 1823 "panel.vala"
						break;
#line 9786 "panel.c"
					}
#line 1820 "panel.vala"
					_g_object_unref0 (e);
#line 9790 "panel.c"
				}
			}
		}
#line 1829 "panel.vala"
		if (!in_engines) {
#line 1830 "panel.vala"
			_g_object_unref0 (engine);
#line 1830 "panel.vala"
			return;
#line 9800 "panel.c"
		}
	}
#line 1833 "panel.vala"
	_tmp20_ = engine;
#line 1833 "panel.vala"
	panel_set_engine (self, _tmp20_);
#line 1780 "panel.vala"
	_g_object_unref0 (engine);
#line 9809 "panel.c"
}

static void
panel_real_focus_out (IBusPanelService* base,
                      const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
#line 1836 "panel.vala"
	self = (Panel*) base;
#line 1836 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1837 "panel.vala"
	_tmp0_ = g_strdup ("");
#line 1837 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1837 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 9828 "panel.c"
}

static void
panel_real_destroy_context (IBusPanelService* base,
                            const gchar* input_context_path)
{
	Panel * self;
	GHashTable* _tmp0_;
#line 1840 "panel.vala"
	self = (Panel*) base;
#line 1840 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1841 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1842 "panel.vala"
		return;
#line 9845 "panel.c"
	}
#line 1844 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1844 "panel.vala"
	g_hash_table_remove (_tmp0_, input_context_path);
#line 9851 "panel.c"
}

static gboolean
__lambda114_ (Panel* self)
{
	Indicator* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	gboolean result;
#line 1865 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 1865 "panel.vala"
	_tmp1_ = panel_create_activate_menu (self, FALSE);
#line 1865 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1865 "panel.vala"
	indicator_set_menu (_tmp0_, _tmp2_);
#line 1865 "panel.vala"
	_g_object_unref0 (_tmp2_);
#line 1866 "panel.vala"
	self->priv->m_menu_update_delay_time_id = (guint) 0;
#line 1867 "panel.vala"
	result = G_SOURCE_REMOVE;
#line 1867 "panel.vala"
	return result;
#line 9877 "panel.c"
}

static gboolean
___lambda114__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda114_ ((Panel*) self);
#line 1861 "panel.vala"
	return result;
#line 9887 "panel.c"
}

static void
panel_real_register_properties (IBusPanelService* base,
                                IBusPropList* props)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1847 "panel.vala"
	self = (Panel*) base;
#line 1847 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1848 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1848 "panel.vala"
	property_manager_set_properties (_tmp0_, props);
#line 1849 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1849 "panel.vala"
	property_panel_set_properties (_tmp1_, props);
#line 1850 "panel.vala"
	panel_set_properties (self, props);
#line 1853 "panel.vala"
	if (self->priv->m_icon_type != PANEL_ICON_TYPE_INDICATOR) {
#line 1854 "panel.vala"
		return;
#line 9915 "panel.c"
	}
#line 1855 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 1856 "panel.vala"
		return;
#line 9921 "panel.c"
	}
#line 1857 "panel.vala"
	if (self->priv->m_menu_update_delay_time_id > ((guint) 0)) {
#line 1858 "panel.vala"
		g_source_remove (self->priv->m_menu_update_delay_time_id);
#line 1859 "panel.vala"
		self->priv->m_menu_update_delay_time_id = (guint) 0;
#line 9929 "panel.c"
	}
#line 1861 "panel.vala"
	self->priv->m_menu_update_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, self->priv->m_menu_update_delay_time, ___lambda114__gsource_func, g_object_ref (self), g_object_unref);
#line 9933 "panel.c"
}

static void
panel_real_update_property (IBusPanelService* base,
                            IBusProperty* prop)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1872 "panel.vala"
	self = (Panel*) base;
#line 1872 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1873 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1873 "panel.vala"
	property_manager_update_property (_tmp0_, prop);
#line 1874 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1874 "panel.vala"
	property_panel_update_property (_tmp1_, prop);
#line 1875 "panel.vala"
	panel_set_property (self, prop, FALSE);
#line 9957 "panel.c"
}

static void
panel_real_update_preedit_text (IBusPanelService* base,
                                IBusText* text,
                                guint cursor_pos,
                                gboolean visible)
{
	Panel * self;
#line 1878 "panel.vala"
	self = (Panel*) base;
#line 1878 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1881 "panel.vala"
	if (visible) {
#line 9973 "panel.c"
		CandidatePanel* _tmp0_;
		CandidatePanel* _tmp1_;
		PropertyPanel* _tmp2_;
#line 1883 "panel.vala"
		_tmp0_ = panel_get_active_candidate_panel (self);
#line 1883 "panel.vala"
		_g_object_unref0 (self->priv->m_candidate_panel_active);
#line 1883 "panel.vala"
		self->priv->m_candidate_panel_active = _tmp0_;
#line 1885 "panel.vala"
		_tmp1_ = self->priv->m_candidate_panel_active;
#line 1885 "panel.vala"
		candidate_panel_set_preedit_text (_tmp1_, text, cursor_pos);
#line 1886 "panel.vala"
		_tmp2_ = self->priv->m_property_panel;
#line 1886 "panel.vala"
		property_panel_set_preedit_text (_tmp2_, text, cursor_pos);
#line 9991 "panel.c"
	} else {
		CandidatePanel* _tmp3_;
		PropertyPanel* _tmp4_;
#line 1888 "panel.vala"
		_tmp3_ = self->priv->m_candidate_panel_active;
#line 1888 "panel.vala"
		candidate_panel_set_preedit_text (_tmp3_, NULL, (guint) 0);
#line 1889 "panel.vala"
		_tmp4_ = self->priv->m_property_panel;
#line 1889 "panel.vala"
		property_panel_set_preedit_text (_tmp4_, NULL, (guint) 0);
#line 10003 "panel.c"
	}
}

static void
panel_real_hide_preedit_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1893 "panel.vala"
	self = (Panel*) base;
#line 1894 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 1894 "panel.vala"
	candidate_panel_set_preedit_text (_tmp0_, NULL, (guint) 0);
#line 10018 "panel.c"
}

static void
panel_real_update_auxiliary_text (IBusPanelService* base,
                                  IBusText* text,
                                  gboolean visible)
{
	Panel * self;
	IBusText* _tmp1_ = NULL;
	CandidatePanel* _tmp2_;
	IBusText* _tmp3_ = NULL;
	PropertyPanel* _tmp4_;
#line 1897 "panel.vala"
	self = (Panel*) base;
#line 1897 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1900 "panel.vala"
	if (visible) {
#line 10037 "panel.c"
		CandidatePanel* _tmp0_;
#line 1901 "panel.vala"
		_tmp0_ = panel_get_active_candidate_panel (self);
#line 1901 "panel.vala"
		_g_object_unref0 (self->priv->m_candidate_panel_active);
#line 1901 "panel.vala"
		self->priv->m_candidate_panel_active = _tmp0_;
#line 10045 "panel.c"
	}
#line 1903 "panel.vala"
	if (visible) {
#line 1903 "panel.vala"
		_tmp1_ = text;
#line 10051 "panel.c"
	} else {
#line 1903 "panel.vala"
		_tmp1_ = NULL;
#line 10055 "panel.c"
	}
#line 1903 "panel.vala"
	_tmp2_ = self->priv->m_candidate_panel_active;
#line 1903 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp2_, _tmp1_);
#line 1904 "panel.vala"
	if (visible) {
#line 1904 "panel.vala"
		_tmp3_ = text;
#line 10065 "panel.c"
	} else {
#line 1904 "panel.vala"
		_tmp3_ = NULL;
#line 10069 "panel.c"
	}
#line 1904 "panel.vala"
	_tmp4_ = self->priv->m_property_panel;
#line 1904 "panel.vala"
	property_panel_set_auxiliary_text (_tmp4_, _tmp3_);
#line 10075 "panel.c"
}

static void
panel_real_hide_auxiliary_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1907 "panel.vala"
	self = (Panel*) base;
#line 1908 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 1908 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp0_, NULL);
#line 10089 "panel.c"
}

static void
panel_real_update_lookup_table (IBusPanelService* base,
                                IBusLookupTable* table,
                                gboolean visible)
{
	Panel * self;
	IBusLookupTable* _tmp1_ = NULL;
	CandidatePanel* _tmp2_;
	IBusLookupTable* _tmp3_ = NULL;
	PropertyPanel* _tmp4_;
#line 1911 "panel.vala"
	self = (Panel*) base;
#line 1911 "panel.vala"
	g_return_if_fail (table != NULL);
#line 1914 "panel.vala"
	if (visible) {
#line 10108 "panel.c"
		CandidatePanel* _tmp0_;
#line 1915 "panel.vala"
		_tmp0_ = panel_get_active_candidate_panel (self);
#line 1915 "panel.vala"
		_g_object_unref0 (self->priv->m_candidate_panel_active);
#line 1915 "panel.vala"
		self->priv->m_candidate_panel_active = _tmp0_;
#line 10116 "panel.c"
	}
#line 1917 "panel.vala"
	if (visible) {
#line 1917 "panel.vala"
		_tmp1_ = table;
#line 10122 "panel.c"
	} else {
#line 1917 "panel.vala"
		_tmp1_ = NULL;
#line 10126 "panel.c"
	}
#line 1917 "panel.vala"
	_tmp2_ = self->priv->m_candidate_panel_active;
#line 1917 "panel.vala"
	candidate_panel_set_lookup_table (_tmp2_, _tmp1_);
#line 1918 "panel.vala"
	if (visible) {
#line 1918 "panel.vala"
		_tmp3_ = table;
#line 10136 "panel.c"
	} else {
#line 1918 "panel.vala"
		_tmp3_ = NULL;
#line 10140 "panel.c"
	}
#line 1918 "panel.vala"
	_tmp4_ = self->priv->m_property_panel;
#line 1918 "panel.vala"
	property_panel_set_lookup_table (_tmp4_, _tmp3_);
#line 10146 "panel.c"
}

static void
panel_real_hide_lookup_table (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1921 "panel.vala"
	self = (Panel*) base;
#line 1922 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 1922 "panel.vala"
	candidate_panel_set_lookup_table (_tmp0_, NULL);
#line 10160 "panel.c"
}

static void
panel_real_set_content_type (IBusPanelService* base,
                             guint purpose,
                             guint hints)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1925 "panel.vala"
	self = (Panel*) base;
#line 1926 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel_active;
#line 1926 "panel.vala"
	candidate_panel_set_content_type (_tmp0_, purpose, hints);
#line 10176 "panel.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 10193 "panel.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 10220 "panel.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 10226 "panel.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 10232 "panel.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 10236 "panel.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 10244 "panel.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 10248 "panel.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 10260 "panel.c"
}

static void
_vala_array_add28 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 2034 "panel.vala"
	if ((*length) == (*size)) {
#line 2034 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2034 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10275 "panel.c"
	}
#line 2034 "panel.vala"
	(*array)[(*length)++] = value;
#line 2034 "panel.vala"
	(*array)[*length] = NULL;
#line 10281 "panel.c"
}

static void
panel_real_state_changed (IBusPanelService* base)
{
	Panel * self;
	Switcher* _tmp0_;
	gboolean _tmp2_ = FALSE;
	gchar* icon_name = NULL;
	gchar* _tmp3_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp4_;
	IBusEngineDesc* _tmp5_;
	IBusEngineDesc* _tmp6_;
	const gchar* _tmp14_;
	IBusEngineDesc* _tmp55_;
	gint i = 0;
	IBusEngineDesc** _tmp64_;
	gint _tmp64__length1;
	IBusEngineDesc** _tmp71_;
	gint _tmp71__length1;
	IBusEngineDesc* _tmp72_;
	IBusEngineDesc* _tmp73_;
	gchar** names = NULL;
	gchar** _tmp74_;
	gint names_length1;
	gint _names_size_;
	IBusEngineDesc** _tmp75_;
	gint _tmp75__length1;
	GSettings* _tmp80_;
	gchar** _tmp81_;
	gint _tmp81__length1;
#line 1929 "panel.vala"
	self = (Panel*) base;
#line 1931 "panel.vala"
	_tmp0_ = self->priv->m_switcher_active;
#line 1931 "panel.vala"
	if (switcher_is_running (_tmp0_)) {
#line 1932 "panel.vala"
		return;
#line 10322 "panel.c"
	}
#line 1935 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10326 "panel.c"
		Indicator* _tmp1_;
#line 1937 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 1937 "panel.vala"
		if (_tmp1_ == NULL) {
#line 1938 "panel.vala"
			return;
#line 10334 "panel.c"
		}
	}
#line 1944 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 1945 "panel.vala"
		_tmp2_ = !binding_common_default_is_xdisplay ();
#line 10341 "panel.c"
	} else {
#line 1944 "panel.vala"
		_tmp2_ = FALSE;
#line 10345 "panel.c"
	}
#line 1944 "panel.vala"
	if (_tmp2_) {
#line 1946 "panel.vala"
		return;
#line 10351 "panel.c"
	}
#line 1950 "panel.vala"
	_tmp3_ = g_strdup ("ibus-keyboard");
#line 1950 "panel.vala"
	icon_name = _tmp3_;
#line 1952 "panel.vala"
	_tmp4_ = self->priv->m_bus;
#line 1952 "panel.vala"
	_tmp5_ = ibus_bus_get_global_engine (_tmp4_);
#line 1952 "panel.vala"
	engine = _tmp5_;
#line 1953 "panel.vala"
	_tmp6_ = engine;
#line 1953 "panel.vala"
	if (_tmp6_ != NULL) {
#line 10367 "panel.c"
		IBusEngineDesc* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		IBusEngineDesc* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1954 "panel.vala"
		_tmp7_ = engine;
#line 1954 "panel.vala"
		_tmp8_ = ibus_engine_desc_get_icon (_tmp7_);
#line 1954 "panel.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 1954 "panel.vala"
		_g_free0 (icon_name);
#line 1954 "panel.vala"
		icon_name = _tmp9_;
#line 1955 "panel.vala"
		_tmp10_ = engine;
#line 1955 "panel.vala"
		_tmp11_ = ibus_engine_desc_get_icon_prop_key (_tmp10_);
#line 1955 "panel.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1955 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1955 "panel.vala"
		self->priv->m_icon_prop_key = _tmp12_;
#line 10394 "panel.c"
	} else {
		gchar* _tmp13_;
#line 1957 "panel.vala"
		_tmp13_ = g_strdup ("");
#line 1957 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1957 "panel.vala"
		self->priv->m_icon_prop_key = _tmp13_;
#line 10403 "panel.c"
	}
#line 1960 "panel.vala"
	_tmp14_ = icon_name;
#line 1960 "panel.vala"
	if (string_get (_tmp14_, (glong) 0) == '/') {
#line 1961 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10411 "panel.c"
			GtkStatusIcon* _tmp15_;
			const gchar* _tmp16_;
#line 1962 "panel.vala"
			_tmp15_ = self->priv->m_status_icon;
#line 1962 "panel.vala"
			_tmp16_ = icon_name;
#line 1962 "panel.vala"
			gtk_status_icon_set_from_file (_tmp15_, _tmp16_);
#line 10420 "panel.c"
		} else {
#line 1964 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10424 "panel.c"
				Indicator* _tmp17_;
				const gchar* _tmp18_;
#line 1965 "panel.vala"
				_tmp17_ = self->priv->m_indicator;
#line 1965 "panel.vala"
				_tmp18_ = icon_name;
#line 1965 "panel.vala"
				indicator_set_icon_full (_tmp17_, _tmp18_, "");
#line 10433 "panel.c"
			}
		}
	} else {
		gchar* language = NULL;
		IBusEngineDesc* _tmp19_;
		const gchar* _tmp33_;
#line 1968 "panel.vala"
		language = NULL;
#line 1970 "panel.vala"
		_tmp19_ = engine;
#line 1970 "panel.vala"
		if (_tmp19_ != NULL) {
#line 10446 "panel.c"
			gchar* name = NULL;
			IBusEngineDesc* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gboolean _tmp23_ = FALSE;
			const gchar* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 1971 "panel.vala"
			_tmp20_ = engine;
#line 1971 "panel.vala"
			_tmp21_ = ibus_engine_desc_get_name (_tmp20_);
#line 1971 "panel.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 1971 "panel.vala"
			name = _tmp22_;
#line 1972 "panel.vala"
			_tmp24_ = name;
#line 1972 "panel.vala"
			_tmp25_ = strlen (_tmp24_);
#line 1972 "panel.vala"
			_tmp26_ = _tmp25_;
#line 1972 "panel.vala"
			if (_tmp26_ >= 4) {
#line 10471 "panel.c"
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1972 "panel.vala"
				_tmp27_ = name;
#line 1972 "panel.vala"
				_tmp28_ = string_slice (_tmp27_, (glong) 0, (glong) 4);
#line 1972 "panel.vala"
				_tmp29_ = _tmp28_;
#line 1972 "panel.vala"
				_tmp23_ = g_strcmp0 (_tmp29_, "xkb:") == 0;
#line 1972 "panel.vala"
				_g_free0 (_tmp29_);
#line 10485 "panel.c"
			} else {
#line 1972 "panel.vala"
				_tmp23_ = FALSE;
#line 10489 "panel.c"
			}
#line 1972 "panel.vala"
			if (_tmp23_) {
#line 10493 "panel.c"
				Switcher* _tmp30_;
				IBusEngineDesc* _tmp31_;
				gchar* _tmp32_;
#line 1973 "panel.vala"
				_tmp30_ = self->priv->m_switcher_active;
#line 1973 "panel.vala"
				_tmp31_ = engine;
#line 1973 "panel.vala"
				_tmp32_ = switcher_get_xkb_language (_tmp30_, _tmp31_);
#line 1973 "panel.vala"
				_g_free0 (language);
#line 1973 "panel.vala"
				language = _tmp32_;
#line 10507 "panel.c"
			}
#line 1970 "panel.vala"
			_g_free0 (name);
#line 10511 "panel.c"
		}
#line 1976 "panel.vala"
		_tmp33_ = language;
#line 1976 "panel.vala"
		if (_tmp33_ != NULL) {
#line 1977 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10519 "panel.c"
				GdkPixbuf* pixbuf = NULL;
				const gchar* _tmp34_;
				GdkPixbuf* _tmp35_;
				GtkStatusIcon* _tmp36_;
				GdkPixbuf* _tmp37_;
#line 1978 "panel.vala"
				_tmp34_ = language;
#line 1978 "panel.vala"
				_tmp35_ = panel_create_icon_pixbuf_with_string (self, _tmp34_);
#line 1978 "panel.vala"
				pixbuf = _tmp35_;
#line 1980 "panel.vala"
				_tmp36_ = self->priv->m_status_icon;
#line 1980 "panel.vala"
				_tmp37_ = pixbuf;
#line 1980 "panel.vala"
				gtk_status_icon_set_from_pixbuf (_tmp36_, _tmp37_);
#line 1977 "panel.vala"
				_g_object_unref0 (pixbuf);
#line 10539 "panel.c"
			} else {
#line 1983 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10543 "panel.c"
					cairo_surface_t* image = NULL;
					const gchar* _tmp38_;
					cairo_surface_t* _tmp39_;
					Indicator* _tmp40_;
					cairo_surface_t* _tmp41_;
#line 1984 "panel.vala"
					_tmp38_ = language;
#line 1984 "panel.vala"
					_tmp39_ = panel_create_cairo_image_surface_with_string (self, _tmp38_, TRUE);
#line 1984 "panel.vala"
					image = _tmp39_;
#line 1987 "panel.vala"
					_tmp40_ = self->priv->m_indicator;
#line 1987 "panel.vala"
					_tmp41_ = image;
#line 1987 "panel.vala"
					indicator_set_cairo_image_surface_full (_tmp40_, _tmp41_, "");
#line 1983 "panel.vala"
					_cairo_surface_destroy0 (image);
#line 10563 "panel.c"
				}
			}
		} else {
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp42_;
			GtkIconTheme* _tmp43_;
			GtkIconTheme* _tmp44_;
			const gchar* _tmp45_;
			GtkIconInfo* _tmp46_;
			GtkIconInfo* _tmp47_;
			gboolean _tmp48_;
#line 1991 "panel.vala"
			_tmp42_ = gtk_icon_theme_get_default ();
#line 1991 "panel.vala"
			_tmp43_ = _g_object_ref0 (_tmp42_);
#line 1991 "panel.vala"
			theme = _tmp43_;
#line 1992 "panel.vala"
			_tmp44_ = theme;
#line 1992 "panel.vala"
			_tmp45_ = icon_name;
#line 1992 "panel.vala"
			_tmp46_ = gtk_icon_theme_lookup_icon (_tmp44_, _tmp45_, 48, 0);
#line 1992 "panel.vala"
			_tmp47_ = _tmp46_;
#line 1992 "panel.vala"
			_tmp48_ = _tmp47_ != NULL;
#line 1992 "panel.vala"
			_g_object_unref0 (_tmp47_);
#line 1992 "panel.vala"
			if (_tmp48_) {
#line 1993 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10597 "panel.c"
					GtkStatusIcon* _tmp49_;
					const gchar* _tmp50_;
#line 1994 "panel.vala"
					_tmp49_ = self->priv->m_status_icon;
#line 1994 "panel.vala"
					_tmp50_ = icon_name;
#line 1994 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp49_, _tmp50_);
#line 10606 "panel.c"
				} else {
#line 1996 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10610 "panel.c"
						Indicator* _tmp51_;
						const gchar* _tmp52_;
#line 1997 "panel.vala"
						_tmp51_ = self->priv->m_indicator;
#line 1997 "panel.vala"
						_tmp52_ = icon_name;
#line 1997 "panel.vala"
						indicator_set_icon_full (_tmp51_, _tmp52_, "");
#line 10619 "panel.c"
					}
				}
			} else {
#line 2000 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 10625 "panel.c"
					GtkStatusIcon* _tmp53_;
#line 2001 "panel.vala"
					_tmp53_ = self->priv->m_status_icon;
#line 2001 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp53_, "ibus-engine");
#line 10631 "panel.c"
				} else {
#line 2003 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 10635 "panel.c"
						Indicator* _tmp54_;
#line 2004 "panel.vala"
						_tmp54_ = self->priv->m_indicator;
#line 2004 "panel.vala"
						indicator_set_icon_full (_tmp54_, "ibus-engine", "");
#line 10641 "panel.c"
					}
				}
			}
#line 1976 "panel.vala"
			_g_object_unref0 (theme);
#line 10647 "panel.c"
		}
#line 1960 "panel.vala"
		_g_free0 (language);
#line 10651 "panel.c"
	}
#line 2010 "panel.vala"
	_tmp55_ = engine;
#line 2010 "panel.vala"
	if (_tmp55_ == NULL) {
#line 2011 "panel.vala"
		_g_object_unref0 (engine);
#line 2011 "panel.vala"
		_g_free0 (icon_name);
#line 2011 "panel.vala"
		return;
#line 10663 "panel.c"
	}
	{
		gboolean _tmp56_ = FALSE;
#line 2014 "panel.vala"
		i = 0;
#line 2014 "panel.vala"
		_tmp56_ = TRUE;
#line 2014 "panel.vala"
		while (TRUE) {
#line 10673 "panel.c"
			IBusEngineDesc** _tmp58_;
			gint _tmp58__length1;
			IBusEngineDesc** _tmp59_;
			gint _tmp59__length1;
			IBusEngineDesc* _tmp60_;
			const gchar* _tmp61_;
			IBusEngineDesc* _tmp62_;
			const gchar* _tmp63_;
#line 2014 "panel.vala"
			if (!_tmp56_) {
#line 10684 "panel.c"
				gint _tmp57_;
#line 2014 "panel.vala"
				_tmp57_ = i;
#line 2014 "panel.vala"
				i = _tmp57_ + 1;
#line 10690 "panel.c"
			}
#line 2014 "panel.vala"
			_tmp56_ = FALSE;
#line 2014 "panel.vala"
			_tmp58_ = self->priv->m_engines;
#line 2014 "panel.vala"
			_tmp58__length1 = self->priv->m_engines_length1;
#line 2014 "panel.vala"
			if (!(i < _tmp58__length1)) {
#line 2014 "panel.vala"
				break;
#line 10702 "panel.c"
			}
#line 2015 "panel.vala"
			_tmp59_ = self->priv->m_engines;
#line 2015 "panel.vala"
			_tmp59__length1 = self->priv->m_engines_length1;
#line 2015 "panel.vala"
			_tmp60_ = _tmp59_[i];
#line 2015 "panel.vala"
			_tmp61_ = ibus_engine_desc_get_name (_tmp60_);
#line 2015 "panel.vala"
			_tmp62_ = engine;
#line 2015 "panel.vala"
			_tmp63_ = ibus_engine_desc_get_name (_tmp62_);
#line 2015 "panel.vala"
			if (g_strcmp0 (_tmp61_, _tmp63_) == 0) {
#line 2016 "panel.vala"
				break;
#line 10720 "panel.c"
			}
		}
	}
#line 2020 "panel.vala"
	if (i == 0) {
#line 2021 "panel.vala"
		_g_object_unref0 (engine);
#line 2021 "panel.vala"
		_g_free0 (icon_name);
#line 2021 "panel.vala"
		return;
#line 10732 "panel.c"
	}
#line 2024 "panel.vala"
	_tmp64_ = self->priv->m_engines;
#line 2024 "panel.vala"
	_tmp64__length1 = self->priv->m_engines_length1;
#line 2024 "panel.vala"
	if (i >= _tmp64__length1) {
#line 2025 "panel.vala"
		_g_object_unref0 (engine);
#line 2025 "panel.vala"
		_g_free0 (icon_name);
#line 2025 "panel.vala"
		return;
#line 10746 "panel.c"
	}
	{
		gint j = 0;
#line 2027 "panel.vala"
		j = i;
#line 10752 "panel.c"
		{
			gboolean _tmp65_ = FALSE;
#line 2027 "panel.vala"
			_tmp65_ = TRUE;
#line 2027 "panel.vala"
			while (TRUE) {
#line 10759 "panel.c"
				IBusEngineDesc** _tmp67_;
				gint _tmp67__length1;
				IBusEngineDesc** _tmp68_;
				gint _tmp68__length1;
				IBusEngineDesc* _tmp69_;
				IBusEngineDesc* _tmp70_;
#line 2027 "panel.vala"
				if (!_tmp65_) {
#line 10768 "panel.c"
					gint _tmp66_;
#line 2027 "panel.vala"
					_tmp66_ = j;
#line 2027 "panel.vala"
					j = _tmp66_ - 1;
#line 10774 "panel.c"
				}
#line 2027 "panel.vala"
				_tmp65_ = FALSE;
#line 2027 "panel.vala"
				if (!(j > 0)) {
#line 2027 "panel.vala"
					break;
#line 10782 "panel.c"
				}
#line 2028 "panel.vala"
				_tmp67_ = self->priv->m_engines;
#line 2028 "panel.vala"
				_tmp67__length1 = self->priv->m_engines_length1;
#line 2028 "panel.vala"
				_tmp68_ = self->priv->m_engines;
#line 2028 "panel.vala"
				_tmp68__length1 = self->priv->m_engines_length1;
#line 2028 "panel.vala"
				_tmp69_ = _tmp68_[j - 1];
#line 2028 "panel.vala"
				_tmp70_ = _g_object_ref0 (_tmp69_);
#line 2028 "panel.vala"
				_g_object_unref0 (_tmp67_[j]);
#line 2028 "panel.vala"
				_tmp67_[j] = _tmp70_;
#line 10800 "panel.c"
			}
		}
	}
#line 2030 "panel.vala"
	_tmp71_ = self->priv->m_engines;
#line 2030 "panel.vala"
	_tmp71__length1 = self->priv->m_engines_length1;
#line 2030 "panel.vala"
	_tmp72_ = engine;
#line 2030 "panel.vala"
	_tmp73_ = _g_object_ref0 (_tmp72_);
#line 2030 "panel.vala"
	_g_object_unref0 (_tmp71_[0]);
#line 2030 "panel.vala"
	_tmp71_[0] = _tmp73_;
#line 2032 "panel.vala"
	_tmp74_ = g_new0 (gchar*, 0 + 1);
#line 2032 "panel.vala"
	names = _tmp74_;
#line 2032 "panel.vala"
	names_length1 = 0;
#line 2032 "panel.vala"
	_names_size_ = names_length1;
#line 2033 "panel.vala"
	_tmp75_ = self->priv->m_engines;
#line 2033 "panel.vala"
	_tmp75__length1 = self->priv->m_engines_length1;
#line 10828 "panel.c"
	{
		IBusEngineDesc** desc_collection = NULL;
		gint desc_collection_length1 = 0;
		gint _desc_collection_size_ = 0;
		gint desc_it = 0;
#line 2033 "panel.vala"
		desc_collection = _tmp75_;
#line 2033 "panel.vala"
		desc_collection_length1 = _tmp75__length1;
#line 2033 "panel.vala"
		for (desc_it = 0; desc_it < desc_collection_length1; desc_it = desc_it + 1) {
#line 10840 "panel.c"
			IBusEngineDesc* _tmp76_;
			IBusEngineDesc* desc = NULL;
#line 2033 "panel.vala"
			_tmp76_ = _g_object_ref0 (desc_collection[desc_it]);
#line 2033 "panel.vala"
			desc = _tmp76_;
#line 10847 "panel.c"
			{
				IBusEngineDesc* _tmp77_;
				const gchar* _tmp78_;
				gchar* _tmp79_;
#line 2034 "panel.vala"
				_tmp77_ = desc;
#line 2034 "panel.vala"
				_tmp78_ = ibus_engine_desc_get_name (_tmp77_);
#line 2034 "panel.vala"
				_tmp79_ = g_strdup (_tmp78_);
#line 2034 "panel.vala"
				_vala_array_add28 (&names, &names_length1, &_names_size_, _tmp79_);
#line 2033 "panel.vala"
				_g_object_unref0 (desc);
#line 10862 "panel.c"
			}
		}
	}
#line 2036 "panel.vala"
	_tmp80_ = self->priv->m_settings_general;
#line 2036 "panel.vala"
	_tmp81_ = names;
#line 2036 "panel.vala"
	_tmp81__length1 = names_length1;
#line 2036 "panel.vala"
	g_settings_set_strv (_tmp80_, "engines-order", _tmp81_);
#line 1929 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1929 "panel.vala"
	_g_object_unref0 (engine);
#line 1929 "panel.vala"
	_g_free0 (icon_name);
#line 10880 "panel.c"
}

void
panel_set_wayland_object_path (Panel* self,
                               const gchar* object_path)
{
	gchar* _tmp0_;
#line 2040 "panel.vala"
	g_return_if_fail (self != NULL);
#line 2041 "panel.vala"
	_tmp0_ = g_strdup (object_path);
#line 2041 "panel.vala"
	_g_free0 (self->priv->m_wayland_object_path);
#line 2041 "panel.vala"
	self->priv->m_wayland_object_path = _tmp0_;
#line 10896 "panel.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "panel.vala"
	g_return_if_fail (n_param_values == 4);
#line 24 "panel.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "panel.vala"
		data1 = closure->data;
#line 24 "panel.vala"
		data2 = param_values->data[0].v_pointer;
#line 10921 "panel.c"
	} else {
#line 24 "panel.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "panel.vala"
		data2 = closure->data;
#line 10927 "panel.c"
	}
#line 24 "panel.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 24 "panel.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 10933 "panel.c"
}

static void
panel_class_init (PanelClass * klass,
                  gpointer klass_data)
{
#line 24 "panel.vala"
	panel_parent_class = g_type_class_peek_parent (klass);
#line 24 "panel.vala"
	g_type_class_adjust_private_offset (klass, &Panel_private_offset);
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_cursor_location = (void (*) (IBusPanelService*, gint, gint, gint, gint)) panel_real_set_cursor_location;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_in = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_in;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_out = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_out;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->destroy_context = (void (*) (IBusPanelService*, const gchar*)) panel_real_destroy_context;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->register_properties = (void (*) (IBusPanelService*, IBusPropList*)) panel_real_register_properties;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_property = (void (*) (IBusPanelService*, IBusProperty*)) panel_real_update_property;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_preedit_text = (void (*) (IBusPanelService*, IBusText*, guint, gboolean)) panel_real_update_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_preedit_text = (void (*) (IBusPanelService*)) panel_real_hide_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_auxiliary_text = (void (*) (IBusPanelService*, IBusText*, gboolean)) panel_real_update_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_auxiliary_text = (void (*) (IBusPanelService*)) panel_real_hide_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_lookup_table = (void (*) (IBusPanelService*, IBusLookupTable*, gboolean)) panel_real_update_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_lookup_table = (void (*) (IBusPanelService*)) panel_real_hide_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_content_type = (void (*) (IBusPanelService*, guint, guint)) panel_real_set_content_type;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->state_changed = (void (*) (IBusPanelService*)) panel_real_state_changed;
#line 24 "panel.vala"
	G_OBJECT_CLASS (klass)->finalize = panel_finalize;
#line 24 "panel.vala"
	panel_signals[PANEL_REALIZE_SURFACE_SIGNAL] = g_signal_new ("realize-surface", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 24 "panel.vala"
	panel_signals[PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL] = g_signal_new ("update-shortcut-keys", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT_ENUM, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_INT, BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE);
#line 10978 "panel.c"
}

static void
panel_instance_init (Panel * self,
                     gpointer klass)
{
	IBusEngineDesc** _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	XKBLayout* _tmp13_;
	gchar* _tmp14_;
#line 24 "panel.vala"
	self->priv = panel_get_instance_private (self);
#line 32 "panel.vala"
	self->priv->m_settings_general = NULL;
#line 33 "panel.vala"
	self->priv->m_settings_hotkey = NULL;
#line 34 "panel.vala"
	self->priv->m_settings_panel = NULL;
#line 35 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_STATUS_ICON;
#line 38 "panel.vala"
	self->priv->m_indicator_show_status = INDICATOR_STATUS_ACTIVE;
#line 43 "panel.vala"
	_tmp0_ = g_new0 (IBusEngineDesc*, 0 + 1);
#line 43 "panel.vala"
	self->priv->m_engines = _tmp0_;
#line 43 "panel.vala"
	self->priv->m_engines_length1 = 0;
#line 43 "panel.vala"
	self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 44 "panel.vala"
	_tmp1_ = g_str_hash;
#line 44 "panel.vala"
	_tmp2_ = g_str_equal;
#line 44 "panel.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 44 "panel.vala"
	self->priv->m_engine_contexts = _tmp3_;
#line 47 "panel.vala"
	_tmp4_ = g_strdup ("");
#line 47 "panel.vala"
	self->priv->m_current_context_path = _tmp4_;
#line 48 "panel.vala"
	_tmp5_ = g_strdup ("");
#line 48 "panel.vala"
	self->priv->m_real_current_context_path = _tmp5_;
#line 49 "panel.vala"
	self->priv->m_use_global_engine = TRUE;
#line 50 "panel.vala"
	self->priv->m_use_engine_lang = TRUE;
#line 60 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 63 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 66 "panel.vala"
	self->priv->m_switcher_delay_time = 400;
#line 67 "panel.vala"
	self->priv->m_use_system_keyboard_layout = FALSE;
#line 68 "panel.vala"
	_tmp6_ = g_str_hash;
#line 68 "panel.vala"
	_tmp7_ = g_str_equal;
#line 68 "panel.vala"
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_object_unref0_);
#line 68 "panel.vala"
	self->priv->m_xkb_icon_pixbufs = _tmp8_;
#line 71 "panel.vala"
	_tmp9_ = g_str_hash;
#line 71 "panel.vala"
	_tmp10_ = g_str_equal;
#line 71 "panel.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _cairo_surface_destroy0_);
#line 71 "panel.vala"
	self->priv->m_xkb_icon_image = _tmp11_;
#line 74 "panel.vala"
	memset (&_tmp12_, 0, sizeof (GdkRGBA));
#line 74 "panel.vala"
	_tmp12_.red = 0.0;
#line 74 "panel.vala"
	_tmp12_.green = 0.0;
#line 74 "panel.vala"
	_tmp12_.blue = 0.0;
#line 74 "panel.vala"
	_tmp12_.alpha = 1.0;
#line 74 "panel.vala"
	self->priv->m_xkb_icon_rgba = _tmp12_;
#line 76 "panel.vala"
	_tmp13_ = xkb_layout_new ();
#line 76 "panel.vala"
	self->priv->m_xkblayout = _tmp13_;
#line 77 "panel.vala"
	self->priv->inited_engines_order = TRUE;
#line 80 "panel.vala"
	_tmp14_ = g_strdup ("");
#line 80 "panel.vala"
	self->priv->m_icon_prop_key = _tmp14_;
#line 81 "panel.vala"
	self->priv->m_property_icon_delay_time = 500;
#line 83 "panel.vala"
	self->priv->m_menu_update_delay_time = (guint) 100;
#line 97 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 11092 "panel.c"
}

static void
panel_finalize (GObject * obj)
{
	Panel * self;
	Indicator* _tmp0_;
	GList* _tmp2_;
#line 24 "panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PANEL, Panel);
#line 167 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 167 "panel.vala"
	if (_tmp0_ != NULL) {
#line 11107 "panel.c"
		Indicator* _tmp1_;
#line 168 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 168 "panel.vala"
		indicator_unregister_connection (_tmp1_);
#line 11113 "panel.c"
	}
#line 170 "panel.vala"
	_tmp2_ = self->priv->m_keybindings;
#line 170 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp2_);
#line 172 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 172 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 31 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 32 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 33 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 34 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 37 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 40 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 41 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 42 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 43 "panel.vala"
	self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 44 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_engine_contexts);
#line 47 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 48 "panel.vala"
	_g_free0 (self->priv->m_real_current_context_path);
#line 51 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 52 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel_active);
#line 53 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 54 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher_active);
#line 56 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel_x11);
#line 57 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher_x11);
#line 61 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 62 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 64 "panel.vala"
	_g_object_unref0 (self->priv->m_about_dialog);
#line 65 "panel.vala"
	_g_object_unref0 (self->priv->m_css_provider);
#line 68 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_pixbufs);
#line 71 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_image);
#line 76 "panel.vala"
	_xkb_layout_unref0 (self->priv->m_xkblayout);
#line 80 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 97 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 101 "panel.vala"
	_g_free0 (self->priv->m_wayland_object_path);
#line 24 "panel.vala"
	G_OBJECT_CLASS (panel_parent_class)->finalize (obj);
#line 11181 "panel.c"
}

static GType
panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Panel), 0, (GInstanceInitFunc) panel_instance_init, NULL };
	GType panel_type_id;
	panel_type_id = g_type_register_static (ibus_panel_service_get_type (), "Panel", &g_define_type_info, 0);
	Panel_private_offset = g_type_add_instance_private (panel_type_id, sizeof (PanelPrivate));
	return panel_type_id;
}

GType
panel_get_type (void)
{
	static volatile gsize panel_type_id__once = 0;
	if (g_once_init_enter (&panel_type_id__once)) {
		GType panel_type_id;
		panel_type_id = panel_get_type_once ();
		g_once_init_leave (&panel_type_id__once, panel_type_id);
	}
	return panel_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 11213 "panel.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 11221 "panel.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 11236 "panel.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 11250 "panel.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 11255 "panel.c"
}

